Package: TH.data
Title: TH's Data Archive
Date: 2025-01-17
Version: 1.1-3
Authors@R: c(person("Torsten", "Hothorn", role = c("aut", "cre"),
                    email = "Torsten.Hothorn@R-project.org"))
Description: Contains data sets used in other packages Torsten Hothorn
  maintains.
Depends: R (>= 3.5.0), survival, MASS
Suggests: trtf, tram, rms, coin, ATR, multcomp, gridExtra, vcd,
        colorspace, lattice, knitr
LazyData: yes
VignetteBuilder: knitr
License: GPL-3
NeedsCompilation: no
Packaged: 2025-01-17 14:47:14 UTC; hothorn
Author: Torsten Hothorn [aut, cre]
Maintainer: Torsten Hothorn <Torsten.Hothorn@R-project.org>
Repository: CRAN
Date/Publication: 2025-01-17 18:20:02 UTC
Built: R 4.4.0; ; 2026-07-18 04:53:20 UTC; unix

Package: TH.data
Title: TH's Data Archive
Date: 2025-11-17
Version: 1.1-5
Authors@R: c(person("Torsten", "Hothorn", role = c("aut", "cre"),
                    email = "Torsten.Hothorn@R-project.org"))
Description: Contains data sets used in other packages Torsten Hothorn
  maintains.
Depends: R (>= 3.5.0), survival, MASS
Suggests: trtf, tram, rms, coin, ATR, multcomp, gridExtra, vcd,
        colorspace, lattice, knitr, dplyr, openxlsx, plyr
LazyData: yes
VignetteBuilder: knitr
License: GPL-3
NeedsCompilation: no
Packaged: 2025-11-17 15:44:06 UTC; hothorn
Author: Torsten Hothorn [aut, cre]
Maintainer: Torsten Hothorn <Torsten.Hothorn@R-project.org>
Repository: CRAN
Date/Publication: 2025-11-17 16:50:08 UTC

# Default NAMESPACE created by R
# Remove the previous line if you edit this file

# Export all names
exportPattern("^[^.]")

# Import all packages listed as Imports or Depends
import(
  survival,
  MASS
)

**********************************************************************
*
*  Reproducibility Information for
*
*  Spatio-Phylogenetic Multi-Species Distribution Models
*  by A. Kaldhusdal, R. Brandl, J. Mueller, L. Moest and T. Hothorn
*
**********************************************************************

Content

### bird data
data/birdsData.Rdata

### analysis of bird data
analysis_birdData/
mBirdsESM1_2.R  mBirdsESM3_2.R

### PSGLMM R code
R/
makeData.R  makeEnvir.R  psglmm.R  psglmmSim.R

### simulation study
simulationStudy/
simModel11bin.R   simModel12.R      simModel21pois.R  simModel23bin.R
simModel11pois.R  simModel13bin.R   simModel21.R      simModel23pois.R
simModel11.R      simModel13pois.R  simModel22bin.R   simModel23.R
simModel12bin.R   simModel13.R      simModel22pois.R
simModel12pois.R  simModel21bin.R   simModel22.R

Description

A PSGLMM may be fitted by calling the main function psglmm(). This function 
utilises the functions lmer() (for Gaussian responses) or glmer() (for binary or
Poisson responses) from the lme4 package, but with a twist. Instead of having 
the covariance structure in the data estimated by the function, psglmm() 
requires the user to provide an assumption for this in advance, which is then 
incorporated into the estimation procedure. The covariance structure is passed 
to the function as a list containing one element per random effect component in
the model. 

A formula is passed to the function in the known mixed model (lme4) form, e.g.
  y ~ spp - 1 + (spp - 1 | plot).
With spp being a factor expressing to which species an observation belongs and
plot expressing to which plot the observation was made, the above model assumes
a fixed effect for each species and a random effect in the plots for each 
species. At this stage psglmm() is merely an extension of (g)lmer() for which 
the covariance structure may be assumed to be known.

If several possible covariance structures are plausible, psglmm() also allows us
to test which of these is best fitted to the data. In doing this we pass one
random effect component for each covariance structure to be tested, e.g.:
  y ~ spp - 1 + (spp - 1 | plot) + (spp - 1 | plot).
With A_ind being a unity matrix with a size equal to the number of species,
A_phylo being a phylogenetic correlation matrix for the species and B being
a correlation matrix expressing the spatial dependency of the plots, we would
pass the following list of covariance matrices (VCV) to the function (naming
the list elements eases the interpretation of the model output):
  list("independence"= kronecker(B, A_ind), "phylogeny"= kronecker(B, A_phylo)).
To perform the model selection, the argument msel must be utilised. The model
selection procedure performs a predictive cross-validation and offers three
different proper scoring rules for this task: LS or DSS for Gaussian responses, 
BS or LS for binary responses and DSS for Poisson responses.



psglmm() first calls (g)lFormula() (lme4) to set up the needed model objects. 
These are then modified using several helper functions before they are passed to 
the lme4 fitting algorithms. These helper functions are briefly described in the 
following:
- As lmer() is only allowed to fit less random effects than there are 
  observations and the above mentioned formulas assume one random effect for 
  each observation, we apply the code in lines 301-350 (see psglmm.R) to disable 
  this limitation. Without executing this code a Gaussian model of the above 
  form cannot be fitted.
- adaptFormula() is used to ensure that the order of the random effect 
  components in the formula passed on to the lme4 fitting algorithms is indeed
  the same as in the formula passed to psglmm() by the user.
- randomTerms() is used to set up the random effect terms using the provided
  covariance structures.

- makeVARALL() simply sets up a data.frame for the model results.
- modelSelection() is the function which is called if an automated model 
  selection is wanted (argument msel set to TRUE in psglmm()). The function in 
  turn calls the helper functions pred.xval() in which the predictive cross-
  validation is performed. It also allows for an LR test to be performed to test 
  if the variance estimates for the covariance components are > 0 (because of 
  the issues concerning the testing of variance parameters on the boundary of 
  their parameter space, the calculated p-value should not be overly 
  interpreted).
- LR.test() performs the mentioned LR test.
- pred.xval() is the function in which the predictive cross-validation is
  actually performed. The function is based on the algorithm outlined by Braun 
  et. al (2013). The iterated weighted least squares algorithm is hard coded to 
  abort if no convergence is achieved within 10000 iterations. If this happens, 
  or if any other numerical issue arises, the model selection is aborted, but 
  the model fitting is continued. A corresponding warning is displayed in the 
  model output. Depending on which proper scoring rule is chosen by the user
  (argument msel passed to psglmm()), one of the following helper functions is
  called:
- BS(), DSS(), LS() incorporate the three proper scoring rules "Brier Score",
  "Dawid-Sebastiani Score" and "Logarithmic Score".
The following helper functions are used to simplify the calculation of some 
tasks, which were performed often and thus save some space and make the code a
little easier to read:
- nuniq() returns the number of unique elements in a vector.
- equal() checks if all elements of a vector are identical.
- IFELSE() works like ifelse() but allows for the objects to be returned in 
  either case to be of different classes.
- makePolys() actually didn't find any use in the final version of the paper, 
  but is practical for setting up the polygons of the plots when displaying 
  the estimated values from the model.


The results can be reproduced using the following package versions:

lme4 version 1.0-0 (from R-forge), 1.1-6 from CRAN
Matrix version 1.1-4
fields version 6.8
mvtnorm version 0.9-9995
picante version 1.6-2
ggplot2 version 1.0.0

rm(list= ls())

# Load packages, sources and data
library("ape")
library("lme4")
library("fields")
source("../R/psglmm.R")
load(file.path(path.package(package = "TH.data"), "rda", "birdsData.rda"))

# closely related species
spp <- c("Poecile montanus", "Periparus ater", "Lophophanes cristatus", "Poecile palustris", "Parus major", "Cyanistes caeruleus")

# Environmental factors
env <- names(birdsData$data)[(grep("^y$", names(birdsData$data)) + 1):ncol(birdsData$data)]

# Data are subsetted
d <- birdsData$data[as.character(birdsData$data$spp) %in% spp,]
d$spp <- factor(d$spp)

# Spatial correlation matrix
P <- as(Matern(birdsData$dist), "dgCMatrix")
P[P < 0.05] <- 0 # P is not pos. def. if limit 0.1 is used

# Number of species and plots
s <- length(spp)
p <- nrow(P)

# Identity matrices for species and plots
Is <- as(diag(s), "dgCMatrix")
Ip <- as(diag(p), "dgCMatrix")

# Species correlation matrix
S <- birdsData$phylo$cor[spp, spp]
Sinv <- solve(S)

# Variance-covariance matrices
VCV <- list("independent"= kronecker(Ip, Is), "spatial"= kronecker(P, Is), 
  "phylogeneticA"= kronecker(Ip, S), "spatio-phylogeneticA"= kronecker(P, S), 
  "phylogeneticR"= kronecker(Ip, Sinv), "spatio-phylogeneticR"= kronecker(P, Sinv))

for(X in env) {
  D <- d
  D$x <- D[, X]
  mBirds <- try(psglmm(y ~ spp - 1 + spp:x + (x - 1 | plot:spp) + 
    (x - 1 | plot:spp) + (x - 1 | plot:spp) +  (x - 1 | plot:spp) + 
    (x - 1 | plot:spp) + (x - 1 | plot:spp), 
    VCV = VCV, data= D, rd= 5, family= poisson(), msel= "DSS", msgs= TRUE), silent= TRUE)
  cat(paste(X, ":\n", sep= ""))
  try(print(mBirds$varall), silent= TRUE)
  try(print(mBirds$varsel), silent= TRUE)
  save(mBirds, file= paste("mBirdsESM_2_", i, "_", X, ".Rdata", sep= ""))
}

## Function to fit a phylogenetic and spatial (generalised) linear mixed model
##   (PSGLMM) in which the desgin matrices of the random effects are penalised
##   using a known group correlation/covariance structure.
##
## Required by:
## Depends on: Packages lme4 and Matrix,
##             Formulas adaptFormula(), randomTerms(), makeVARALL() and
##             modelSelection() found in 'support.R'
##             The function lformula() from lme4 needs to be modified in 
##             accordance with the file 'lFormula_tweak.R'
## Arguments:
## ----------
## formula: A linear formula as used by '(g)lmer' in package 'lme4'.
## VCV:     A list of covariance/correlation matrices (preferably named) with 
##          wich the design matrices of the random effects are to be penalised. 
##          The list must contain one element per random effect and in the same 
##          order as the random effects in 'formula'. If a random effect 
##          shouldn't be penalised, 'NULL' is used in its corresponding place in
##          'VCV'. The dimensions of the penalty matrices must match the
##          dimensions of the design matrices.
## data:    A data frame containing the variables named in 'formula'. The 'data'
##          argument is not optional.
## family:  Error distribution and link function to be used in the model. This
##          has to be a family function. Only 'gaussian()', 'binomial()' and
##          'poisson()' are supported.
## gf:      An optional character vector containing the names of the grouping
##          factors of each random effect.
## rd:      To how many digits the variance estimates should be rounded. Takes
##          the value 'NULL' if no rounding is to be done.
## msel:    The proper scoring rule to be used for predictive cross-validation
##          during model selection. For Gaussian responses the logarithmic score
##          'LS' and the Dawid-Sebastiani score 'DSS' are available, 'DSS' for
##          Poisson responses and 'DSS' or the Brier score 'BS' for binary
##          responses. For 'msel= FALSE' no model selection is performed.
## eps:     The limit underneath which random effects variance estimates are to
##          be considered as zero.
## msgs:    If progress messages should be printed.
## REML:    If parameter estimation for Gaussian responses should be REML (TRUE)
##          or ML (FALSE).
## ...:     Further arguments passed to '(g)lFormula'.
##
## Details:
## --------
## Model selection may only be performed if all random effects components are 
##   penalised.
## The predictive cross-validation is only performed if more than one random
##   effects variance estimate is positive.
## The p value of the estimated variance parameter for the chosen covariance
##   component is only calculated if model selection is selected.
## When model selection is performed, the covariance component with the highest
##   score is marked with '*' in the column 'Selection' in '.$varall'. If only
##   one variance parameter is estimated to be positive, no cross-validation is
##   performed and the selected covariance component is marked with '**'.
##
## Value:
## ------
## A list containing
##   - A fitted object of class 'merMod' or 'glmerMod'
##   - A data frame containing all random effects variance estimates
##   - A data frame containing the random effects variance estimate for the 
##     chosen covariance component if model selection is performed.
##
## See also:
## ---------
## 'lmer', 'glmer'
##
## Examples:
## ---------
## 
##


psglmm <- function(formula, VCV= list(), data, family= gaussian(), gf, rd= NULL,
  msel= FALSE, eps= 1e-5, msgs= TRUE, REML= FALSE, ...) {
  ## Required packages are loaded.
  require("Matrix")
  require("lme4")
  ## Version number for lme4 is checked.
  stopifnot(compareVersion(packageDescription("lme4")$Version, "1.0-0") >= 0)
  
  ## Further checks are made.
  if(length(VCV) == 0 || is.null(unlist(VCV)))
    stop("Use '(g)lmer' if no penalising is wanted.")
  if(!is.list(VCV)) stop("'VCV' must be a list.")
  if(missing(formula)) stop("'formula' must be assigned.")
  if(missing(data)) stop("'data' must be assigned.")
  if(is.character(family)) try(family <- get(family, mode= "function"), TRUE)
  if(is.function(family)) family <- family()
  if(!family[[1]] %in% c("gaussian", "binomial", "poisson"))
    stop("'family' must be 'gaussian', 'binomial' or 'poisson'.")
  if(!is.null(rd) && rd < 0) stop("'rd' must be a positive integer.")
  if(!(msel %in% c(TRUE, FALSE, "BS", "LS", "DSS"))) {
    warning(paste("Selection criterium", msel, 
      "not recognised. No model selection performed."))
    msel <- FALSE
  }
  
  ## Call to psglmm is saved for later use.
  if(msgs) cat("Setting up model\n")
  call <- list(formula= formula, VCV= VCV, data= data, family= family)

  ## Formula and data are changed so that random effects with identical grouping 
  ##   factor are set up with unique grouping factors.
  tmp <- adaptFormula(formula, data)
  formula <- tmp$formula
  data <- tmp$data
  origGF <- tmp$origGF
  f4selection <- tmp$f4selection

  ## Raw model is set up with lme4.
  if(family == "gaussian" || family[[1]] == "gaussian") {
#    tryCatch(source("lFormula_tweak.R"), 
#      error= function(e) print(cat(paste("Function lFormula() needs to be",
#      "modified. Please load the file 'lformula_tweak.R' manually or place it",
#      "in the current working directory.\n"))))
    mtmp <- lFormula(formula= formula, data= data, REML= REML, ...)
  }
  if(family %in% c("binomial", "poisson") || family[[1]] %in% c("binomial", "poisson")) 
    mtmp <- glFormula(formula= formula, data= data, family= family, ...)

  ## The permutation of the order of random effects in 'formula' used by 
  ##   '(g)lFormula' is retrieved ('perm') together with the number of levels of
  ##   the grouping factors ('dims') and an object ('rT') to replace
  ##  'mtmp$reTrms$cnms' later.
  rT <- randomTerms(formula, data, mtmp, VCV)
  nRE <- length(rT$rT) # number of random effects

  VCVn <- names(VCV)[rT$perm] # names of penalties
  if(is.null(VCVn)) {
    VCVn <- as.character(rT$perm)
    names(call$VCV) <- as.character(1:nRE)
  }
  ## List of penalties is permuted to fit the order of the random effects used
  ##   by (g)lFormula.
  VCV <- lapply(rT$perm, function(i) VCV[[i]]) 

  VCVNULL <- sapply(VCV, is.null)
  ## Diagonal matrices are added to 'VCV' for random effects which aren't to
  ##   be penalised.
  if(any(VCVNULL)) for(i in which(VCVNULL)) {
    VCV[[i]] <- as(diag(rT$dims[i]), "dgCMatrix")
  }

  ## A check is made, if the dimensions of the penalty matrices match the 
  ##   dimensions of the random effects.
  VCVdims <- sapply(VCV, nrow)
  if(!all(VCVdims == rT$dims)) {
    tmp <- which(VCVdims != rT$dims)
    tmp <- if(is.null(VCVn)) tmp else VCVn[tmp]
    stop(paste("Dimension of elements", 
      paste("'",tmp,"'", sep= "", collapse= ", "), "don't match dimensions of",
      "design matrices."))
  }
  ## Cholesky factors of all penalty matrices are saved in a list.
  CFl <- lapply(1:nRE, function(i) t(chol(VCV[[i]])))

  ## The Cholesky factors in 'CFl' are put together into a matrix containing all
  ##   Cholesky factors in the right order on its "diagonals".
  CF <- bdiag(CFl)
  ## A new 'Zt' matrix is calculated, which will replace 'mtmp$reTrms$Zt'.
  ## The old 'mtmp$reTrms$Zt' is penalised with 'CF'. 
  newZt <- t(crossprod(mtmp$reTrms$Zt, CF))

  ## New 'theta', 'lower' and 'Lind' vectors are calculated, for convenience
  ##   this is done as lists.
  tmp.cnms <- sapply(1:nRE, function(i) sum(1:length(mtmp$reTrms$cnms[[i]])))
  tmp.rT <- sapply(1:nRE, function(i) sum(1:length(rT$rT[[i]])))
  newtheta <- newlower <- vector("list", nRE)
  ## Calculations for first random effect outside of loop.
  newtheta[[1]] <- mtmp$reTrms$theta[1:cumsum(tmp.cnms)[1]]
  newlower[[1]] <- mtmp$reTrms$lower[1:cumsum(tmp.cnms)[1]]
  ## For all subsequent random effects calculations are made.
  if(nRE > 1) for(i in 2:nRE) {
    elem.cnms <- (cumsum(tmp.cnms)[(i - 1)] + 1):(cumsum(tmp.cnms)[i])
    newtheta[[i]] <- mtmp$reTrms$theta[elem.cnms]
    newlower[[i]] <- mtmp$reTrms$lower[elem.cnms]
  }
  ## Elements of 'newtheta' and 'newlower' belonging to penalised random effects
  ##   are set to 1 and 0 respectively, as only one variance parameter should be
  ##   estimated for these.
  for(i in which(!VCVNULL)) {
    newtheta[[i]] <- 1
    newlower[[i]] <- 0
  }
  newtheta <- unlist(newtheta)
  newlower <- unlist(newlower)
  ## A new 'Lind' vector is calculated.
  newLind <- vector("list", nRE)
  for(i in 1:nRE) {
    nSquare <- (-1 + sqrt(1 + 8 * tmp.rT[i])) / 2
    nElem <- cumsum(tmp.rT)[i]
    tmp <- sapply(1:nSquare, 
      function(i) {
        (1:nElem)[(1+c(0, cumsum(nSquare:1))[i]):(c(0, cumsum(nSquare:1))[i] + 
          (nSquare - i + 1))]
      })
    tmp <- t(sapply(1:nSquare, 
      function(i) c(rep(0, nSquare - length(tmp[[i]])), tmp[[i]])))
    tmp <- as.vector(tmp)
    tmp <- tmp[tmp != 0]
    tmp <- tmp + c(0, cumsum(tmp.rT))[i]
    newLind[[i]] <- rep(tmp, rT$dims[i] / length(rT$rT[[i]]))
  }
  newLind <- unlist(newLind)

  ## If all random effects are penalised, 'mtmp$reTrms$Lambdat' is replaced by a 
  ##   diagonal matrix. This is also the case if the original matrix is already
  ##   a diagonal matrix. If any of the random effects should not be penalised,
  ##   and a non-diagonal structure of 'mtmp$reTrms$Lambdat' thus needs to be
  ##   kept, the new matrix has to be constructed manually, as it will
  ##   (probably) contain zeros as 'non-zero' elements. 
  newLambdat <- Matrix(0, nrow(newZt), nrow(newZt), sparse= TRUE)
  newLambdat <- as(newLambdat, "dgCMatrix")
  diag(newLambdat) <- rep(1, nrow(newZt))
  if(!(all(!VCVNULL) || 
    (length(mtmp$reTrms$Lambdat@x) == nrow(mtmp$reTrms$Lambdat) && 
    all(mtmp$reTrms$Lambdat@x == 1)))) {
    tmpi <- tmpp <- tmpx <- vector("list", nRE)
    for(i in 1:nRE) {
      levelsi <- length(rT$rT[[i]])
      reps <- rT$dims[[i]] / levelsi
      tmpp[[i]] <- cumsum(rep(1:levelsi, reps))
      # number of indices in tmpp[[i-1] is added to the indices in tmpp[[i]]
      if(i == 1) tmpp[[i]] <- c(0, tmpp[[i]]) else {
        tmpp[[i]] <- tmpp[[i]] + tmpp[[i - 1]][length(tmpp[[i - 1]])]
      }
      tmp <- unlist(sapply(1:levelsi, 
        function(j) 1:((1:levelsi)[j])))
      tmpi[[i]] <- rep(tmp, reps) + 
        rep(seq(0, rT$dims[[i]] - levelsi, by= levelsi), each= length(tmp)) - 1
      tmpx[[i]] <- rep(unlist(sapply(1:levelsi, function(i) which(tmp==i))), 
        reps) + 
        rep(seq(0, (reps - 1) * length(tmp), by= length(tmp)), 
        each= length(tmp))
      if(i > 1) {
        tmpi[[i]] <- tmpi[[i]] + tmpi[[i - 1]][length(tmpi[[i - 1]])] + 1
        tmpx[[i]] <- tmpx[[i]] + tmpx[[i - 1]][length(tmpx[[i - 1]])]
      }
    }
    newLambdat@i <- as.integer(unlist(tmpi))
    newLambdat@p <- as.integer(unlist(tmpp))
    newLambdat@x[unlist(tmpx)] <- newtheta[newLind]
    if(!.validateCsparse(newLambdat)) stop("Error in creating newLambdat.")
  }

  ## Old vectors are replaced by new ones.
  mtmp$reTrms$Zt <- newZt
  mtmp$reTrms$theta <- newtheta
  mtmp$reTrms$lower <- newlower
  mtmp$reTrms$Lambdat <- newLambdat
  mtmp$reTrms$Lind <- newLind
  mtmp$reTrms$cnms <- rT$rT

  # Manually changed models are fitted using lme4.
  if(msgs) cat("Fitting model\n")
  if(family[[1]] == "gaussian") {
    devfun <- do.call(mkLmerDevfun, mtmp)
    opt <- optimizeLmer(devfun)
    m <- mkMerMod(environment(devfun), opt, mtmp$reTrms, fr= mtmp$fr)
  }
  if(family %in% c("binomial", "poisson") || 
    family[[1]] %in% c("binomial", "poisson")) {
    devfun <- do.call(mkGlmerDevfun, mtmp)
    opt <- optimizeGlmer(devfun)
    # Fehler: zwei Zeilen eingefuegt am 10.10.
    devfun <- updateGlmerDevfun(devfun, mtmp$reTrms)
    opt <- optimizeGlmer(devfun, stage= 2)
    m <- mkMerMod(environment(devfun), opt, mtmp$reTrms, fr= mtmp$fr)
  }
  ## Data frames with results for random effects variance estimates are set up.
  varout <- list("varall"= makeVARALL(nRE, rT, origGF, VCVn, m, family, rd),
    "varsel"= NULL)
  ## Model selection
  if(msel != FALSE && all(!VCVNULL)) {
    if(missing(gf)) {
      gf <- varout$varall$Groups[!(varout$varall$Groups %in% c("", "Residual"))]
      if(length(grep(":", gf)) > 0) {
        tmp <- strsplit(gf[grep(":", gf)], ":")
        gf[grep(":", gf)] <- sapply(1:length(tmp), function(j) tmp[[j]][[1]])
      }
    }
    varout <- modelSelection(msel, varout, nRE, f4selection, call, family, gf, 
      eps, msgs, rd)
  } else {
    if(msel != FALSE && any(VCVNULL)) {
      cat(paste("Model selection may only be done if all elements of 'VCV' are",
        "penalised\n"))
    }
  }
  return(list(modorig= m, varsel= varout$varsel, varall= varout$varall, 
    modsel= varout$modsel))
}


################################################################################
## SUPPORTING FUNCTIONS
################################################################################

## Changes the formula lFormula from lme4 to allow Gaussian models to be fitted
##   with the number of random effects equal to the number of observations. 
require("lme4")
assignInNamespace(x= "lFormula", 
  value= 
  lFormula <- function (formula, data = NULL, REML = TRUE, subset, weights, 
    na.action, offset, contrasts = NULL, control = lmerControl(), 
    ...) {
  control <- control$checkControl
  mf <- mc <- match.call()
  ignoreArgs <- c("start", "verbose", "devFunOnly", "control")
  l... <- list(...)
  l... <- l...[!names(l...) %in% ignoreArgs]
  do.call(lme4:::checkArgs, c(list("lmer"), l...))
  if (!is.null(list(...)[["family"]])) {
      mc[[1]] <- quote(lme4::glFormula)
      if (missing(control)) 
          mc[["control"]] <- glmerControl()
      return(eval(mc, parent.frame()))
  }
  denv <- lme4:::checkFormulaData(formula, data)
  mc$formula <- formula <- as.formula(formula, env = denv)
  m <- match(c("data", "subset", "weights", "na.action", "offset"), 
      names(mf), 0)
  mf <- mf[c(1, m)]
  mf$drop.unused.levels <- TRUE
  mf[[1]] <- as.name("model.frame")
  fr.form <- subbars(formula)
  environment(fr.form) <- environment(formula)
  mf$formula <- fr.form
  fr <- eval(mf, parent.frame())
  attr(fr, "formula") <- formula
  attr(fr, "offset") <- mf$offset
  n <- nrow(fr)
  reTrms <- mkReTrms(findbars(formula[[3]]), fr)
#  checkNlevels(reTrms$flist, n = n, control)
#  checkZrank(reTrms$Zt, n = n, control, nonSmall = 1e+06)
  fixedform <- formula
  fixedform[[3]] <- if (is.null(nb <- nobars(fixedform[[3]]))) 
      1
  else nb
  mf$formula <- fixedform
  fixedfr <- eval(mf, parent.frame())
  attr(attr(fr, "terms"), "predvars.fixed") <- attr(attr(fixedfr, 
      "terms"), "predvars")
  X <- model.matrix(fixedform, fr, contrasts)
  p <- ncol(X)
  if ((rankX <- rankMatrix(X)) < p) 
      stop(gettextf("rank of X = %d < ncol(X) = %d", rankX, 
          p))
  list(fr = fr, X = X, reTrms = reTrms, REML = REML, formula = formula)
}, ns= "lme4")


################################################################################
## Model set up
################################################################################

## (g)lFormula() may change the order of the random effects compared to how they
##   are passed to the function. To be able to separate random effects with the
##   same grouping factor, this function makes a new grouping factor for each
##   of these random effects, simply adding a number in ascending order to the
##   original name of the grouping factor. The data and formula are changed
##   accordingly.
## Required by: psglmm()
## Depends on: nuniq()
##
## Arguments:
## ----------
## formula: A formula from which to extract the random terms, as passed to
##          psglmm().
## data:    data.frame as passed to psglmm().
##
## Returns: A list containing the new formula and data set using the new
##          grouping factor names, the original grouping factor names and a
##          processed form of the formula to be ud for model selection.
adaptFormula <- function(formula, data) {
  terms <- unlist(strsplit(as.character(formula)[3], " + ", fixed= TRUE))
  iRE <- grep("^\\(", terms)
  f4selection <- list("y"= as.character(formula)[2], 
    "fe"= terms[setdiff(1:length(terms), iRE)], "re"= terms[iRE])
  nRE <- length(iRE)
  termsRE <- terms[iRE]
  lastGF <- sapply(1:nRE, function(i) {
    rev(unlist(strsplit(gsub("^.+ [|] ([a-zA-Z0-9_.]+)[:]*([a-zA-Z0-9_.]*)\\)$", 
    "\\1 \\2", termsRE[i]), " ")))[1]
  })
  if(length(lastGF) != nuniq(lastGF)) {
    # how many times was the lastGF used (including its own use)
    lastGFsuffix <- gsub("1", "", 
      sapply(1:nRE, function(i) sum(lastGF[1:i] == lastGF[i])))
    lastGFnew <- vector("character", nRE)
    for(i in 1:nRE) {
      lastGFnew[i] <- paste(lastGF[i], lastGFsuffix[i], sep= "")
    }
    # new terms replace old
    termsRE <- sapply(1:nRE, 
      function(i) gsub(lastGF[i], lastGFnew[i], termsRE[i]))
    terms[iRE] <- termsRE
    formula <- as.formula(paste(formula[[2]], formula[[1]], 
      paste(terms, collapse= "+")))

    for(i in which(lastGFsuffix != "")) {
      data[, lastGFnew[i]] <- data[, lastGF[i]]
    }
  }
  return(list(formula= formula, data= data, origGF= lastGF, 
    f4selection= f4selection))
}


## Function for extracting the random effect variables and their grouping 
##   factors from a formula. 
## Required by: psglmm()
## Depends on: nuniq()
## 
## Arguments:
## ----------
## formula: A formula from which to extract the random terms, as passed to
##          psglmm().
## data:    data.frame as passed to psglmm().
## mtmp:    Element of class 'merMod' or 'glmerMod'.
## VCV:     List of Penalties for random effects as passed to psglmm().
##
## Returns: A list containing a list ('rT') which is similar to the 
##   '.$reTRms$cnms' element from a call to lFormula(), containing the levels of
##   all random effects names according to their grouping factors. It also 
##   contains a vector 'perm' containing the permutation of the order of the 
##   random effects from 'formula' as they are used by (g)lmer() and a vector 
##   'dims' containing the number of levels of the grouping factor of each
##   random effect.
randomTerms <- function(formula, data, mtmp, VCV) {
  allTerms <- strsplit(attr(terms(formula), "term.labels"), " ")
  iRandom <- which(sapply(1:length(allTerms), function(i) "|" %in% allTerms[[i]]))
  if(length(iRandom) == 0) stop("'formula' contains no random effects")
  randomTerms <- lapply(iRandom, function(i) allTerms[[i]])
  nRE <- length(randomTerms)
  rT <- vector("list", nRE)  
  for(i in 1:nRE) {
    names(rT)[i] <- randomTerms[[i]][length(randomTerms[[i]])]
    RE <- setdiff(randomTerms[[i]], c("|", "+", "-", "0", "1", names(rT)[i]))
    if(is.factor(data[, RE])) {
      rT[[i]] <- paste(RE, levels(data[, RE]), sep= "")
    } else {
      if(!(all(c("0", "+") %in% randomTerms[[i]]) || 
        all(c("-", "1") %in% randomTerms[[i]]))) {
        rT[[i]] <- c("(Intercept)", RE)
      } else rT[[i]] <- RE
    }
    if(length(RE) != 0 && !(all(c("-", "1") %in% randomTerms[[i]]) || 
      all(c("0", "+") %in% randomTerms[[i]])) && is.factor(data[, RE])) {
      rT[[i]][1] <- "(Intercept)"
    }
    if(length(RE) == 0) rT[[i]] <- "(Intercept)"
  }
  perm <- vector("numeric", nRE)
  for(i in 1:nRE) {
    perm[i] <- which(sapply(1:nRE, 
      function(j) {
        names(rT)[j] == names(mtmp$reTrms$cnms)[i] && 
        all(rT[[j]] == mtmp$reTrms$cnms[[i]])
      }))
  }
  tmp <- strsplit(names(mtmp$reTrms$cnms), ":")
  dims= vector("numeric", nRE)
  for(i in 1:nRE) {
    dims[i] <- prod(sapply(1:length(tmp[[i]]), 
      function(j) nuniq(data[, tmp[[i]][j]]))) * length(mtmp$reTrms$cnms[[i]])
  }
  if(length(VCV) != nRE) stop("'VCV' must contain one element per random effect.")
  VCVNULL <- sapply(VCV, is.null)
  for(i in which(!VCVNULL & sapply(1:nRE, function(i) length(rT[[i]])) > 1)) {
    RE <- setdiff(randomTerms[[i]], c("|", "+", "-", "0", "1", names(rT)[i]))
    if(!is.factor(data[, RE]) && rT[[i]][1] == "(Intercept)") 
      stop(paste("Penalising random effects for continous variables with ",
      "intercept is not implemented. Remove intercept using '(", RE, " - 1 | ", 
      names(rT)[i], ")' or remove penalty for this random effect.", sep= ""))
    rT[[i]] <- RE
  }
  rT <- lapply(perm, function(i) rT[[i]])
  names(rT) <- names(mtmp$reTrms$cnms)
  return(list(rT= rT, perm= perm, dims= dims))
}


## Function to prepare random effects variance estimates.
## Required by: psglmm()
## Depends on: 
##
## Arguments:
## ----------
## nRE:    The number of random effects in model.
## rT:     A list 'rT' with data for the random terms as returned by the 
##         function randomTerms().
## origGF: Names of the grouping factors of each random effect as passed to
##         psglmm().
## VCVn:   The names of the random effects penalties as passed to psglmm() in 
##         the list VCV.
## m:      A fitted 'merMod' or 'glmerMod' object.
## family: Family of responses.
## rd:     Number of digits to round to.
##
## Returns: A list of two data.frames: one for the variance estimates of all
##          random effects and one for the selected random effect if model 
##          selection is performed.
makeVARALL <- function(nRE, rT, origGF, VCVn, m, family, rd) {
  RE <- as.data.frame(matrix(NA, sum(sapply(1:nRE, 
    function(i) length(rT$rT[[i]]))), 5, 
    dimnames= list(c(), c("Groups", "Name", "Penalty", "Variance", "Std.Dev"))))
  RE$Groups <- unlist(sapply(1:nRE,
    function(i) {
      c(origGF[i], c(rep("", length(rT$rT[[rT$perm[i]]]) - 1)))
    }))
  RE$Name <- unlist(sapply(order(rT$perm), function(i) rT$rT[[i]]))
  RE$Penalty <- unlist(sapply(rT$perm,
    function(i) c(VCVn[i], c(rep("", length(rT$rT[[rT$perm[i]]]) - 1)))))
  RE$Variance <- unlist(sapply(order(rT$perm),
    function(i) {
      sapply(1:length(rT$rT[[i]]), function(j) VarCorr(m)[[i]][j, j])
    }))
  RE$Std.Dev <- unlist(sapply(order(rT$perm), 
    function(i) {
      sapply(1:length(rT$rT[[i]]), 
      function(j) attributes(VarCorr(m)[[i]])$stddev[j])
    }))
  if(family[[1]] == "gaussian") {
    REresid <- data.frame("Residual", "", "", attr(VarCorr(m), "sc")^2, 
      attr(VarCorr(m), "sc"))
    colnames(REresid) <- colnames(RE)
    RE <- rbind(RE, REresid)
  }
  if(!is.null(rd)) {
    RE$Variance <- round(RE$Variance, rd)
    RE$Std.Dev <- round(RE$Std.Dev, rd)
  }
  return(RE)
}



################################################################################
## Model selection
################################################################################

## Function to perform model selection in psglmm(), i.e. to perform predictive
##   cross-validataion and calculate the p-value of the variance estimate for
##   the chosen correlation component.
## Required by: psglmm()
## Depends on: pred.xval()
##
## Arguments:
## ----------
## msel:        A character vector with the name of the proper scoring rule to
##              be used for the predictive cross-validation. For binary data the 
##              Brier score 'BS' and the logarithmic score 'LS are supported. 
##              For Gaussian responses 'LS' and the Dawid-Sebastian score 'DSS' 
##              are supported and for Poisson responses 'DSS' i supported.
## varout:      The data frame for the results as returned by a call to 
##              makeVARALL().
## nRE:         The number of random effects which are penalised.
## f4selection: The formula in a processed form as returned by adaptFormula().
## call:        List of objects passed to psglmm().
## family:      The family used.
## gf:          The names of the grouping factors for each random effect.
## eps:         The limit, above which variance estimates are consdiered to be
##              "greater than zero". Variance estimates very close to zero seem
##              to perform very good in the predictive cross-validation even if
##              they are not significant.
## msgs:        Logical value if messages conserning fitting progress should be
##              returned.
## rd:          Number of digits to round results to.
##
## Returns: A list of two data frame: one (varall) with the variance estimates 
##          for all random effects components (with cross-validation score) and 
##          one (varsel) containing information of the selected variance 
##          parameter and its p value. 
modelSelection <- function(msel, varout, nRE, f4selection, call, family, gf, 
  eps, msgs, rd) {
  if(msgs) cat("Model selection ")
  RE <- varout$varall
  VS <- varout$varsel
  # number of decimal points is obained from 'eps'
  ndp <- round(optimize(function(x) abs(10^-x - eps), c(1, 20))$minimum)
  methods <- list()
  methods$gaussian <- c("DSS", "LS")
  methods$binomial <- c("BS", "LS")
  methods$poisson <- c("DSS", "LS")
  if(sum(RE[!(RE$Groups %in% c("", "Residual")), "Variance"] >= eps) > 1) {
    if(!(msel %in% methods[[family[[1]]]]) || msel == TRUE) {
      if(msel == TRUE) {
        msel <- methods[[family[[1]]]][1]
      } else {
        warning(paste("Method '", msel, "' is not implemented for '",
          family[[1]], "' data. 'msel' set to '", methods[[family[[1]]]][1], 
          "'.", sep= ""))
        msel <- methods[[family[[1]]]][1]
      }
    }
    if(msgs) cat(paste("using method '", msel, "'\n", sep=""))
    VCV2test <- which(RE[!(RE$Groups %in% c("", "Residual")), 
      "Variance"] >= eps)
    xval <- rep(NA, nRE)
    subm <- vector("list", nRE)
    subformula <- subformula.null <- vector("list", nRE)
    var0 <- rep(FALSE, nRE)
    # Predctive cross-validation is performed for all component with a variance
    # estimate > eps
    for(i in VCV2test) {
      if(msgs) cat(paste("  for covariance component '", names(call$VCV)[i], 
        "':\n", sep= ""))
      subformula[[i]] <- as.formula(paste(f4selection$y, "~", 
        paste(f4selection$fe, collapse= "+"), ifelse(is.null(f4selection$fe), 
        "", "+"), 
        f4selection$re[i]))
      subformula.null[[i]] <- as.formula(paste(paste(f4selection$y, "~", 
        paste(f4selection$fe, collapse= "+"))))
      subm[[i]] <- psglmm(subformula[[i]], data= call$data, 
        VCV= list("test"= call$VCV[[i]]), family= family,
        msel= FALSE, eps= eps, msgs= FALSE)
      # If a variance estimate is positive, but estimate in subm[[i]] is 0, this
      # component should not be tested against the others, its pred.xval would 
      # be too good.
      if(subm[[i]]$varall$Variance[1] > eps) {
        xval[i] <- pred.xval(m= subm[[i]]$modorig, 
          y= as.character(subformula[[i]])[2], gf= gf[i], method= msel, 
          eps= eps, family= family, msgs= msgs)
        if(is.na(xval[i])) break
      } else {
        var0[i] <- TRUE
        if(msgs) cat("    crossvalidation skipped as variance estimated to 0\n")
      }
    }
    if(any(var0)) VCV2test <- VCV2test[!(VCV2test %in% which(var0))]
    RE[, msel] <- ""
    xvalres <- round(xval, 5)
    xvalres[setdiff(1:nRE, VCV2test)] <- ""
    xvalres[is.na(xvalres)]<- "NA"
    RE[!(RE$Groups %in% c("", "Residual")), msel] <- xvalres
    RE[, "Selection"] <- ""
    # if any of the results from the predictive cross-validataions returned NA, 
    # no model selection is performed and also no LR test.
    if(!any(is.na(xval[VCV2test])) && length(VCV2test) > 0) {
      VCVopt <- which.max(xval)
#? hier ?#   component choice but no star or p value?
      if(any(xval != 0, na.rm= TRUE) && 
        (sum(!is.na(xval)) == length(VCV2test))) {
        RE[!(RE$Groups %in% c("", "Residual")), "Selection"][VCVopt] <- "*"
      }
      ind <- c(VCVopt, which((RE$Groups %in% c("", "Residual"))))
      VS <- RE[ind, 1:5]
      VS[, c("Variance", "Std.Dev")] <- subm[[VCVopt]]$varall[, c("Variance", 
        "Std.Dev")]
      if(!is.null(rd)) {
        VS[, c("Variance", "Std.Dev")] <- round( VS[, c("Variance", "Std.Dev")],
          rd)
      }
      ## LR test if variance estimate for optimal covariance component is > 0
      ll.alt <- logLik(subm[[VCVopt]]$modorig)[1]
      ll.null <- logLik(glm(subformula.null[[VCVopt]], data= call$data, 
        family= family))[1]
      C <- LR.test(ll.alt, ll.null)
      VS[, "p (LR)"] <- ""
      VS[1, "p (LR)"] <- C[, 2]
      modsel <- subm[[VCVopt]]$modorig
    } else modsel <- NULL
  } else {
    if(msgs) cat("\n")
    RE[, "Selection"] <- ""
    tmp <- round(RE[, "Std.Dev"], ndp)
    tmp[RE$Groups %in% c("", "Residual")] <- NA
    VCVopt <- which.max(tmp)
    if(any(tmp != 0, na.rm= TRUE)) {
      RE[VCVopt, "Selection"] <- "**"
      ind <- c(VCVopt, which((RE$Groups %in% c("", "Residual"))))
      VS <- RE[ind, 1:5]
      ## LR test if variance estimate for optimal covariance component is > 0
      subformula <- as.formula(paste(f4selection$y, "~", 
        paste(f4selection$fe, collapse= "+"), ifelse(is.null(f4selection$fe), 
        "", "+"), f4selection$re[VCVopt]))
      subformula.null <- as.formula(paste(paste(f4selection$y, "~", 
        paste(f4selection$fe, collapse= "+"))))
      subm <- psglmm(subformula, data= call$data, 
        VCV= list("test"= call$VCV[[VCVopt]]), family= family, msel= FALSE, 
        eps= eps, msgs= FALSE)
      VS[, c("Variance", "Std.Dev")] <- subm$varall[, c("Variance", "Std.Dev")]
      if(!is.null(rd)) {
        VS[, c("Variance", "Std.Dev")] <- round( VS[, c("Variance", "Std.Dev")],
          rd)
      }
      ll.alt <- logLik(subm$modorig)[1]
      ll.null <- logLik(glm(subformula.null, data= call$data, family= family))[1]
      C <- LR.test(ll.alt, ll.null)
      VS[, "p (LR)"] <- ""
      VS[1, "p (LR)"] <- C[, 2]
      modsel <- subm$modorig
    } else modsel <- NULL
  }
  varout$varall <- RE
  varout$varsel <- VS
  varout$modsel <- modsel
  return(varout)
}


## Function to perform LR test
## Required by: modelSelection()
## Depends on: 
##
## Arguments:
## ----------
## ll.alt:  The log-likelihood of the alternative model
## ll.null: The log-likelihood of the null model
##
## Returns: A data frame with the p value as numeric and text (if the p value 
##          is < 1e-5 the text string "< 1e-5" is returned.
LR.test <- function(ll.alt, ll.null) {
  LR <- 2 * (ll.alt - ll.null)
  C <- round(1 - 0.5 * pchisq(LR, 0) - 0.5 * pchisq(LR, 1), 5)
  Ctxt <- if(C < 1e-5) paste("<", 1e-5) else as.character(C)
  return(data.frame(C, Ctxt, stringsAsFactors= FALSE))
}



################################################################################
## Predictive cross-validation and proper scoring rules
################################################################################

## Function to perform predictive cross-validation as described by Braun et. al
##   (2013).
## Required by: modelSelection()
## Depends on: 
##
## Arguments:
## ----------
## m:      A fitted model of class 'merMod' or 'glmerMod' with one random
#          effect.
## y:      A character string giving the name of the response variable used in
##         m.
## gf:     The name of the grouping factor of the rando meffect.
## method: The proper scoring rule to be used ('BS', 'LS' or 'DSS').
## eps:    The limit, above which variance estimates are consdiered to be
##         "greater than zero". Variance estimates very close to zero seem to
##         perform very good in the predictive cross-validation even if they are
##         not significant.
## family: The family of the responses.
## msgs:   Logical value if messages conserning fitting progress should be
##         returned.
##
## Returns: The score of the chosen proper scoring rule or NA id the algorithm
##          fails to converge.
pred.xval <- function(m, y, gf, method, eps= 1e-5, family, msgs) {
  data <- model.frame(m)
  ## Binary data saved as a factor is transformed to numerical.
  if(family[[1]] == "binomial" & is.factor(data[, y])) {
    data[, y] <- as.numeric(data[, y]) - 1
  }
  if(method %in% c("DSS", "LS") && is.factor(data[, y])) {
    warning("Methods 'DSS' and 'LS' not compatible with factors.")
    return(NA)
  }
  ## The number of levels for the grouping factor is extracted as 'I'.
  gf.levels <- unique(data[, gf])
  I <- nlevels(gf.levels)

  ## If variance estimate is < eps (i.e. considered to be zero) NA is returned.
  if(VarCorr(m)[[1]][1] < eps) {
    warning("Variance estimate is 0, 'NA' returned.")
    return(NA)
  }
  X <- model.matrix(m) # design matrix fixed effects
  Z <- as(t(m@pp$Zt), "matrix") # design matrix random effects
  b <- t(matrix(m@pp$b(1.), nrow(data) / I)) # estimated random effects
  b <- as.vector(t(b))

  scores <- vector("numeric", nrow(data))
  error <- FALSE
  ## Cross-validation is performed.
  ## Clusters i are the levels of the grouping factor.
  for(i in 1:I) {
    if(error) break
    if(msgs) { # progress bar
      pb <- txtProgressBar(style= 3)
      setTxtProgressBar(pb, i / I)
    }

    ind.i <- which(data[, gf] == gf.levels[i]) # observations belonging to level i of grouping factor.
    J <- length(ind.i) # number of observations in cluster i
    yi <- data[ind.i, y] # response subvector
    Xi <- X[ind.i,]  # fixed effects subdesign matrix for cluster i
    Zi <- Z[ind.i, ind.i]  # random effects subdesign matrix for cluster i
    beta <- fixef(m) # fixed effects estimates
    bi <- b[ind.i] # random effects estimates for cluster i
    Q <- VarCorr(m)[[1]][1] * diag(J) # initial Q
    ## Observations j belonging to cluster i
    for(j in 1:J) { 
      if(error) break
      m.old <- bi
      Wi <- matrix(0, J, J)
      yi.tilde <- vector("numeric", J)
      mj <- setdiff(1:J, j) # observations without the j-th ('mj')
      sc <- 1
      k <- 1
      ## For family Gaussian.
      if(family[[1]] == "gaussian") {
        while(sc >= eps) {
          for(s in mj) {
            yi.tilde[s] <- yi[s] - t(Xi[s,]) %*% beta
          }
          yimj.tilde <- yi.tilde[mj]
          Zimj <- Zi[mj,] # Z_{i, -j}
          C <- solve(solve(Q) + t(Zimj) %*% Zimj)
          m.new <- C %*% t(Zimj) %*% yimj.tilde
          sc <- max(abs(m.new - m.old) / abs(m.old + as.numeric(m.old == 0)))
          m.old <- m.new
          k <- k + 1
          ## If algorithm hasn't converged in 10000 iterations it's stopped
          if(k > 10000) {
            if(msgs) cat("\n")
            warning(cat(paste("IWLS algorithm didn't converge in 10000 ",
              "iterations for i= ", i, " and j = ", j, ".\n", 
              "No model selection possible.\n", sep= "")))
            error <- TRUE
            break
          }
        }
        tau <- t(Xi[j,]) %*% beta + t(Zi[j,]) %*% m.new
        sigma2 <- t(Zi[j,]) %*% C %*% Zi[j,]
        ## Score is calculated using the chosen proper scoring rule
        scores[ind.i[j]] <- get(method, mode= "function")(data[ind.i[j], y], 
          tau, sigma2, family)
      }
      ## For family binomial.
      if(family[[1]] == "binomial") {
        while(sc >= eps) {
          for(s in mj) {
            numerator <- exp(t(Xi[s,]) %*% beta + t(Zi[s,]) %*% m.old)
            Wi[s, s] <- numerator / (1 + numerator)^2
            if(Wi[s, s] == 0) {
              tmp <- beta[which.max(abs(beta))]
              warning(cat(paste("\nWi[s, s] is zero. Cross-validation stopped.",
                " No model selection possible.\n", sep= "")))
              error <- TRUE
            }
            if(error) break
            yi.tilde[s] <- t(Zi[s,]) %*% m.old + yi[s] * (1 / Wi[s, s]) - 
              numerator - 1
          }
          if(error) break
          Wimj <- Wi[mj, mj]  # W_{i, -j}
          yimj.tilde <- yi.tilde[mj]
          Zimj <- Zi[mj,] # Z_{i, -j}
          C <- solve(solve(Q) + t(Zimj) %*% Wimj %*% Zimj)
          m.new <- C %*% t(Zimj) %*% Wimj %*% yimj.tilde
          sc <- max(abs(m.new - m.old) / abs(m.old + as.numeric(m.old == 0)))
          m.old <- m.new
          k <- k + 1
          if(k > 10000) {
            if(msgs) cat("\n")
            warning(cat(paste("IWLS algorithm didn't converge in 10000 ",
              "iterations for i= ", i, " and j = ", j, ".\n", 
              "No model selection possible.\n", sep= "")))
            error <- TRUE
            break
          }
        }
        tau <- t(Xi[j,]) %*% beta + t(Zi[j,]) %*% m.new
        sigma2 <- t(Zi[j,]) %*% C %*% Zi[j,]
        scores[ind.i[j]] <- get(method, mode= "function")(data[ind.i[j], y], 
          tau, sigma2, family)
      }
      ## For family Poisson.
      if(family[[1]] == "poisson") {
        while(sc >= eps) {
          for(s in mj) {
            Wi[s, s] <- exp(t(Xi[s,]) %*% beta + t(Zi[s,]) %*% m.old)
            if(Wi[s, s] == 0) {
              tmp <- beta[which.max(abs(beta))]
              warning(cat(paste("\nWi[s, s] is zero. Cross-validation stopped.",
                " No model selection possible.\n", sep= "")))
              error <- TRUE
            }
            if(error) break
            yi.tilde[s] <- t(Zi[s,]) %*% m.old + yi[s] * (1 / Wi[s, s]) - 1
          }
          if(error) break
          Wimj <- Wi[mj, mj]  # W_{i, -j}
          yimj.tilde <- yi.tilde[mj]
          Zimj <- Zi[mj,] # Z_{i, -j}
          C <- solve(solve(Q) + t(Zimj) %*% Wimj %*% Zimj)
          m.new <- C %*% t(Zimj) %*% Wimj %*% yimj.tilde
          if(!is.numeric(m.new)) {
            cat("\n")
            warning(cat("'m.new' not numeric. No model selection possible.\n"))
            error <- TRUE
            break
          }
          sc <- max(abs(m.new - m.old) / abs(m.old + as.numeric(m.old == 0)))
          m.old <- m.new
          k <- k + 1
          if(k > 10000) {
            if(msgs) cat("\n")
            warning(cat(paste("IWLS algorithm didn't converge in 10000 ",
              "iterations for i= ", i, " and j = ", j, ".\n", 
              "No model selection possible.\n", sep= "")))
            error <- TRUE
            break
          }
        }
        tau <- t(Xi[j,]) %*% beta + t(Zi[j,]) %*% m.new
        sigma2 <- t(Zi[j,]) %*% C %*% Zi[j,]
        E.lambda <- exp(tau + 0.5 * sigma2)
        V.lambda <- (exp(sigma2) - 1) * exp(2 * tau + sigma2)
        E.yij <- E.lambda
        V.yij <- E.lambda + V.lambda
        if(method == "LS") {
#          alpha <- E.yij^2 / V.yij
#          if(V.yij <= 1) return(NA)
#          phi <- E.yij
#          scores[ind.i[j]] <- pnbinom(data[ind.i[j], y], size= phi, mu= alpha)
          ydistr <- function(lambda, y, mu, var) {
            ((lambda^y) / factorial(y)) * exp(-lambda) * 
              (1 / (lambda * sqrt(2 * pi * var))) * 
              exp(-((log(lambda) - mu)^2) / 2 * var)
          }
print("integration start")
          scores[ind.i[j]] <- integrate(ydistr, y=data[ind.i[j], y], 
            mu= E.lambda, var= V.lambda, lower= 0, upper= Inf)
print("integration stop")
        }
        if(method == "DSS") {
          scores[ind.i[j]] <- get(method, mode= "function")(data[ind.i[j], y], 
            E.yij, V.yij, family)
        }
      }
    }
  }
  if(msgs) close(pb)
  if(error) return(NA) # if algorithm didn't converge NA is returned
  return(mean(scores))
}


## Proper scoring rule: Brier Score
## Required by: pred.xval()
## Depends on:
##
## Arguments:
## ----------
## y: A vector of actual responses.
## E: The expectation value obtained through cross-validation.
## V: The variance obtained through cross-validation.
## family: The family of the response. Not used.
##
## Returns: A numeric score. A higher score is better.
BS <- function(y, E, V, family){
	brier.score <- -(pnorm(0, mean= E, sd= sqrt(V) + pi^2 / 3 * 225 / 256, 
	  lower.tail= FALSE) - y)^2
  return(brier.score)
}


## Proper scoring rule: Logarithmic Score
## Required by: pred.xval()
## Depends on:
##
## Arguments:
## ----------
## y: A vector of actual responses.
## E: The expectation value obtained through cross-validation.
## V: The variance obtained through cross-validation.
## family: The family of the response.
##
## Returns: A numeric score. A higher score is better.
LS <- function(y, E, V, family){
  if(family[[1]] == "gaussian") {
    ls <- log(dnorm(y, mean= E, sd= sqrt(V)))
  }
  if(family[[1]] == "binomial") {
    ls <- log(dbinom(y, size= 1, 
	    prob= pnorm(0, mean= E, sd= sqrt(V) + pi^2 / 3 * 225 / 256, 
	    lower.tail= FALSE)))
  }
  if(family[[1]] == "poisson") {
  # approximation using gamma distribution!
    ls <- log(dpois(y, size= V, mu= E))
  }
	return(ls)	
}


## Proper scoring rule: Dawid Sebastiani Score
## Required by: pred.xval()
## Depends on:
##
## Arguments:
## ----------
## y: A vector of actual responses.
## E: The expectation value obtained through cross-validation.
## V: The variance obtained through cross-validation.
## family: The family of the response. Not used.
##
## Returns: A numeric score. A higher score is better.
DSS <- function(y, E, V, family) {
  -0.5 * (log(V) + ((y - E) / sqrt(V))^2)
}
# comment # for Poisson: if y==E and V<1 DSS is positive



################################################################################
## Misc.
################################################################################

## Function to retrieve the number of unique values to a vector 'x'. This as an
##   alternative to 'nlevels', when only the number of actually used levels is
##   needed.
## Required by: randomTerms(), adaptFormula()
## Depends on:
##
## Arguments:
## ----------
## x: A vector.
##
## Returns: The scalar number of unique values in 'x'.
nuniq <- function(x) {
  if(is.factor(x)) x <- as.vector(x)
  if(!(is.vector(x) || isMatrix(x))) stop("'x' must be a vector")
  return(length(unique(as.vector(x))))
}


## Function to check if all elements of a vector are equal
## Required by:
## Depends on: 
##
## Arguments:
## ----------
## x: A vector
##
## Returns: TRUE/FALSE
equal <- function(x) {
  if(length(x) == 0 | all(is.na(x))) return(NA)
  if(length(x) == 1) return(TRUE)
  if(length(unique(x[!is.na(x)])) == 1) return(TRUE) else return(FALSE)
}


## Function returning 'yes' if 'test' is TRUE and 'no' if 'test' is FALSE. 
##   Contrary to ifelse() this function works for arbitrary objects to be used
##   as 'yes' and 'no'.
## Required by: 
## Depends on:
##
## Arguments:
## ----------
## test: A logical vector of length one.
## yes:  An R object.
## no:   An R object.
##
## Returns: The object 'yes' or 'no' depending on the value of 'test'.
IFELSE <- function(test, yes, no) {
  if(test) return(yes)
  if(!test) return(no)
}


## Function to create polygons of size 1x1 aligned in a rectangular grid.
## Required by:
## Depends on: 
##
## Arguments:
## ----------
## rangex: range of plots' lower left horizontal starting coordinate.
## rangey: range of plots' lower left vertical starting coordinate.
##
## Returns: A list of 5x2 matrices containing the coordinates of each plot.
makePolys <- function(rangex, rangey) {
  px <- length(rangex)
  py <- length(rangey)
  p <- px * py
  polys <- vector("list", p)
  names(polys) <- 1:p
  for(i in 1:p) {
    j <- ifelse(i %% px == 0, px, i %% px)
    k <- (i %/% px) + ifelse(i %% px == 0, 0, 1)
    x <- c(rangex[j], rep(rangex[j]+1, 2), rep(rangex[j], 2))
    y <- c(rep(rangey[k], 2), rep(rangey[k]+1, 2), rangey[k])
    polys[[i]] <- matrix(c(x, y), 5, 2)
  }
  return(polys)
}

id <- "11"
mod <- paste("simModel", id, sep= "")

# Load packages and sources
library("lme4")
library("mvtnorm")
library("fields")
source("../R/psglmm.R")
source("../R/psglmmSim.R")
source("../R/makeData.R")
source("../R/makeEnvir.R")

# Number of simulations per rho
nsim= 100
formula= y ~ spp - 1 + (spp - 1 | plot) + (spp - 1 | plot) + (spp - 1 | plot)
# Variance-Covariance-Structure of random effects
VCVtmp= list("phylogenetic"= kron("I_p", "S"), "spatial"= kron("P", "I_s"), 
  "spatio-phylogenetic"= kron("P", "S"))
gf= c("plot", "plot", "plot")
# Number of plots in x and y direction
px= 10
py= 10
# Number of species
s= 4
# Fixed effects
spp.fe= seq(-2, 2, length.out= s)
# Correlations to be used between species 1 and 2
rho= seq(0, 0.98, 0.02)
# Species' random effect variance
var.spp= 2
# Plots' random effect variance
var.plot= 0
# Variance independent of species and plots
var.ind= 0
# Variance of error term (only for 'family=gaussian()')
var.error= 0.01
# If an environmental factor should be simulated (ESM) or not (CCM)
x= FALSE
# Proper scoring rule to be used for the predictive cross-validation
msel= "DSS"
family= gaussian()
# Under which value spatial correlations should be set to zero
P.lim= 0.1

seeds <- 1:length(rho)
for(i in 1:length(rho)) {
  set.seed(seeds[i])
  cat(paste("seed:", seeds[i], "\n"))
  sims <- psglmmSim(nsim, formula, VCVtmp, px, py, s, spp.fe, rho12= rho[i], 
    var.spp, var.plot, var.ind, var.error, x, family, gf, msel, envir, P.lim)
  save(sims, file= paste("sims/", mod, "_", i, ".Rdata", sep=""))
  cat("Data saved\n")
#  rm(sims)
}

# Function for simulating Data
################################################################################
# px:        number of plots in x-direction
# py:        number of plots in y-direction
# s:         number of species
# spp.fe:    fixed effects of species
# rho12:     correlation between species 1 and 2
# var.spp:   Variance parameter of species effect
# var.plot:  Variance parameter of spatial effect
# var.ind:   Variance parameter if there is neither species specific nor spatial
#            variance
# var.error: Variance of error term (only for Gaussian responses)
# x:         Logical if a the effect of an environmental factor should be
#            simulated; must be TRUE if 'envir' is used
# family:    Family of simulated responses
# spatial:   If a spatial correlation structure should be used (TRUE) or not 
#            (FALSE)
# plot.pred: Logical if boxplots of linear predictors for each species should be
#            plotted
# P.lim:     The minimum spatial correlation to be considered
# envir:     A vector containing the values of an environmental factor for all
#            plots; if 'envir' is used 'x' must be TRUE 
# ...:       Additional arguments to be passed to Matern()
makeData <- function(px= 10, py= 10, s= 2, spp.fe= c(0, 0), rho12= 0, 
  var.spp= 0, var.plot= 0, var.ind= 0, var.error= 0.01, x= FALSE, 
  family= gaussian(), spatial= TRUE, plot.pred= FALSE, P.lim= 0.1, envir, ...) {

  if(any(c(px, py, s) <= 0)) 
    stop("'px', 'py' and 's' must be positive integers.")
  if(length(spp.fe) != s) stop("'spp.fe' must have length 's'.")
  if(abs(rho12) > 1) stop("correlation must be between -1 and 1.")
  if(!all(c(var.spp, var.plot, var.ind) >= 0)) 
    stop("variances must be non-negative.")
  if(!(family %in% c("gaussian", "binomial", "poisson") || 
    family[[1]] %in% c("gaussian", "binomial", "poisson"))) 
    stop("'family' must be 'gaussian', 'binomial' or 'poisson'")

  require("mvtnorm")  # for rmvnorm()
  require("fields")   # for Matern()

  p <- px * py
  # Correlation matrix of species is set up
  S <- diag(s)
  S[cbind(2:1, 1:2)] <- rho12
  # Spatial correlation matrix is set up using Matern correlation function
  if(spatial) {
    xy <- expand.grid(x= 1:px, y= 1:py)
    dists <- as.matrix(dist(xy, method= "euclidian", diag= TRUE, upper= TRUE))
    P <- Matern(dists, ...)
    P[P < P.lim] <- 0
  } else P <- diag(p)
  # Data are set up
  d <- data.frame(y= rep(0, p * s), plot= factor(rep(1:p, each= s)), 
    spp= factor(rep(1:s, p)))
  # Fixed and random effects for species are added
  d$y <- d$y + rep(spp.fe, p)
  if(x == FALSE) {
    if(all(c(var.spp, var.plot) != 0)) {
      VCOV <- kronecker(IFELSE(var.plot > 0, var.plot * P, diag(p)), 
        IFELSE(var.spp > 0, var.spp * S, diag(s)))
      d$y <- d$y + t(rmvnorm(1, mean= rep(0, p * s), sigma= VCOV))
    } else {
      if(all(c(var.spp, var.plot) == 0)) {
        d$y <- d$y + rnorm(p * s, mean= 0, sd= sqrt(var.ind))
      } else {
        if(var.spp > 0) {
          VCOV <- var.spp * S
          d$y <- d$y + as.vector(t(rmvnorm(p, mean= rep(0, s), sigma= VCOV)))
        }
        if(var.plot > 0) {
          VCOV <- var.plot * P
          d$y <- d$y + as.vector(rmvnorm(s, mean= rep(0, p), sigma= VCOV))       
        }
      }
    }
  } else {
    if(missing(envir)) {
      envir <- rmvnorm(1, mean= seq(1, 2, length.out= p), sigma= 0.25 * P)
      envir <- as.vector(envir)
    }
    if(all(c(var.spp, var.plot) != 0)) {
      VCOV <- kronecker(IFELSE(var.plot > 0, var.plot * P, diag(p)), 
        IFELSE(var.spp > 0, var.spp * S, diag(s)))
      beta <- as.vector(t(rmvnorm(1, mean= rep(0, p * s), sigma= VCOV)))
    } else {
      if(all(c(var.spp, var.plot) == 0)) {
        beta <- rnorm(p * s, mean= 0, sd= sqrt(var.ind))
      } else {
        if(var.spp > 0) {
          VCOV <- var.spp * S
          beta <- as.vector(t(rmvnorm(p, mean= rep(0, s), sigma= VCOV)))
        }
        if(var.plot > 0) {
          VCOV <- var.plot * P
          beta <- as.vector(rmvnorm(s, mean= rep(0, p), sigma= VCOV))       
        }
      }
    }
    d$x <- rep(envir, each= s)
    d$y <- d$y + beta * d$x 
  }
  if(plot.pred) {
    boxplot(d$y ~ d$spp, axes= FALSE, main= "linear predictors", outline= FALSE)
    axis(1, at= 1:s, label= paste("spp", i= 1:s, sep= ""))
    axis(2)
    box()
    for(i in 1:s) lines(i + c(-0.4, 0.4), rep(spp.fe[i], 2), col= 2)
  }
  d$pred <- d$y 
  # If Gaussian data are to be generated an error term is added
  if(family == "gaussian" || family[[1]] == "gaussian")  {
    d$y <- d$y + rnorm(p * s, mean= 0, sd= sqrt(var.error))
  }
  # If binomial data are to be generated the linear predictor is transformed
  if(family == "binomial" || family[[1]] == "binomial") {
    d$y <- factor(rbinom(p * s, size= 1, prob= plogis(d$pred)))
    d$y2 <- factor(as.numeric(d$pred > 0))
  }
  # If Poisson data are to be generated the linear predictor is transformed
  if(family == "poisson" || family[[1]] == "poisson") {
    d$y <- rpois(p * s, lambda= exp(d$pred))
  }
  return(list(d= d, S= as(S, "dgCMatrix"), P= as(P, "dgCMatrix")))
}

# See 'simModel11.R' for a short explanation
id <- "21pois"
mod <- paste("simModel", id, sep= "")

library("lme4")
library("mvtnorm")
library("fields")

source("../R/psglmm.R")
source("../R/psglmmSim.R")
source("../R/makeData.R")
source("../R/makeEnvir.R")

nsim= 100
formula= y ~ spp - 1 + spp:x + (x - 1 | plot:spp) + (x - 1 | plot:spp) + 
  (x - 1 | plot:spp) + (x - 1 | plot:spp)
VCVtmp= list("independent"= kron("I_p", "I_s"), 
  "phylogenetic"= kron("I_p", "S"), "spatial"= kron("P", "I_s"), 
  "spatio-phylogenetic"= kron("P", "S"))
gf= c("plot", "plot", "plot", "plot")
px= 10
py= 10
s= 4
spp.fe= seq(-1, 1, length.out= s)
rho= seq(0, 0.98, 0.02)
var.spp= 1
var.plot= 0
var.ind= 0
var.error= 0
x= TRUE
msel= "DSS"
family= poisson()
P.lim= 0.1

seeds <- 1:length(rho)
for(i in 1:length(rho)) {
  set.seed(seeds[i])
  cat(paste("seed:", seeds[i], "\n"))
  sims <- psglmmSim(nsim, formula, VCVtmp, px, py, s, spp.fe, rho12= rho[i], 
    var.spp, var.plot, var.ind, var.error, x, family, gf, msel, envir, P.lim)
  save(sims, file= paste("sims/", mod, "_", i, ".Rdata", sep=""))
  cat("Data saved\n")
  rm(sims)
}

# See 'simModel11.R' for a short explanation
id <- "23pois"
mod <- paste("simModel", id, sep= "")

library("lme4")
library("mvtnorm")
library("fields")

source("../R/psglmm.R")
source("../R/psglmmSim.R")
source("../R/makeData.R")
source("../R/makeEnvir.R")

nsim= 100
formula= y ~ spp - 1 + spp:x + (x - 1 | plot:spp) + (x - 1 | plot:spp) + 
  (x - 1 | plot:spp) + (x - 1 | plot:spp)
VCVtmp= list("independent"= kron("I_p", "I_s"), 
  "phylogenetic"= kron("I_p", "S"), "spatial"= kron("P", "I_s"), 
  "spatio-phylogenetic"= kron("P", "S"))
gf= c("plot", "plot", "plot", "plot")
px= 10
py= 10
s= 4
spp.fe= seq(-1, 1, length.out= s)
rho= seq(0, 0.98, 0.02)
var.spp= 1
var.plot= 1
var.ind= 0
var.error= 0
x= TRUE
msel= "DSS"
family= poisson()
P.lim= 0.1

seeds <- 1:length(rho)
for(i in 1:length(rho)) {
  set.seed(seeds[i])
  cat(paste("seed:", seeds[i], "\n"))
  sims <- psglmmSim(nsim, formula, VCVtmp, px, py, s, spp.fe, rho12= rho[i], 
    var.spp, var.plot, var.ind, var.error, x, family, gf, msel, envir, P.lim)
  save(sims, file= paste("sims/", mod, "_", i, ".Rdata", sep=""))
  cat("Data saved\n")
  rm(sims)
}

files <- c("PROACT_2013_08_12_Demographics_Dictionary.csv", "PROACT_2013_08_12_SUBJECT_ALS_HX_Dictionary.csv", 
           "PROACT_2013_08_12_FAMHX_Dictionary.csv", "PROACT_2013_08_12_ALSFRS_Dictionary.csv", 
           "PROACT_2013_08_12_VITALS_Dictionary.csv", "PROACT_2013_08_22_TREATMENT_Dictionary.csv", 
           "PROACT_2013_08_12_SVC_Dictionary.csv", "PROACT_2013_08_12_FVC_Dictionary.csv",
           "PROACT_2013_08_12_RILUZOLE_Dictionary.csv", "PROACT_2013_08_12_DEATH_Dictionary.csv", 
           "PROACT_2013_08_22_LABS_Dictionary.csv",
           "PROACT_2013_08_12_Demographics_Data.xlsx", "PROACT_2013_08_12_SUBJECT_ALS_HX_Data.xlsx",
           "PROACT_2013_08_12_FAMHX_Data.xlsx", "PROACT_2013_08_12_ALSFRS_Data.xlsx", 
           "PROACT_2013_08_12_VITALS_Data.xlsx", "PROACT_2013_08_22_TREATMENT_Data.xlsx", 
           "PROACT_2013_08_12_SVC_Data.xlsx", "PROACT_2013_08_12_FVC_Data.xlsx", 
           "PROACT_2013_08_12_RILUZOLE_Data.xlsx", "PROACT_2013_08_12_DEATH_Data.xlsx")

if (interactive()) {
  
  infolder <- readline("Please specify the directory where the raw PRO ACT data
                       downloaded from https://nctu.partners.org/ProACT are stored
                       (press ENTER if it is the same as the current working directory): ")
  ifelse(infolder == "", infolder <- "./", infolder <- infolder)
  
  
  outfolder <- readline("Please specify a directory where I should save the data;
                        it should be relative to the previously entered directory
                        (press ENTER if it is the same as the previous): ")
  ifelse(outfolder == "", outfolder <- "./", outfolder <- outfolder)
  
} 
if(!file.exists(infolder)) stop(paste0('directory "', infolder, '" does not exist'))
if(!file.exists(outfolder)) stop(paste0('directory "', outfolder, '" does not exist'))

wdbase <- getwd()
setwd(infolder)

m <- files %in% list.files()

if (!all(m))
  cat("File(s)", files[!m], "missing; aborting.\n")


cat("This is going to take a while ...\n")


#--- 1.1 - Download dictionaries -----------------------------------------------------------------------#

d <- c("PROACT_2013_08_12_Demographics_Dictionary.csv", "PROACT_2013_08_12_SUBJECT_ALS_HX_Dictionary.csv", 
       "PROACT_2013_08_12_FAMHX_Dictionary.csv", "PROACT_2013_08_12_ALSFRS_Dictionary.csv", 
       "PROACT_2013_08_12_VITALS_Dictionary.csv", "PROACT_2013_08_22_TREATMENT_Dictionary.csv", 
       "PROACT_2013_08_12_SVC_Dictionary.csv", "PROACT_2013_08_12_FVC_Dictionary.csv",
       "PROACT_2013_08_12_RILUZOLE_Dictionary.csv", "PROACT_2013_08_12_DEATH_Dictionary.csv", 
       "PROACT_2013_08_22_LABS_Dictionary.csv")

library("openxlsx")

dict  <-  function(d){
  tmp <- read.table(d, sep = "|", header = TRUE, na.string = "", quote = "\"")
}
DICT <- lapply(d,dict)


for(i in 1:length(DICT)){
  names(DICT)[[i]] <- as.character(DICT[[i]][1,"FormName"])
}
#str(DICT)


#--- 1.2 - Download datasets ---------------------------------------------------------------------------#

f <- c("PROACT_2013_08_12_Demographics_Data.xlsx", "PROACT_2013_08_12_SUBJECT_ALS_HX_Data.xlsx",
       "PROACT_2013_08_12_FAMHX_Data.xlsx", "PROACT_2013_08_12_ALSFRS_Data.xlsx", 
       "PROACT_2013_08_12_VITALS_Data.xlsx", "PROACT_2013_08_22_TREATMENT_Data.xlsx", 
       "PROACT_2013_08_12_SVC_Data.xlsx", "PROACT_2013_08_12_FVC_Data.xlsx", 
       "PROACT_2013_08_12_RILUZOLE_Data.xlsx", "PROACT_2013_08_12_DEATH_Data.xlsx")

labs <- read.csv("PROACT_2013_08_27_LABS_Data.csv", check.names=FALSE)

db  <-  function(f){
  tmp <- read.xlsx(f, check.names=FALSE)
}
RALS <- lapply(f,db)


##-- Add lab dataset

FormID <- rep(146,nrow(labs))
labs$FormID <- FormID
labs <- labs[c("SubjectID","FormID", "Test Name", "Test Result", "Test Unit", "Laboratory Delta")] 
RALS[["labs"]] <- labs 

for(i in 1:length(RALS)){
  if(RALS[[i]][1,"FormID"]==DICT[[i]][1,"FormID"]){
    names(RALS)[[i]] <- as.character(DICT[[i]][1,"FormName"])
  }
}


#--- 1.3 -  Take the information from the dictionaries and apply labels   ------------------------------#


##-- Change labels

nam <- list()
for(i in 1:length(d)){
  DICT[[i]][,"FieldID"] <- paste("V", DICT[[i]][,"FieldID"], sep = "_")  
  DICT[[i]][,"FormID"] <- paste("F", DICT[[i]][,"FormID"], sep = "_")
  nam[[i]] <- subset(DICT[[i]], select = c(FormID, FieldID, Field_Name))[!duplicated(subset(DICT[[i]], select = c(FormID, FieldID, Field_Name))),]
}

for(i in 1:length(nam)){
  if(nam[[i]][1,"FormID"]==DICT[[i]][1,"FormID"]){
    names(nam)[[i]] <- as.character(DICT[[i]][1,"FormName"])
  }
}


##-- Save the dictionary

vname <- list()
for(i in 1:length(d)){
  vname[[i]] <- subset(DICT[[i]], select = c(FormID, FormName, FieldID, Field_Name, Value))
}

for(i in 1:length(DICT)){
  names(vname)[[i]] <- as.character(DICT[[i]][1,"FormName"])
}

v2name <- vname[[1]]
for (i in 2:length(vname))
  v2name <- merge(v2name, vname[[i]], all = T)

### some of the variables are not defined in the dictionary 
nam.datfra <- names(RALS)
for(f in nam.datfra){
  for(i in 3:ncol(RALS[[f]])){
    for(j in 1:length(nam[[f]][,"Field_Name"])){
      if(names(RALS[[f]])[i] == nam[[f]][,"Field_Name"][j]) {
        colnames(RALS[[f]])[i] <- nam[[f]][,"FieldID"][j]
      }
    }
  }  
}

for(f in nam.datfra){
  d <- grep("Delta$", nam[[f]][,"Field_Name"])
  if (length(d) > 0 && !any(c("Onset Delta", "Diagnosis Delta") %in% nam[[f]][d,"Field_Name"])
      #!any(c("V_1417", "V_1418") %in% nam[[f]][d,"FieldID"])
  ) {
    names(RALS[[f]])[names(RALS[[f]]) == nam[[f]][d,"FieldID"]] <- "Delta"
    nm <- names(RALS[[f]])
    nm[nm == "Delta"] <- nm[3]
    nm[3] <- "Delta"
    RALS[[f]] <- RALS[[f]][, nm]
    ### only for debugging
  }
}


##-- Delete the extra summary row in tables: "Death Report", "Riluzole use"

x <- RALS[["Death Report"]]
y <- subset(x, !SubjectID=="(3484 row(s) affected)")

RALS[["Death Report"]] <- y

x <- RALS[["Riluzole use"]]
y <- subset(x, !SubjectID=="(7108 row(s) affected)")

RALS[["Riluzole use"]] <- y

#save("RALS",file="RALS.Rda")
#save("v2name",file="v2name.Rda")


#--- 2 - Clean up datasets -----------------------------------------------------------------------------#


##-- Save the dataframes to clean them 

RALScomp <- RALS
RALSclean <- RALS


#--- 2.1 - Clean up ALSFRS -----------------------------------------------------------------------------#

x <- RALS[["ALSFRS(R)"]]


##-- Explore the data 

## Frequency tables 
#apply(x[-1],2,table,useNA="ifany")                           ##### THERE ARE 167 <NA> IN "Delta"


##-- Fix Gastrostomy

### only one can be missing
gastrostomy <- with(x, !is.na(V_1218) & !is.na(V_1219))      # Identify when both columns have values (good = at least one NA)
x[gastrostomy, "V_1218"] <- pmax(x[gastrostomy, "V_1218"],   # Substitute the values of V_1218 by the maximum between V_1218 and V_1219 
                                 x[gastrostomy, "V_1219"])
x[gastrostomy, "V_1219"] <- NA                               # Delete the values of V_1219 where both columns have values (gastrotomy)
x$V_121819 <- with(x, ifelse(is.na(V_1219), V_1218, V_1219)) # Obtain one column for "Cutting"


##-- Calculate ALSFRS

# replace V_1214 with V_1230 for ALSFRS scores...
x$V_121430 <- with(x, ifelse(is.na(V_1214), V_1230, V_1214))                          # Substitute NA of V_1214 (Respiratory) by V_1230 (Dyspnea)
x$ALSFRS <- as.numeric(as.character(x$V_1228))                                        # Define ALSFRS as ALSFRS Total(V_1228)
#table(x$ALSFRS, useNA="ifany")                                                       ##### <ERROR/FIXME> One value is equal than 44 </ERROR/FIXME>
RNA <- is.na(x$ALSFRS)                                                                # Define RNA as NA of ALSFRS
#table(RNA)                                                                           ##### NA = 9172
x$ALSFRS[!RNA] <- with(x[!RNA,], V_1213 + V_1214 + V_1215 +                           # Obtain ALSFRS without considering NA - We have everything as before except for only one column of "cutting" 
                         V_1216 + V_1217 + ifelse(is.na(V_1218), V_1219, V_1218) + 
                         V_1220 + V_1221 + V_1222 + V_1223, na.rm = TRUE)
#table(x$ALSFRS, useNA="ifany")                                                       ##### <ERROR/FIXED> The value 44 was fixed </ERROR/FIXED>
##### NA = 9219
x$ALSFRS[RNA] <- with(x[RNA,], V_1213 + V_1215 + V_1216 + V_1217 +                    # Obtain NA of ALSFRS - Instead of V_1214 we have V_1230 
                        ifelse(is.na(V_1218), V_1219, V_1218) + 
                        V_1220 + V_1221 + V_1222 + V_1223 + V_1230, na.rm = TRUE)
A <- with(x, V_1213 + V_121430 + V_1215 +                                             # Verify that ALSFRS is correct
            V_1216 + V_1217 + V_121819 + 
            V_1220 + V_1221 + V_1222 + V_1223)
wrongALSFRS <- subset(x, abs(A - x$ALSFRS) > 0)$SubjectID


##-- Save the complete dataset

### For this dataset, duplicated cases cannot be found by delta due to "NA"
#str(x)
RALScomp[["ALSFRS(R)"]] <- x
#str(RALScomp[["ALSFRS(R)"]])


##-- Delete ALSFRS Total and ALSFRS-R Total 

x$V_1228 <- x$V_1229 <- NULL                   


##-- Obtain subset with "Delta" available in ALSFRS data

### There are 65 cases with "Delta" and without "ALSFRS" score 
### only subjects with ALS scores
x <- subset(x, !is.na(Delta))                                                         # Select data with "delta" information 
#y <- subset(x, is.na(ALSFRS))


##-- Define Subject indexes 

### only subjects with ALS scores available are interesting
id <- unique(x$SubjectID)                                                             # vector with the subjects (4838) who have "Delta" information              


##-- Debug duplicated cases 
dup <- sapply(id, function(i) any(duplicated(subset(x, SubjectID == i)$Delta)))       # identify duplicated cases by "delta"
# uniquexHS <- ddply(x, .(SubjectID), function(a){
#   unique(a)
# })

###<FIXME> there are duplicated SubjectIDs but with different values ...</FIXME>  
### Total duplicated cases = 9. Specifically, the subjects with the problem are 603836; 839490
### Solution: Delete the duplicated cases
#table(dup)
id[dup]
wi <- id[dup]            
if (sum(dup) > 0) {
  wi <- id[dup]                                 # SujectID of the duplicated cases 
  for (w in wi) {
    ind <- which(x$SubjectID == w)              # Row ID of the duplicated cases 
    nind <- ind[duplicated(x[ind, "Delta"])]    # Row ID of the case which is duplicated 
    x <- x[-nind,]                              # Data without the duplicated cases 
  }
}


##-- Save the cleaned dataset
RALSclean[["ALSFRS(R)"]] <- x
#str(RALSclean[["ALSFRS(R)"]])


#--- 2.2 - Clean up Demographics -----------------------------------------------------------------------#

x <- RALS[["Demographics"]] 

##-- Clean up the dataset

### Eliminate the 37 rows with the ERROR in Ethnicity WITHOUT MISSING THE INFORMATION 

## ---- ETHNICITY 

idx <- unique(x$SubjectID)  

### These are the same duplicated cases than when we are working with the subjects who have "delta" information in the ALSFRS dataset  
dup <- sapply(idx, function(i) any(duplicated(subset(x, SubjectID == i)$SubjectID)))   # identify duplicated cases by "Subject"
#table(dup)
wi <- idx[dup]                                 

y <- subset(x, SubjectID %in% wi)
#table(y$V_1204)

if (sum(dup) > 0) {
  wi <- idx[dup]                                    # SujectID of the duplicated cases 
  for (w in wi) {
    ind <- which(x$SubjectID == w)                  # Row ID of the duplicated cases 
    nind <- ind[duplicated(x[ind, "SubjectID"])]    # Row ID of the case which is duplicated 
    x <- x[-nind,]                                  # Data without the duplicated cases 
  }
}

#table(x$V_1204)
for (w in wi) {
  x$V_1204[x$SubjectID==w] <- "Hispanic or Latino"
}


## ---- RACE 

### Some columns have value equal to 0
##e.g.Subject= 902
x$Race <- 4
x$Race[!is.na(x$V_1211)] <- 1
x$Race[!is.na(x$V_1207)] <- 2
x$Race[!is.na(x$V_1208)] <- 3
x$Race[!is.na(x$V_1393)] <- 4
x$Race <- factor(x$Race, labels = c("Caucasian", "Asian", "Black/African American", "Unkown"))

y <- subset(x,SubjectID==902)

### CORRECTION 
x$V_1211[x$V_1211==0] <- NA
x$V_1207[x$V_1207==0] <- NA
x$V_1208[x$V_1208==0] <- NA
x$V_1393[x$V_1393==0] <- NA

x$Race <- 4
x$Race[!is.na(x$V_1211)] <- 1
x$Race[!is.na(x$V_1207)] <- 2
x$Race[!is.na(x$V_1208)] <- 3
x$Race[!is.na(x$V_1393)] <- 4
x$Race <- factor(x$Race, labels = c("Caucasian", "Asian", "Black/African American", "Unkown"))

y <- subset(x,SubjectID==902)

## ---- Sex: cleanup levels

x$Sex <- x$V_1205
x$Sex <- x$Sex[, drop = TRUE]         # Drops the levels that do not occur

## ---- Age

x$Age <- x$V_1257


##-- Save the complete dataset

RALScomp[["Demographics"]] <- x 


##-- Save the cleaned dataset

#x <- merge(x, SubjectIDs, by = "SubjectID")  ## We do not have "SubjectsIDs"
x$Delta <- NULL  
RALSclean[["Demographics"]] <- x 


#--- 2.3 - Clean up Labs -------------------------------------------------------------------------------#

##### THIS STEP IS LOCATED IN THE FILE NAMED "CleanupLabs.R"


#--- 2.4 - Clean up Family History ---------------------------------------------------------------------#

x <- RALS[["Family History"]]


##-- Explore duplicated cases 

## Identify and check the information of duplicated cases 

idx <- unique(x$SubjectID)  

# dup <- sapply(idx, function(i) any(duplicated(subset(x, SubjectID == i)$SubjectID)))       # identify duplicated cases by "SUBJECT"
#table(dup)

#y <- subset(x, SubjectID==427558 | SubjectID==434916)                     # The difference is only two cases with respect to the dataset defined by Delta of ALSFRS scores 
wi <- idx[dup]                                 


##-- Clean up some columns 

### collapse stroke entries
x$V_1419ND <- x$V_1419
#table(x$V_1419ND, useNA="ifany")
x$V_1419ND <- factor(x$V_1419ND, levels=c(levels(x$V_1419ND), "STROKE")) 
x$V_1419ND[grep("STROKE", x$V_1419ND)] <- "STROKE"
x$V_1419ND[x$V_1419ND == ""] <- NA
x$V_1419ND <- x$V_1419ND[, drop = TRUE]

## Clean up levels of V_1420 

x$V_1420[x$V_1420 == 0] <- NA
x$V_1420[x$V_1420 == ""] <- NA

### There is a case with "SROKES"
x$V_1420 <- factor(x$V_1420, levels=c(levels(x$V_1420), "STROKE")) 
x$V_1420[x$V_1420 == "SROKES"] <- "STROKE"
#x$V_1420[grep("STROKE", x$V_1420)] <- "STROKE"
x$V_1420 <- x$V_1420[, drop = TRUE]
#table(x$V_1420, useNA="ifany")

###In V_1419 = OTHER, we are missing the information 
y <- subset(x,V_1420=="STROKE")
x$V_1419ND[x$V_1419 == "OTHER" & x["V_1420"]=="STROKE"] <- "STROKE"
x$V_1419ND[x$V_1419 == "OTHER" & x["V_1420"]=="STROKE 1/2 SISTER"] <- "STROKE"
y <- subset(x,V_1420=="STROKE")
y <- subset(x,V_1420=="STROKE 1/2 SISTER")
#table(x$V_1419ND, useNA="ifany")


##-- Save the complete dataset

RALScomp[["Family History"]] <- x


##-- Delete some columns

### family information is time constant
x$Delta <- NULL

### remove completely missing variables ----- 40 - 1 (DELTA) - 13 = 26 COLUMNS + 1(V_1419ND) = 27 COLUMNS
x <- x[, sapply(x, function(a) any(!is.na(a)))]


##-- Explore duplicated cases 

## Identify and check the information of duplicated cases 

# dup <- sapply(id, function(i) any(duplicated(subset(x, SubjectID == i)$SubjectID)))       # identify duplicated cases by "SUBJECT"
#table(dup)


##-- Merge information of duplicated subjects

## Merge numerical variables 

x1 <- x
x1 <- aggregate(x[-c(1:3,21,22,27)], by=list(name=x$SubjectID), sum, na.rm = TRUE)
x1[x1==2] <- 1                   # Now there are some "2"s in the columns which need to be recode. This happened when the same person has more than one disease


names(x1)[names(x1)=="name"] <- "SubjectID"
x2 <- x[c(1:3,21,22,27)]


x <- merge(x1,x2,by=c("SubjectID"),all=TRUE)

# dup <- sapply(id, function(i) any(duplicated(subset(x, SubjectID == i)$SubjectID)))       # identify duplicated cases by "SUBJECT"
#table(dup)
# wi <- id[dup]                                 


## Merge categorical variables 

x$V_1419MOD <- NA

for(i in 1:length(id[dup])){
  x$V_1419MOD[x$SubjectID==id[dup][i]] <- paste(x$V_1419ND[x$SubjectID==id[dup][i]], collapse =" ")  
}

x1 <- subset(x, is.na(V_1419MOD))
x2 <- subset(x, !is.na(V_1419MOD))
x1$V_1419MOD <- x1$V_1419ND
#str(x1)
#str(x2)
x2$V_1419MOD <- as.factor(x2$V_1419MOD)
#str(x2)

x <- rbind(x1,x2)
#str(x)
x$V_1419MOD <- x$V_1419MOD[, drop = TRUE] 


# dup <- sapply(id, function(i) any(duplicated(subset(x, SubjectID == i)$SubjectID)))       # identify duplicated cases by "SUBJECT"
#table(dup)
# wi <- id[dup]                                 


## Recode levels of V_1419MOD

x$V_1419modl <- as.character(x$V_1419MOD)
x$V_1419modl[x$V_1419modl=="DAT ALS"] <- "ALS DAT"
x$V_1419modl[x$V_1419modl=="OTHER ALS"] <- "ALS OTHER"
x$V_1419modl[x$V_1419modl=="OTHER DAT"] <- "DAT OTHER"
x$V_1419modl[x$V_1419modl=="OTHER PARKINSON'S DISEASE"] <- "PARKINSON'S DISEASE OTHER"
x$V_1419modl[x$V_1419modl=="PARKINSON'S DISEASE ALS"] <- "ALS PARKINSON'S DISEASE"
x$V_1419modl[x$V_1419modl=="PARKINSON'S DISEASE DAT"] <- "DAT PARKINSON'S DISEASE"
x$V_1419modl <- x$V_1419modl[, drop = TRUE]


##-- Explore data with information in V_1287 


y <- subset(x, is.na(V_1419modl))
#table(x$V_1419modl, useNA="ifany")
x$V_1419modl[is.na(x$V_1419modl)] <- "ALS"
# x$V_1419modl <- as.factor(x$V_1419modl)
#table(x$V_1419modl, useNA="ifany")


##-- Delete duplicated cases 
x <- subset(x, !duplicated(SubjectID))


##-- Create a dataset with all the Subjects with Delta information 

### fill in missing family information (assuming "no" instead of NA)
s <- id[!(id %in% x$SubjectID)]                             #4838 - 512 = 4326; subjects with ALS score - subjects with FAM HX (the second one is a subset of the first one)
X <- matrix(NA, nrow = length(s), ncol = ncol(x) - 1)
colnames(X) <- colnames(x)[-1]
X <- as.data.frame(X)
X$FormID <- x$FormID[1]
X$SubjectID <- s
x <- rbind(x, X)

ff <- colnames(x)[!colnames(x) %in% c("SubjectID", "FormID", "Delta", "V_1419", "V_1420", "V_1419ND", "V_1419MOD", "V_1419modl", "V_1287")]
#colnames(x)
#ff
for (f in ff) {
  
  x[[f]][x[[f]]==0] <- NA
}
#table(x$V_1288,useNA="ifany")

# dup <- sapply(id, function(i) any(duplicated(subset(x, SubjectID == i)$SubjectID)))       # identify duplicated cases by "SUBJECT"


##-- Save the cleaned dataset

RALSclean[["Family History"]] <- x


#--- 2.5 - Clean up ALS History ------------------------------------------------------------------------#

x <- RALS[["Subject ALS History"]] 


##-- Explore the data 

## Frequency tables 

#str(x)
#View(x)        # To see the duplicated cases

### The column "Site of Onset" generates one new row for the same Subject, 
### many examples can be found at the beginning of the dataset
apply(x[-c(10,11,12,13,16,17)],2,table,useNA="ifany") 
apply(x["V_1247"],2,table,useNA="ifany")                     # OBS: 9 cases with ".", 1 case "Weakness"
apply(x["V_1248"],2,table,useNA="ifany")                     # OBS: We are not interested in this column
y <- subset(x,x["V_1248"]=="farciculation hands")            # OBS: Check this category - This category was classified in the V_1247-Symptom as "OTHER"
y <- subset(x,x["V_1248"]=="other")                          # OBS: Check this category


##-- Clean up some columns 

## Clean up factor levels of "Symptom" 

x$Symptoms <- factor(x$V_1247)
x$Symptoms[x$Symptoms == "."] <- NA
x$Symptoms[x$Symptoms == ""] <- NA
x$Symptoms[x$Symptoms == "Weakness"] <- "WEAKNESS"
x$Symptoms <- x$Symptoms[, drop = TRUE]
levels(x$Symptoms)                  

## Clean up factor levels of "Site of Onset"                 

### The column "Site of Onset" generates one new row for the same Subject, many examples can be found at the beginning of the dataset
levels(x$V_1416)
x$V_1416[x$V_1416 == ""] <- NA
x$V_1416 <- x$V_1416[, drop = TRUE]


##-- Save the complete data

RALScomp[["Subject ALS History"]] <- x


##-- Produce table with only SubjectID and Onset / OnsetSite

x1 <- x[!is.na(x$V_1417), c("SubjectID", "V_1417")]
names(x1)[2] <- "Onset"
#table(x1$Onset, useNA="ifany")           ### There are 10 missing values in Onset. THIS WAS VERIFIED IN THE XLS FILE

x1 <- x1[!duplicated(x1$SubjectID),]
#idx1 <- unique(x1$SubjectID)
#length(idx1)
x2 <- x[!is.na(x$V_1416), c("SubjectID", "V_1416")]
names(x2)[2] <- "OnsetSite"


### long format symptoms to wide format
x3 <- x[!is.na(x$Symptoms), c("SubjectID", "Symptoms")]

X <- model.matrix(~ Symptoms - 1, data = x3)                  # Create a matrix in which the columns are the symptoms
ind <- split(1:nrow(X), x3$SubjectID)


Y <- matrix(0, nrow = length(id), ncol = nlevels(x3$Symptoms))
for (i in 1:length(ind)) 
  Y[names(ind)[i] == id,] <- 
  as.integer(colSums(X[ind[[i]],,drop = FALSE]) > 0)
colnames(Y) <- levels(x3$Symptoms)
Y <- as.data.frame(Y)
Y <- lapply(Y, function(x) factor(x, labels = c("no", "yes")))
Y <- as.data.frame(Y)
Y$SubjectID <- id

### merge Onset / OnsetSite / Symptoms
tmp <- merge(merge(x1, x2, by = "SubjectID", all=T), Y, by = "SubjectID", all=T)


## Check missing data of Symptoms, Onset and OnsetSite

w <- subset(tmp, is.na(Onset))
idOnsetna <- unique(w$SubjectID)                 ### These subjects do not have Onset in the xls file 
y1 <- subset(x,SubjectID==idOnsetna[1])
for(i in 2:length(idOnsetna)){
  tmpy <- subset(x,SubjectID==idOnsetna[i])
  y1 <- rbind(y1,tmpy)
}
y2 <- subset(Y,SubjectID==idOnsetna[1])
for(i in 2:length(idOnsetna)){
  tmpy <- subset(Y,SubjectID==idOnsetna[i])
  y2 <- rbind(y2,tmpy)
}
y3 <- subset(Y, SubjectID==idOnsetna[1])
y4 <- subset(x3, SubjectID==idOnsetna[1])


##-- Save the cleaned tables
RALSclean[["Subject ALS History"]] <- x
RALSclean[["Medical History"]] <- tmp


#--- 2.6 - Clean up Forced Vital Capacity --------------------------------------------------------------#

x <- RALS[["Forced Vital Capacity"]]


##-- Clean up 

## ---- V_1185

#table(x$V_1185, useNA="ifany")
x$V_1185MOD <- x$V_1185
x$V_1185MOD[x$V_1185MOD==""] <- NA
x$V_1185MOD[x$V_1185MOD==". 0"] <- 0
x$V_1185MOD[x$V_1185MOD=="X.XX"] <- NA
x$V_1185MOD[grep("%", x$V_1185MOD)] <- NA
x$V_1185MOD <- x$V_1185MOD[, drop = TRUE]
#table(x$V_1185MOD, useNA="ifany")
x$V_1185NUM <- as.numeric(as.character(x$V_1185MOD))         

## ---- V_1188

#table(x$V_1188, useNA="ifany")
x$V_1188MOD <- x$V_1188
x$V_1188MOD[x$V_1188MOD==82] <- NA                   ### Mistake (only 1 case)


##-- Save the complete dataset

### This dataset has duplicated cases (by delta). There are NAs in delta.
RALScomp[["Forced Vital Capacity"]] <- x

x <- subset(x, !is.na(V_1185NUM))

#summary(x$Delta)
x <- subset(x, !is.na(Delta))


##-- Explore duplicated cases

# dup <- sapply(id, function(i) any(duplicated(subset(x, SubjectID == i)$Delta)))       # identify duplicated cases by "Delta"
#table(dup)
# wi <- id[dup]      

# dupx <- sapply(id, function(i) any(duplicated(subset(x, SubjectID == i))))             # identify duplicated cases by all the columns

### <FIXME> there are duplicated SubjectIDs but with different values ...</FIXME>
### <FIXME> which ones are correct??? </FIXME>

### Solution: DELETE THEM. CHECK THE NUMBER OF CASES WITH RESPECT TO THE TOTAL
### In total 42 cases with different information 

x <- subset(x, !duplicated(paste(SubjectID, Delta)))


##-- Save the cleaned dataset

RALSclean[["Forced Vital Capacity"]] <- x


#--- 2.7 - Clean up Vital Signs ------------------------------------------------------------------------#

x <- RALS[["Vital Signs"]]


y <- subset(x,V_1177==98.60000)                            ### Maximum value 98.60 - Temperature without units 


##-- Clean up the data 

## ---- TEMPERATURE 

x$temperature  <- x$V_1177

x$temperature[x$temperature==98.60000] <- (98.60000-32)*(5/9) 

x$V_1170[x$V_1170 == ""] <- NA
x$V_1170[x$V_1170 == "ND"] <- NA
x$V_1169[x$V_1169 == ""] <- NA
x$V_1169[x$V_1169 == "ND"] <- NA
x$V_1170NUM <- as.numeric(as.character(x$V_1170))
x$V_1169NUM <- as.numeric(as.character(x$V_1169))

## ---- HEIGHT 

### height is not time varying - COVERT UNITS             
x$V_1171 <- as.numeric(as.character(x$V_1171))
height <- subset(x, !is.na(V_1171))[, c("SubjectID", "V_1171", "V_1181")]
height <- subset(height, !duplicated(SubjectID))
#table(height$V_1181, useNA="ifany")
height$Height <- with(height, ifelse(V_1181 == "Inches", V_1171 * 2.54, V_1171))
height$V_1181 <- height$V_1171 <- NULL
RALScomp[["Demographics"]] <- merge(RALScomp[["Demographics"]], height, "SubjectID", all = TRUE)

## ---- WEIGHT

## Convert weight units 

#table(x$V_1180, useNA="ifany")
x$V_1178 <- as.numeric(as.character(x$V_1178))
x$weight <- with(x, ifelse(V_1180 == "Pounds", V_1178 * 0.45359236999999997, V_1178))
#x$V_1180 <- x$V_1178 <- NULL

RALScomp[["Vital Signs"]] <- x


##-- Save height in dataset "Demographics" cleaned 

height <- subset(x, !is.na(V_1171))[, c("SubjectID", "V_1171", "V_1181")]
height <- subset(height, !duplicated(SubjectID))

height$Height <- with(height, ifelse(V_1181 == "Inches", V_1171 * 2.54, V_1171))
height$V_1181 <- height$V_1171 <- NULL
RALSclean[["Demographics"]] <- merge(RALSclean[["Demographics"]], height, "SubjectID", all = TRUE)


##-- Debug useless rows and duplicated cases  

### remove height and height units 
x$V_1171 <- x$V_1181 <- NULL

### remove complete useless rows
x <- subset(x, rowSums(is.na(x)) < length(x)-10)       # 10 = 8 (categorical columns) + 1(SubjectID) + 1(FormID)


### e.g. Good criteria to delete these duplicated cases 
w1 <- subset(x, SubjectID==3551)
w2 <- subset(x, SubjectID==2956)

x <- subset(x, !duplicated(paste(SubjectID, Delta)))

### e.g. Good criteria to delete these duplicated cases 
w3 <- subset(x, SubjectID==3551)
w4 <- subset(x, SubjectID==2956)


##-- Save the cleaned dataset

RALSclean[["Vital Signs"]] <- x


#--- 2.8 - Clean up Slow Vital Signs -------------------------------------------------------------------#

x <- RALS[["Slow Vital Capacity"]]


##-- Save the complete dataset

#y <- subset(x, is.na(Delta))
RALScomp[["Slow Vital Capacity"]] <- x


##-- Eliminate rows with NA in V_1262 - Subject Liters (Trial 1)

x <- subset(x, !is.na(V_1262))


##-- Eliminate rows without Delta information   # OBS: JUSTIFICATION - Longitudinal data

#summary(x$Delta)
x <- subset(x, !is.na(Delta))

### THERE ARE NOT DUPLICATED CASES BY DELTA 
# dup <- sapply(id, function(i) any(duplicated(subset(x, SubjectID == i)$Delta)))       # identify duplicated cases by "Delta"


##-- Save the cleaned data

RALSclean[["Slow Vital Capacity"]] <- x


#--- 2.9 - Clean up Treatment --------------------------------------------------------------------------#

x <- RALS[["Treatment Group"]]


##-- Check duplicated cases - THERE ARE NOT DUPLICATED CASES

idx <- unique(x$SubjectID) 

# dup <- sapply(idx, function(i) any(duplicated(subset(x, SubjectID == i)$SubjectID)))       # identify duplicated cases by "subject"
#table(dup)


##-- Save the complete dataset

RALScomp[["Treatment Group"]] <- x


##-- Save the cleaned data

RALSclean[["Treatment Group"]] <- x


#--- 2.10 - Clean up RILUZOLE --------------------------------------------------------------------------#

#names(RALSclean)
x <- RALS[["Riluzole use"]]

##-- Check duplicated cases

### THERE ARE NOT DUPLICATED CASES
idx <- unique(x$SubjectID) 


##-- Save the complete dataset

RALScomp[["Riluzole use"]] <- x


##-- Clean useless columns


x$"Riluzole use Day 0" <- x$"Riluzole use Date"  <- NULL
#str(x)


##-- Save the cleaned data
RALSclean[["Riluzole use"]] <- x


#--- 2.11 - Clean up Death Report ----------------------------------------------------------------------#

x <- RALS[["Death Report"]]

##-- Check duplicated cases

idx <- unique(x$SubjectID) 

# dup <- sapply(idx, function(i) any(duplicated(subset(x, SubjectID == i)$SubjectID)))       # identify duplicated cases by "subject"
#table(dup)

# wi <- idx[dup]                                 

### ALL THESE DUPLICATED SUBJECTS HAVE THE SAME INFORMATION IN DIFFERENT ROWS


##-- Save the complete dataset

RALScomp[["Death Report"]] <- x


##-- Eliminate duplicated cases 

x <- subset(x, !duplicated(SubjectID))


##-- Check duplicated cases

# dup <- sapply(id, function(i) any(duplicated(subset(x, SubjectID == i)$SubjectID)))       # identify duplicated cases by "subject"


##-- Save the cleaned data

RALSclean[["Death Report"]] <- x

cat("first part done, three to go\n")


###############################################################################
############## CleanupLabs_finalHS: cleaning up the laboratory data
###############################################################################


#--- 2.3 - Clean up Labs -------------------------------------------------------------------------------#


u <- RALSclean[["ALSFRS(R)"]] 
id <- unique(u$SubjectID) 
x <- RALS[["Laboratory Data"]]



##-- Clean up substances' labels

### actually Urine Urea and Blood Urea Nitrogen (BUN) are the same
x$V_1250MOD <- x$V_1250
x$V_1250MOD[x$V_1250MOD == "Urine Urea"] <- "Blood Urea Nitrogen (BUN)"

#str(x)
x$V_1250MOD <- factor(x$V_1250MOD)
#str(x)


##-- Identify substances with at least 40% of the information 

a <- xtabs(~ SubjectID + V_1250MOD, data = x)

p <- colMeans(a > 0) ### % subjects with at least one measurement
#p <- colSums(a > 0) 

### substances with at least 40% of the subjects having at least one measurement
tselect <- names(p)[p > .4]          


##-- Clean up numeric values 

### clean up numeric values 
### <FIXME> ignore censoring for the time being </FIXME>


## Verify the presence of "," 
wi <- grep(",", x$V_1251)


x$V_1251MOD <- gsub(",", "", x$V_1251)


x$V_1251MOD <- as.factor(x$V_1251MOD)


## Verify the presence of "<" 
wi <- grep("[<]", x$V_1251)

x$V_1251MOD[x$V_1250=="Bilirubin (Total)" & x$V_1251=="<0.2"] <- NA


x$V_1251MOD <- as.factor(x$V_1251MOD)
#str(x)
x$V_1251MOD <- x$V_1251MOD[, drop = TRUE] 



##-- Delete rows with missing values in V_1251

x <- subset(x, !is.na(V_1251MOD))


suppressWarnings(x$V_1251NUM <- as.numeric(as.character(x$V_1251)))


#x$V_1251NUM <- as.numeric(levels(x$V_1251MOD))[x$V_1251MOD]
#str(x)
x$V_1251FAC <- x$V_1251MOD

x$V_1251FAC[!is.na(x$V_1251NUM)] <- NA
x$V_1251FAC <- as.factor(x$V_1251FAC)
#str(x)
x$V_1251FAC <- x$V_1251FAC[, drop = TRUE] 


## Verify the presence of "-" for the last subject identified      

s <- subset(x, V_1251NUM==V_1251NUM[wi[1]])
for (i in 2:length(wi)){
  s <- rbind(s,subset(x, V_1251NUM==V_1251NUM[wi[i]]))
}


##-- Clean up units 


x$V_1252MOD <- tolower(x$V_1252)


x$V_1252MOD[x$V_1252MOD == "x10e12/l"] <- "10e12/l"


x$V_1252MOD <- factor(tolower(x$V_1252MOD))



##-- Explore and clean up the substances selected

## ---- "ABSOLUTE BASOPHIL COUNT"

x$V_1252MOD[which(x$V_1250MOD == "Absolute Basophil Count" & x$V_1252MOD == "10e12/l")] <- "10e9/l"


## ---- "ALBUMIN"

x$V_1252MOD[which(x$V_1250MOD == "Albumin" & x$V_1252MOD == "%")] <- "g/l"


### Solution: THE CASES WERE DIVIDED BY 1000

x$V_1251num <- with(x, ifelse(V_1250MOD == "Platelets" & V_1251NUM > 100000, V_1251NUM/1000, V_1251NUM))

x$V_1252MOD[which(x$V_1250MOD == "Platelets" & x$V_1252MOD == "")] <- "10e9/l"


### Data 
s <- subset(x, V_1250MOD== "Red Blood Cells (RBC)")
ids  <- unique(s$SubjectID) 


### Duplicated cases
d <- subset(s, duplicated(paste(SubjectID, Delta)))
idd <- unique(d$SubjectID) 
### There are 1635 duplicated subjects 


### Solution:  COVERT UNITS TO 10E9/L TO 10E12/L DIVIDING BY 1000
x$V_1251num <- with(x, ifelse(V_1250MOD == "Red Blood Cells (RBC)" & V_1252MOD =="10e9/l" & V_1251NUM > 999 & V_1251NUM < 10000, V_1251num/1000, V_1251num))


### Solution:  COVERT UNITS TO 10E9/L TO 10E12/L DIVIDING BY 1000. WOULD BE OK, EVEN WHEN THE VALUES SEEM TO BE HIGH
x$V_1251num <- with(x, ifelse(V_1250MOD == "Red Blood Cells (RBC)" & V_1252MOD =="10e9/l" & V_1251NUM > 9999 & V_1251NUM < 100000, V_1251num/1000, V_1251num))


### Solution:  COVERT VALUES DIVIDING BY 1000000
x$V_1251num <- with(x, ifelse(V_1250MOD == "Red Blood Cells (RBC)" & V_1252MOD =="10e9/l" & V_1251NUM > 999999 & V_1251NUM < 10000000, V_1251num/1000000, V_1251num))
z <- subset(x, x$V_1250MOD == "Red Blood Cells (RBC)" & x$V_1251NUM > 999999 & x$V_1251NUM < 10000000)


### Cases between 3.33e+09 and 5.76e+09. TOTAL=281
z <- subset(x, x$V_1250MOD == "Red Blood Cells (RBC)" & x$V_1251NUM > 999999999 & x$V_1251NUM < 10000000000)

### Solution:  COVERT VALUES DIVIDING BY 1000000000
x$V_1251num <- with(x, ifelse(V_1250MOD == "Red Blood Cells (RBC)" & V_1252MOD =="10e9/l" & V_1251NUM > 999999999 & V_1251NUM < 10000000000, V_1251num/1000000000, V_1251num))
z <- subset(x, x$V_1250MOD == "Red Blood Cells (RBC)" & x$V_1251NUM > 999999999 & x$V_1251NUM < 10000000000)


y <- subset(x, V_1250MOD == "Red Blood Cells (RBC)" & V_1251NUM == 500)  # There are 174 subjects with RCB=500 
idy <- unique(y$SubjectID)

### Solution:  1. REMOVE RBC=500, EXCEPT THE 3 SUBJECTS WHERE THE VALUE 500 DOES NOT HAVE A DUPLICATED CASE 
###            2. DIVIDE THE REMAINING CASES BY 100 

### Subtitute 500 by NA
x$V_1251num[which(x$V_1250MOD == "Red Blood Cells (RBC)" & x$V_1251NUM == 500)] <- NA


### Leave value 5 in the exceptional cases (4 cases in total)
idex <- c(445636, 609564, 985781)

for(i in idex){
  x$V_1251num <- with(x, ifelse(V_1250MOD == "Red Blood Cells (RBC)" & V_1251NUM == 500 & SubjectID==i, 5, V_1251num))
}


#### Solution: CHANGE THE LABEL OF THE UNITS COLUMN TO 10E12/L. THIS APPLIES TO ALL THE PREVIOUS CHANGES 
x$V_1252MOD[which(x$V_1250MOD == "Red Blood Cells (RBC)" & x$V_1252MOD == "10e9/l")] <- "10e12/l"



y <- subset(x, V_1250MOD == "White Blood Cell (WBC)" & V_1252MOD =="10e9/l" & x$V_1251num > 1000)
x$V_1251num <- with(x, ifelse(V_1250MOD == "White Blood Cell (WBC)" & V_1252MOD =="10e9/l" & V_1251num > 1000, V_1251num/1000, V_1251num))
y <- subset(x, V_1250MOD == "White Blood Cell (WBC)" & V_1252MOD =="10e9/l" & x$V_1251NUM > 1000)

x$V_1252MOD[which(x$V_1250MOD == "White Blood Cell (WBC)" & x$V_1252MOD == "")] <- "10e9/l"


### VERY SIMILAR TO THE NUMBER OF DUPLICATED CASES IN RBC
idwbc <- unique(s$SubjectID)
# dup <- sapply(idwbc, function(i) any(duplicated(subset(s, SubjectID == i)$Delta))) 


x$V_1252MOD[which(x$V_1250MOD == "Creatine Kinase MB" & x$V_1252MOD == "u/l")] <- "%"


x$V_1252MOD[which(x$V_1250MOD == "Creatine Kinase MM" & x$V_1252MOD == "u/l")] <- "%"


x$V_1252MOD[which(x$V_1250MOD == "Mean Corpuscular Hemoglobin" & x$V_1252MOD == "pg")] <- "pg/cell"


x$V_1252MOD[which(x$V_1250MOD == "Prothrombin Time (clotting)" & x$V_1252MOD == "%")] <- "seconds"


x$V_1252MOD[which(x$V_1250MOD == "Urine Granular Cast" & x$V_1252MOD == "")] <- "/hpf"



RALScomp[["Laboratory Data"]] <- x


##-- Eliminate rows without Delta

### no time information
x <- subset(x, !is.na(Delta))


##-- Eliminate rows without Test Result (THESE ROWS ARE THOSE WHERE RBC=500 WERE REMOVED)

x <- subset(x, !(is.na(V_1251num) & is.na(V_1251FAC)))


##-- Eliminate duplicated cases 

### only subjects with ALS scores
x <- subset(x, SubjectID %in% id)


##-- Obtain one table per substance 

idtest <- unique(x$V_1250)

idtestMOD <- unique(x$V_1250MOD)


### one table per substance
tests <- as.character(unique(x$V_1250MOD[, drop = TRUE]))

lab <- vector(mode = "list", length = length(tests))
names(lab) <- tests
#str(lab)
for (tt in tests) {
  tmp <- subset(x, V_1250MOD == tt)
  tmp$V_1252MOD <- tmp$V_1252MOD[, drop = TRUE]
  unit <- tmp$V_1252MOD
  # if (length(unique(unit)) > 1)
  #    cat(tt, "units: ", unique(as.character(unit)), "\n")
  
  ### <FIXME> remove duplicates here? </FIXME>
  ### merge at the end will explode...
  i <- with(tmp, paste(SubjectID, Delta, sep = "_"))
  tmp <- tmp[!duplicated(i),]
  
  ### produce valid variable names
  tname <- gsub(" ", "_", tt)
  tname <- gsub("-", "_", tname)
  tname <- gsub("\\(", "", tname)
  tname <- gsub("\\)", "", tname)
  #    if (tt %in% tselect) {
  names(tmp)[names(tmp) == "V_1251num"] <- paste("Value", tname, sep = "_")
  names(tmp)[names(tmp) == "V_1251FAC"] <- paste("Category", tname, sep = "_")
  names(tmp)[names(tmp) == "V_1252MOD"] <- paste("Unit", tname, sep = "_")
  #    } else {
  #        tmp$V_1251 <- TRUE
  #        names(tmp)[names(tmp) == "V_1251"] <- paste(tname, "DONE", sep = "")
  #    }
  tmp$V_1250 <- tmp$V_1250MOD <- NULL
  tmp$V_1251 <- tmp$V_1251MOD <- tmp$V_1251NUM <- NULL
  tmp$V_1252 <- NULL
  tmp$FormID <- NULL
  
  lab[[tt]] <- tmp
}

lab <- lab[sapply(lab, function(x) length(unique(x$SubjectID)) > 100)]


##-- Merge data for substances with more than 100 measurements 

### merge laboratory data into one data.frame
### but only for substances with > 100 measurements
ind <- which(sapply(lab, nrow) > 100)

x <- lab[[ind[1]]]
for (i in ind[-1]) {
  x <- merge(x, lab[[i]], by = c("SubjectID", "Delta"), all = TRUE)
}
idx <- unique(x$SubjectID)


##-- Save the cleaned data

## save raw lab data
RALSclean[["Raw Laboratory Data"]] <- lab

## save lab data 
RALSclean[["Laboratory Data"]] <- x


cat("second part done, two to go\n")

###################################################################
#################### descr_data: finalizing data (right scale etc)
###################################################################
library("plyr")

## ----Overview------------------------------------------------------------
names(RALSclean) <- gsub(" ", "_", names(RALSclean))
names(RALSclean)[names(RALSclean) == "ALSFRS(R)"] <- "ALSFRS_R"

# RALSclean$Raw_Laboratory_Data <- NULL

RALSclean$Riluzole_use$SubjectID <- as.numeric(as.character(RALSclean$Riluzole_use$SubjectID))
RALSclean$Death_Report$SubjectID <- as.numeric(as.character(RALSclean$Death_Report$SubjectID))


## ----Treatment-----------------------------------------------------------
RALSclean$Riluzole_use$V_1461 <- factor(RALSclean$Riluzole_use$V_1461)


## ----Death_Report--------------------------------------------------------
RALSclean$Death_Report$V_1465 <- factor(RALSclean$Death_Report$V_1465)

### find maximum Delta in datasets and include it as censored observation
### for patients without observed survival time
### use RALScomp for this (more information)
deltanumeric <- function(x) {
  if(is.factor(x$Delta))
    x$Delta <- as.numeric(as.character(x$Delta))
  return(x)
}

RALScomp <- llply(RALScomp, deltanumeric)
RALSclean <- llply(RALSclean, deltanumeric)


getmaxdelta <-  function(a) {
  if(is.null(a$Delta) || is.na(a$Delta)) NA else max(a$Delta, na.rm = TRUE)
} 

deltas <- ldply(RALScomp, function(x) {
  ddply(x, .(SubjectID), getmaxdelta)
})

names(deltas)[names(deltas) == "V1"] <- "Delta"
max.deltas <- ddply(deltas, .(SubjectID), function(a)  
  if(is.null(a$Delta)) data.frame(set = NA, maxDelta = NaN) else {
    maxD <- max(a$Delta, na.rm = TRUE)
    maxD.id <- which.max(a$Delta)
    data.frame(set = a$.id[maxD.id], maxDelta = maxD)
  }
)

# summary(max.deltas)
dr <- merge(RALSclean$Death_Report, max.deltas, by = "SubjectID", all = TRUE)
dr$V_1465[is.na(dr$V_1465)] <- "No"
dr$V_1466[dr$V_1465 == "No"] <- dr$maxDelta[dr$V_1465 == "No"]

## check logic
(str.surv <- dr[which(dr$V_1466 < dr$maxDelta), ])

RALSclean$Death_Report <- dr

cat("third part done, one to go\n")

###################################################################
#################### ALS_data_management.R
###################################################################
library("dplyr")

datl <- RALSclean

#######-------------- Basis Data Set ---------------------------------------
##'should contain:
##' t.onsettrt: time between ALS onset and treatment start
##' V_i.Start: ALS score i at treatment start
##' V_i.halfYearAfter: ALS score six month after treatment start

#######-------------- ALSFRS ---------------------------------------
als <- datl$ALSFRS_R
scorevars <- paste0("V_", c(1213:1223, 1230:1232))

## delete .5 values (they are imputated)
is.integernumber <- function(x, tol = .Machine$double.eps^0.5)  abs(x - round(x)) < tol
p5toNA <- function(x) {
  x[!is.integernumber(x)] <- NA
  x
}
als[ ,scorevars] <- als[ ,scorevars] %>% mutate_each(funs(p5toNA)) %>% mutate_each(funs(as.ordered))

## make one variable out of V_1218 and V_1219
als$V_121.8.9 <- als$V_1218
als$V_121.8.9[is.na(als$V_121.8.9)] <- als$V_1219[is.na(als$V_121.8.9)]
datl$ALSFRS_R <- als



### Get (unique) Diagnosis and Onset Delta for each Patient
### Needed because of multiple rows for patients in history data set
histr <- datl$Subject_ALS_History
#plot(table(histr$SubjectID))
names(table(histr$SubjectID)[table(histr$SubjectID) == 4])

histr <- subset(histr, select = c(SubjectID, V_1418, V_1417))
histr <- unique(histr)
bothvNA <- is.na(histr$V_1418) & is.na(histr$V_1417)
histr <- histr[!bothvNA, ]
length(unique(histr$SubjectID))


#### Scores, Diagnosis Delta and Treatment needed
dat.diagtrt <- merge(histr, datl$Riluzole_use, by = "SubjectID", all = TRUE)
dat.diagtrt <- subset(dat.diagtrt, select = c(SubjectID, V_1418, V_1417, Delta, V_1461))
names(dat.diagtrt)[grep("_", names(dat.diagtrt))] <- c("DiagnosisDelta", "OnsetDelta", "Riluzole")
names(dat.diagtrt)[names(dat.diagtrt) == "Delta"] <- "RiluzoleDelta"
dat.diagtrt$DiagnosisDelta <- as.numeric(as.character(dat.diagtrt$DiagnosisDelta))
dat.diagtrt$OnsetDelta <- as.numeric(as.character(dat.diagtrt$OnsetDelta))
dat.diagtrt$t.diagtrt <- dat.diagtrt$RiluzoleDelta - dat.diagtrt$DiagnosisDelta
dat.diagtrt$t.onsettrt <- dat.diagtrt$RiluzoleDelta - dat.diagtrt$OnsetDelta


#### merge Delta-Dataset with ALS Scores
dat <- merge(dat.diagtrt, datl$ALSFRS_R, by = "SubjectID")

#### Find ALS Score of Treatment start and 6 months later (approximately; 20 days +- is okay)
## 6 months after Treatment start
dat$halfYearAfter <- dat$RiluzoleDelta + 183

get.bestFitToTime <- function(x, time = "halfYearAfter") {
  # compute absolute differences 
  diffs <- abs(x$Delta - x[ , time])
  
  # only look, if there are non-missing values and differences smaller than 20 days
  if((sum(!is.na(diffs)) > 0) && (min(diffs, na.rm = TRUE) < 20)){
    # look for the smallest difference and return row
    min.diff <- which.min(diffs)
    x[min.diff, ]
  } else NULL
}

dat.halfYearAfter <- ddply(dat, .(SubjectID), get.bestFitToTime)

## Day of treatment Start
dat.Start <- ddply(dat, .(SubjectID), get.bestFitToTime, time = "RiluzoleDelta")

#### data set with ALS Info of the Patient at treatment start and 6 months later
data <- merge(dat.Start, dat.halfYearAfter, all = TRUE, by = names(dat.diagtrt))

names(data) <- gsub(".x", ".Start",  names(data))
names(data) <- gsub(".y", ".halfYearAfter",  names(data))


del <- c("FormID", "Mode of Administration", "ALSFRS Responded", 
         "V_121819", "V_121430", "halfYearAfter.",
         "DiagnosisDelta", "OnsetDelta", "Delta.")
delind <- grepl(paste0(del, collapse = "|"), names(data))
data <- data[ , !(delind)]



#######-------------- Demographics ---------------------------------------
demog <- datl$Demographics[ , c("SubjectID", "Race", "Sex", "Age", "Height")]

data <- merge(data, demog, by = "SubjectID", all = TRUE)



#######-------------- Medical History ---------------------------------------
med <- datl$Medical_History
med$Onset <- NULL

data <- merge(data, med, by = "SubjectID", all = TRUE)



#######-------------- Family History ---------------------------------------
fam <- datl$Family_History

### are there cases in an older generation, the same generation or a younger generation
older <- paste0("V_", c(1288, 1289, 1290, 1294, 1295, 1296, 1297,
                        1298, 1299, 1300, 1301, 1311, 1312, 1313))
same <- paste0("V_", c(1291:1293, 1309, 1426, 1427))
younger <- paste0("V_", c(1302, 1305, 1424, 1425))

are.cases <- function(fam, members) {
  res <- as.numeric(rowSums(fam[ , names(fam) %in% members], na.rm = TRUE) > 0)
  factor(res, labels = c("no", "yes"))
}

fam$fam.hist.older <- are.cases(fam, older)
fam$fam.hist.same <- are.cases(fam, same)
fam$fam.hist.younger <- are.cases(fam, younger)


fam <- subset(fam, select = c(SubjectID, fam.hist.older, fam.hist.same, fam.hist.younger, V_1419modl)) ##! V_1419 concerns the patient
names(fam)[names(fam) == "V_1419modl"] <- "NeurologicalDisease"
data <- merge(data, fam, by = "SubjectID", all = TRUE)



#######-------------- Vital Signs ---------------------------------------
vit <- datl$Vital_Signs
dlt <- data[ , c("SubjectID", "RiluzoleDelta")]
vit <- merge(vit, dlt, by = "SubjectID", all = TRUE)

vit <- ddply(vit, .(SubjectID), get.bestFitToTime, time = "RiluzoleDelta")
vit <- subset(vit, select = c(SubjectID, temperature, V_1170NUM, V_1169NUM, weight))
names(vit)[names(vit) %in% c("V_1170NUM", "V_1169NUM")] <- c("BP_diastolic", "BP_systolic")
data <- merge(data, vit, by = "SubjectID", all = TRUE)



#######-------------- Treatment Group ---------------------------------------
trt <- subset(datl$Treatment_Group, select = -FormID)
names(trt)[names(trt) == "V_1454"] <- "treatment.group"
names(trt)[names(trt) == "Delta"] <- "treatment.group.Delta"

data <- merge(data, trt, by = "SubjectID", all = TRUE)




#######-------------- SVC ---------------------------------------
svc <- subset(datl$Slow_Vital_Capacity, select = c(SubjectID, Delta, V_1262))

svc <- merge(svc, dlt, by = "SubjectID", all.x = TRUE)
svc <- ddply(svc, .(SubjectID), get.bestFitToTime, time = "RiluzoleDelta")
svc$RiluzoleDelta <- NULL

names(svc)[names(svc) %in% c("V_1262")] <- c("SubjectLiters_svc")
svc$Delta <- NULL
data <- merge(data, svc, by = "SubjectID", all = TRUE)


#######-------------- FVC ---------------------------------------
fvc <- subset(datl$Forced_Vital_Capacity, select = c(SubjectID, Delta, V_1185NUM, V_1188MOD))

fvc <- merge(fvc, dlt, by = "SubjectID", all.x = TRUE)
fvc <- ddply(fvc, .(SubjectID), get.bestFitToTime, time = "RiluzoleDelta")
fvc$RiluzoleDelta <- NULL

names(fvc)[names(fvc) %in% c( "V_1185NUM", "V_1188MOD")] <- c("SubjectLiters_fvc", "SubjectNormal_fvc")
fvc$Delta <- NULL
data <- merge(data, fvc, by = "SubjectID", all = TRUE)




#######-------------- Laboratory Data ---------------------------------------
lab <- datl$Laboratory_Data
# colSums(is.na(lab))
del <- grep("Unit|Category", names(lab))
lab <- lab[,-del]

lab <- merge(lab, dlt, by = "SubjectID", all.x = TRUE)
lab <- ddply(lab, .(SubjectID), get.bestFitToTime, time = "RiluzoleDelta")
lab$RiluzoleDelta <- NULL
lab$Delta <- NULL

data <- merge(data, lab, by = "SubjectID", all = TRUE)



#######-------------- Death report ---------------------------------------
surv <- subset(datl$Death_Report, select = -c(FormID, set, maxDelta))
head(surv, 30)
names(surv) <- c("SubjectID", "cens", "survival.time")
surv$cens <- as.numeric(surv$cens == "Yes") 

data <- merge(data, surv, by = "SubjectID", all.x = TRUE)

### delete observations with survival < Delta
dr <- datl$Death_Report
dr <- dr[(dr$V_1466 < dr$maxDelta) & !is.na(dr$V_1466), ]
drid <- dr$SubjectID
data <- data[!(data$SubjectID %in% drid), ]



### checking all variables for right scale (numeric, factor)
facs <- sapply(data, is.factor)
data$Age <- as.numeric(as.character(data$Age))
data$temperature <- as.numeric(as.character(data$temperature))
data$ALSFRS.Start <- as.numeric(as.character(data$ALSFRS.Start))
data$ALSFRS.halfYearAfter <- as.numeric(as.character(data$ALSFRS.halfYearAfter))


setwd(wdbase)

save(data, file = paste0(outfolder, "RALSfinal.rda"))
save(RALSclean, file = paste0(outfolder, "RALSfinal_list.rda"))

cat(paste("\n
          Your data files are called RALSfinal.rda and RALSfinal_list.rda.
          Read them into R using function read().\n"))

# Function for simulating an environmental factor
################################################################################
library("fields")
library("mvtnorm")

px <- 10
py <- 10

xy <- expand.grid(x= 1:px, y= 1:py)
dists <- as.matrix(dist(xy, method= "euclidian", diag= TRUE, upper= TRUE))
P <- Matern(dists, scale= 1, range= 1)
set.seed(124)
x <- rmvnorm(1, mean= seq(1, 2, length.out= px*py), sigma= 0.25 * P)
envir <- as.vector(x)

# See 'simModel11.R' for a short explanation
id <- "12bin"
mod <- paste("simModel", id, sep= "")

library("lme4")
library("mvtnorm")
library("fields")

source("../R/psglmm.R")
source("../R/psglmmSim.R")
source("../R/makeData.R")
source("../R/makeEnvir.R")

nsim= 100
formula= y ~ spp - 1 + (spp - 1 | plot) + (spp - 1 | plot) + (spp - 1 | plot)
VCVtmp= list("phylogenetic"= kron("I_p", "S"), "spatial"= kron("P", "I_s"), 
  "spatio-phylogenetic"= kron("P", "S"))
gf= c("plot", "plot", "plot")
px= 10
py= 10
s= 4
spp.fe= seq(-1, 1, length.out= s)
rho= seq(0, 0.98, 0.02)
var.spp= 0
var.plot= 1
var.ind= 0
var.error= 0
x= FALSE
msel= "BS"
family= binomial()
P.lim= 0.1

seeds <- 1:length(rho)
for(i in 1:length(rho)) {
  set.seed(seeds[i])
  cat(paste("seed:", seeds[i], "\n"))
  sims <- psglmmSim(nsim, formula, VCVtmp, px, py, s, spp.fe, rho12= rho[i], 
    var.spp, var.plot, var.ind, var.error, x, family, gf, msel, envir, P.lim)
  save(sims, file= paste("sims/", mod, "_", i, ".Rdata", sep=""))
  cat("Data saved\n")
  rm(sims)
}

## ----setup, results = "hide", echo = FALSE, message = FALSE, warnings = FALSE----
set.seed(290875)

load(system.file("rda", "bloodloss.rda", package = "TH.data"))

### some packages
library("trtf")
library("tram")
library("rms")
library("coin")
library("survival")
library("ATR")
library("multcomp")
library("gridExtra")
library("vcd")
library("colorspace")
library("lattice")
tcols <- diverge_hcl(50, h = c(246, 40), c = 96, l = c(65, 90), alpha = .5)
cols <- qualitative_hcl(3, palette = "Harmonic")
vR <- paste(R.Version()$major, R.Version()$minor, sep = ".")
vtram <- packageDescription("tram")$Version
vtrtf <- packageDescription("trtf")$Version
### plot setup
trellis.par.set(list(plot.symbol = list(col="black", cex = .75),
                     box.rectangle = list(col=1),
                     box.umbrella = list(lty=1, col=1),
                     strip.background = list(col = "white")))
ltheme <- canonical.theme(color = FALSE)     ## in-built B&W theme
ltheme$strip.background$col <- "transparent" ## change strip bg
lattice.options(default.theme = ltheme)

frmt1 <- function(x) formatC(round(x, 1), digits = 1, format = "f") 
frmt3 <- function(x) {
    if (!is.numeric(x)) return(x)
    formatC(round(x, 3), digits = 3, format = "f") 
}

### tree plots
ctrl <- ctree_control(alpha = 0.05, minbucket = 50,
                      teststat = "max", splitstat = "max", maxsurrogate = 3)

en <- function(obj, col = "black", bg = "white", fill = "transparent",
                     ylines = 2, id = TRUE, mainlab = NULL, gp = gpar(), K = 20,
                     type = c("trafo", "distribution", "survivor",  
                              "density", "logdensity", "hazard",
                              "loghazard", "cumhazard", "quantile"),
                     flip = FALSE, axes = TRUE, xaxis = NULL, ...)
{

    ### panel function for ecdf in nodes
    rval <- function(node) {

        nid <- id_node(node)
        dat <- data_party(obj, nid)
        wn <- dat[["(weights)"]]   

        cf <- obj$coef[as.character(nid),c("Hb.prae", "F1.prae", 
                                           "F2.prae", "F13.Akt.prae")]
        cf <- matrix(round(exp(cf), 3), nrow = 1)
        # cf <- rbind(cf, obj$ci[as.character(nid),])
        rownames(cf) <- c("OR")#, "CI")
        colnames(cf) <- c("Hb.prae", "F1.prae", "F2.prae", "F13.Akt.prae")
        colnames(cf) <- c("hemoglobin", "F. I", "F. II", "F. XIII")

        top_vp <- viewport(layout = grid.layout(nrow = 1, ncol = 2,
                           widths = unit(c(1, ylines), c("null", "lines")),
                           heights = unit(1, "null")),
                           width = unit(1, "npc"),
                           height = unit(1, "npc"), # - unit(2, "lines"),
                           name = paste("node_mlt", nid, sep = ""), gp = gp)

        pushViewport(top_vp)
        grid.rect(gp = gpar(fill = bg, col = 0))

        grid.draw(tableGrob(cf))

        upViewport(1)
    }

    return(rval)
}
class(en) <- "grapcon_generator"

### format confidence intervals
ci <- function(m) {
    cf <- coef(m)
    idx <- 1:length(cf)
    i <- grep("(Intercept)", names(cf))
    if (length(i) > 0)
        idx <- idx[-i]
    cbind(exp(cf)[idx], exp(confint(m)[idx,]))
}

vlab <- function(x) {
    lab <- code$desc_EN[code$varname == x]
    lab <- paste0(toupper(substr(lab, 1, 1)), substr(lab, 2, nchar(lab)))
    paste(lab, " (in ", code$unit[code$varname == x], ")", sep = "")
}

pvar <- function(x)
    paste(paste(x[-length(x)], collapse = ", "), ", and ", x[length(x)], sep = "")


## ----vignette, eval = FALSE---------------------------------------------------
# library("knitr")
# knit("blood_loss_report.Rnw")
# library("tools")
# texi2pdf("blood_loss_report.tex")

## ----preproc, echo = FALSE----------------------------------------------------
x <- c("GA", "AGE", "MULTIPAR", "BMI", "TWIN", "FET.GEW", "IOL", "AIS")
z <- subset(code, type %in% c("confounder", "reason"))$varname
prae <- c("F1.prae", "F2.prae", "Hb.prae", ### "F13.Ag.prae", 
          "F13.Akt.prae") 
          ### "DD.prae")
vars <- c("MBL", prae, z)
blood$mode <- with(blood, SECTIO.prim == "yes" | SECTIO.sek == "yes" |
                     SECTIO.not == "yes") + 1
blood$mode[blood$SECTIO.sek == "yes" | blood$SECTIO.not == "yes"] <- 3
blood$mode <- factor(blood$mode, levels = 1:3,
                     labels = c("Vaginal delivery", "Planned Cesarean", "Unplanned Cesarean"))
blood$VCmode <- blood$mode
levels(blood$VCmode) <- c("Vaginal delivery", "Cesarean Sectio", "Cesarean Sectio")
ct <- table(blood$mode)

## ----table-1, echo = FALSE, results = "asis"----------------------------------
frmtnum <- function(x)
    paste(frmt1(x)[2], " (", paste(frmt1(x)[-2], collapse = "-"), ")", sep = "")
frmtrow <- function(x) {
    if (is.factor(blood[[x]])) return(table(blood[[x]], blood$mode))
    prb <- c(0.25, .5, .75)
    ret <- c(vaginal = frmtnum(quantile(subset(blood, mode == "Vaginal delivery")[[x]], 
                                   prob = prb, na.rm = TRUE)),
             planned = frmtnum(quantile(subset(blood, mode == "Planned Cesarean")[[x]], 
                                   prob = prb, na.rm = TRUE)),
             unplanned = frmtnum(quantile(subset(blood, mode == "Unplanned Cesarean")[[x]], 
                                   prob = prb, na.rm = TRUE)))
    ret <- matrix(ret, nrow = 1)
    rownames(ret) <- "Med (IQR)"
    if (all(!is.na(blood[[x]]))) return(ret)
    ret <- rbind(table(is.na(blood[[x]]), blood$mode)["TRUE",], ret)
    rownames(ret) <- c("missing", "Med (IQR)")
    ret
}
tab <- lapply(vars, frmtrow)
names(tab) <- vars

desc <- code$desc_EN[match(vars, code$varname)]
desc <- rep(desc, sapply(tab, nrow))
desc[dd <- duplicated(desc)] <- ""

unit <- code$unit[match(vars, code$varname)]
unit <- gsub("\\%", "\\\\%", unit)
unit <- gsub("kg/m\\^2", "$\\\\text{kg} / \\\\text{m}^2$", unit)
unit <- rep(unit, sapply(tab, nrow))
unit[dd] <- ""
unit[is.na(unit)] <- ""

xtab <- do.call("rbind", tab)
xtab <- cbind(var = desc, unit = unit, item = rownames(xtab), xtab)

writeLines(paste(xtab[,1], " & ", xtab[,2], "&", xtab[, 3], " & ", xtab[,4],
" & ", xtab[,5], " & ", xtab[,6], " \\\\"))

write.csv(xtab, file = "table_1.csv")


## ----MBL-plot, echo = FALSE, fig.width = 6, fig.height = 5, cache = TRUE, warning = FALSE, dev = c("tiff", "pdf", "png"), dpi = 300----
### unconditional MBL
qy <- 0:max(blood$MBL)
### MBL outcome as interval censored

### interval length: 50 for MBL < 1000; 100 for MBL > 1000
off <- 25
tm1 <- with(blood, ifelse(MBL < 1000, MBL - off, MBL - 2 * off))
tm2 <- with(blood, ifelse(MBL >= 1000, MBL + 2 * off, MBL + off))
### some measurements are more precise, use length 10 here
ex <- !blood$MLB %in% seq(from = 100, to = 6000, by = 50)
stopifnot(sum(ex) == 0)
tm1[ex] <- blood$MBL[ex] - off / 5
tm2[ex] <- blood$MBL[ex] + off / 5
blood$MBLsurv <- Surv(time = tm1, time2 = tm2, type = "interval2")

MBLlim <- c(0, 2700)

nd <- data.frame(mode = sort(unique(blood$mode)))
### takes too long on Windows
if (FALSE) {
plot(m <- as.mlt(Colr(MBLsurv | mode ~ 1, data = blood, order = 15,
                 bounds = c(0, Inf), support = c(250, 2000), 
                 extrapolate = TRUE)), newdata = nd,
     q = qy, type = "distribution", col = cols, lwd = 2, xlim = MBLlim,
     xlab = vlab("MBL"), ylab = "Probability", ylim = c(-.05, 1.05), 
     inset = 10)
rug(blood$MBL[blood$mode == "Vaginal delivery"], lwd = 2, col = cols[1])
rug(blood$MBL[blood$mode == "Planned Cesarean"], side = 3, lwd = 2, col = cols[2])
rug(blood$MBL[blood$mode == "Unplanned Cesarean"], side = 3, lwd = 2, col = cols[3])
legend("bottomright", lwd = 2, col = cols, legend = levels(blood$mode), bty = "n")
}

## ----MBL-plot-check, eval = FALSE, echo = FALSE, fig.width = 6, fig.height = 5, warning = FALSE, dev = c("tiff", "pdf", "png"), dpi = 300----
# plot(survfit(MBLsurv ~ mode, data = blood), col = cols, xlim = c(0, 2700),
#      lty = 2, xlab = vlab("MBL"), ylab = "1 - Probability", ylim = c(-.05, 1.05))
# plot(m, newdata= nd, type = "survivor", add = TRUE, col = cols, lty = 1)
# rug(blood$MBL[blood$mode == "Vaginal delivery"], lwd = 2, col = cols[1])
# rug(blood$MBL[blood$mode == "Planned Cesarean"], side = 3, lwd = 2, col = cols[2])
# rug(blood$MBL[blood$mode == "Unplanned Cesarean"], side = 3, lwd = 2, col = cols[3])
# legend("topright", lwd = 2, col = cols, legend = levels(blood$mode), bty = "n")

## ----MBL-Colr, echo = TRUE, cache = TRUE--------------------------------------
mvars <- c("Hb.prae", "F1.prae", "F2.prae", "F13.Akt.prae")
fm <- paste(mvars, collapse = "+")
### continuous outcome logistic regression
m_MBL <- Colr(as.formula(paste("MBLsurv ~ ", fm)), data = blood, 
              bounds = c(0, Inf), support = c(250, 2000))
### number of observations
sum(complete.cases(model.frame(m_MBL)))
summary(m_MBL)
logLik(m_MBL)

## ----MBL-Colr-ci, echo = TRUE, cache = TRUE-----------------------------------
(ci_all <- ci(m_MBL))

## ----MBL-orm, echo = TRUE-----------------------------------------------------
(m_MBL_orm <- orm(as.formula(paste("MBL ~ ", fm)), data = blood))
### OR and confidence interval for F. XIII 
### (sign of the coefficient is different in rms::orm and tram::Colr)
exp(-coef(m_MBL_orm)["F13.Akt.prae"])
exp(-rev(confint(m_MBL_orm)["F13.Akt.prae",]))

## ----MBL-Colr-Cesar, echo = TRUE, cache = TRUE--------------------------------
m_MBL_C <- Colr(as.formula(paste("MBLsurv | VCmode ~ VCmode:(", fm, ")")), 
                data = blood, bounds = c(0, Inf), support = c(250, 2000))
summary(m_MBL_C)
logLik(m_MBL_C)

## ----MBL-Colr-pre, echo = FALSE, fig.width = 6, fig.height = 5, dev = c("tiff", "pdf", "png"), dpi = 300----
nd <- blood[1,mvars, drop = FALSE]
nd[1,] <- cm <- round(apply(blood[, mvars], 2, median, na.rm = TRUE), 1)
F13 <- seq(from = min(blood$F13.Akt.prae, na.rm = TRUE), 
           to = max(blood$F13.Akt.prae, na.rm = TRUE),
           length = 25)
nd <- nd[rep(1, length(F13)),]
nd[, "F13.Akt.prae"] <- F13
nd$MBLsurv <- 500
X <- model.matrix(as.mlt(m_MBL)$model, data = nd)

cf <- confint(glht(as.mlt(m_MBL), linfct = X))

plot(F13, plogis(cf$confint[, "Estimate"], lower.tail = FALSE), type = "l",
     ylim = c(0, 1), xlab = "Prepartum F. XIII (%)", 
     ylab = expression(paste("Probability PPH (", MBL >= 500, "ml)")))
lwr <- plogis(cf$confint[, "lwr"], lower.tail = FALSE)
upr <-  plogis(cf$confint[, "upr"], lower.tail = FALSE)
polygon(c(F13, rev(F13)), c(lwr, rev(upr)),
        border = NA, col = "lightblue")
lines(F13, plogis(cf$confint[, "Estimate"], lower.tail = FALSE))
rug(blood$F13.Akt.prae, col = rgb(.1, .1, .1, .1))

## ----sample-size, echo = TRUE-------------------------------------------------
blood$PPH <- factor(blood$MBL >= 500, levels = c(FALSE, TRUE), 
                    labels = c("no", "yes"))
summary(m_PPH <- lm(F13.Akt.prae ~ PPH, data = blood))
confint(m_PPH)["PPHyes",]

## ----sample-size-W, echo = TRUE, cache = TRUE---------------------------------
wilcox_test(F13.Akt.prae ~ PPH, data = blood, 
            distribution = approximate(10000), conf.int = TRUE)

## ----MBL-check-1, echo = TRUE, cache = TRUE, warning = FALSE, message = FALSE, results = "hide"----
### Tobit model
tll <- logLik(t_MBL <- Lm(as.formula(paste("MBLsurv ~ ", fm)), 
                          data = blood))
### distribution regression
drll <- logLik(dr_MBL <- Colr(as.formula(paste("MBLsurv | ", fm, "~ 1")), 
                              data = blood, bounds = c(0, Inf), 
                              support = c(250, 2000)))

## ----dr-plot, echo = FALSE, warning = FALSE, dev = c("tiff", "pdf", "png"), dpi = 300----
nd0 <- data.frame("Hb.prae" = 0, "F1.prae" = 0, "F2.prae" = 0, "F13.Akt.prae" = 0)
q <- seq(from = MBLlim[1], to = MBLlim[2], length.out = 200)
p0 <- predict(as.mlt(dr_MBL), newdata = nd0, q = q, type = "trafo")
layout(matrix(1:4, ncol = 2))
for (i in 1:4) {
    nd <- nd0
    nd[[i]] <- 1
    cim <- confint(m_MBL)[i,]
    p <- c(predict(as.mlt(dr_MBL), newdata = nd, q = q, type = "trafo") - p0)
    ylim <- exp(max(abs(c(p[is.finite(p)], cim))) * c(-1, 1))
    cn <- code$desc_EN[code$varname == colnames(nd)[i]]
    plot(q, exp(p), type = "l", main = cn, 
         ylim = ylim, xlab = vlab("MBL"), ylab = expression(exp(beta)))
    polygon(c(-100, 3100, 3100, -100), rep(exp(cim), each = 2),
            border = NA, col = rgb(.1, .1, .1, .1))
    abline(h = exp(coef(m_MBL)[i]), lty = 2)
    abline(h = 1, lty = 1, col = "darkred", lwd = 3)
    rug(blood$MBL, col = rgb(.1, .1, .1, .1))
}

## ----MBL-check-2, echo = FALSE, results = "hide", cache = TRUE, warning = FALSE, message = FALSE----
### Binary logistic regression
lr500 <- glm(as.formula(paste("I(MBL < 500) ~ ", fm)), 
             data = blood, family = binomial())
(ci_500 <- ci(lr500))
lr750 <- glm(as.formula(paste("I(MBL < 750) ~ ", fm)), 
             data = blood, family = binomial())
(ci_750 <- ci(lr750))
lr1000 <- glm(as.formula(paste("I(MBL < 1000) ~ ", fm)), 
              data = blood, family = binomial())
(ci_1000 <- ci(lr1000))

## ----table-2, echo = FALSE, results = "asis"----------------------------------
p_all <- paste("$", format.pval(summary(m_MBL)$test$test$pvalues, eps = 0.001), "$")
p_500 <- paste("$", format.pval(summary(lr500)$coef[-1,4], eps = 0.001), "$")
p_750 <- paste("$", format.pval(summary(lr750)$coef[-1,4], eps = 0.001), "$")
p_1000 <- paste("$", format.pval(summary(lr1000)$coef[-1,4], eps = 0.001), "$")
ci_tab <- rbind(cbind(frmt3(ci_all), p_all), 
                cbind(frmt3(ci_500), p_500),
                cbind(frmt3(ci_750), p_750),
                cbind(frmt3(ci_1000), p_1000))
ci_tab <- cbind(c("All", rep("", 3),
                 "500", rep("", 3),
                 "750", rep("", 3),
                 "1000", rep("", 3)), rownames(ci_tab), ci_tab)
writeLines(paste(ci_tab[,1], " & ", ci_tab[,2], " & ",
                 ci_tab[,3], " & ", ci_tab[,4], " & ", ci_tab[,5], " & ", ci_tab[,6], " \\\\"))
write.csv(ci_tab, file = "table_2.csv")

## ----table-3, echo = FALSE, results = "asis"----------------------------------
ci_tab <- cbind(frmt3(ci(m_MBL_C)), format.pval(summary(m_MBL_C)$test$test$pvalues, eps = 0.001))
ci_tab <- cbind(names(coef(m_MBL_C)), ci_tab)
writeLines(paste(ci_tab[,1], " & ", ci_tab[,2], " & ",
                 ci_tab[,3], " & ", ci_tab[,4], " & ", ci_tab[,5], " \\\\"))
write.csv(ci_tab, file = "table_3.csv")

## ----MBL-xtree, echo = FALSE, cache = TRUE, fig.width = 12.25, fig.height = 4.5, dev = c("tiff", "pdf", "png"), dpi = 300----
### partitioning
xfm <- paste(x, collapse = "+")
zfm <- paste(z, collapse = "+")

xfm_MBL <- as.formula(paste("MBLsurv ~ ", fm, "|", xfm))
zfm_MBL <- as.formula(paste("MBLsurv ~ ", fm, "|", zfm))

blood$DAUER.ap[is.na(blood$DAUER.ap)] <- 0

yfm <- as.formula(paste("MBLsurv ~ ", fm))
xMBL_cc <- complete.cases(blood[, all.vars(yfm)])
zMBL_cc <- complete.cases(blood[, all.vars(yfm)])

xitr_MBL <- trafotree(as.mlt(m_MBL), formula = xfm_MBL, data = blood[xMBL_cc,], 
                      parm = mvars, control = ctrl)

nodeid <- predict(xitr_MBL, newdata = blood, type = "node")
blood$nd <- factor(nodeid, levels = sort(unique(nodeid)),
                   labels = sort(unique(nodeid)))
m <- Colr(as.formula(paste("MBLsurv | nd ~ nd:(", fm, ")")), 
          data = blood[xMBL_cc,], bounds = c(0, Inf), support = c(250, 2000))
cf <- ci(m)
cf <- formatC(round(cf, 3), digits = 3, format = "f") 
xitr_MBL$ci <- matrix(paste(matrix(cf[,2], ncol = 4), 
                            matrix(cf[,3], ncol = 4), sep = "-"), ncol = 4)
rownames(xitr_MBL$ci) <- levels(blood$nd)
plot(rotate(xitr_MBL), terminal_panel = en)

## ----MBL-extreme, echo = FALSE------------------------------------------------
xn <- tapply(1:nrow(blood), blood$nd, function(i) colMeans(blood[i, mvars], na.rm = TRUE))
nd <- as.data.frame(do.call("rbind", xn))
nd$nd <- sort(unique(blood$nd))
cb <- confband(as.mlt(m), newdata = nd, type = "distribution", 
               K = 500, calpha = univariate_calpha())
### 500
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 500)^2),-1]))))[, c(1, 2, 4, 3)]

## ----MBL-extreme-, echo = FALSE-----------------------------------------------
### 750
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 750)^2),-1]))))[, c(1, 2, 4, 3)]

## ----MBL-extreme-1000, echo = FALSE-------------------------------------------
### 1000
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 1000)^2),-1]))))[, c(1, 2, 4, 3)]

## ----MBL-extreme-50, echo = FALSE---------------------------------------------
nd50 <- nd
nd50$F13.Akt.prae <- nd50$F13.Akt.prae + 50
cb <- confband(as.mlt(m), newdata = nd50, type = "distribution", 
               K = 500, calpha = univariate_calpha())
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 500)^2),-1]))))[, c(1, 2, 4, 3)]

## ----MBL-extreme-50-750, echo = FALSE-----------------------------------------
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 750)^2),-1]))))[, c(1, 2, 4, 3)]

## ----MBL-extreme-50-1000, echo = FALSE----------------------------------------
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 1000)^2),-1]))))[, c(1, 2, 4, 3)]

## ----F13-trt, echo = FALSE, results = "hide", dev = c("tiff", "pdf", "png"), dpi = 300----
nd <- nd[rep(1:nrow(nd), 2),]
nd$type <- gl(2, nrow(nd) / 2, labels = c("prepartum F. XIII", "prepartum F. XIII + 50 units"))
nd$F13.Akt.prae <- nd$F13.Akt.prae + c(0, 50)[nd$type]
nd$med <- c(predict(as.mlt(m), newdata = nd, type = "quantile", prob = .5))
nd$MBL1000 <- (1 - c(predict(as.mlt(m), newdata = nd, type = "distribution", q = 1000))) * 100
print(nd)
qy <- 2:2000 
p <- predict(as.mlt(m), newdata = nd, type = "distribution", q = qy)
nd <- nd[rep(1:nrow(nd), each = length(qy)),]
nd$MBL <- rep(qy, nrow(nd) / length(qy))
nd$p <- c(p)
key <- simpleKey(levels(nd$type), points = FALSE, lines = TRUE,
                 space = "top", lty = 1)
key$lines$col <- cols2 <- tcols[c(1, length(tcols))]
plt <- vector(mode = "list", length = 2)
# plt[[1]] <- plot(rotate(xitr_MBL), terminal_panel = en, pop = FALSE)
pfun <- function(x, y, ...) {
    panel.abline(v = c(500, 750, 1000), col = "lightgrey")
    panel.xyplot(x = x, y = y, ...)
}
levels(nd$nd) <- paste("Subgroup", levels(nd$nd))
plt[[2]] <- xyplot(p ~ MBL | nd, data = nd, groups = type, type = "l", 
       panel = pfun,
       key = key, col = cols2, xlab = vlab("MBL"), ylab = "Probability")
#       layout = matrix(1:nlevels(blood$nd), ncol = 1))
plot(plt[[2]])
# grid.arrange(plt[[1]], plt[[2]], ncol = 2)

## ----MBL-ztree, echo = FALSE, cache = TRUE, fig.width = 12.5, fig.height = 4.5, dev = c("tiff", "pdf", "png"), dpi = 300----
zitr_MBL <- trafotree(as.mlt(m_MBL), formula = zfm_MBL, data = blood[zMBL_cc,], 
                     parm = mvars, control = ctrl)
blood$nd <- factor(predict(zitr_MBL, newdata = blood, type = "node"))
m <- Colr(as.formula(paste("MBLsurv | nd ~ nd:(", fm, ")")), 
          data = blood[zMBL_cc,], bounds = c(0, Inf), support = c(250, 2000))
cf <- ci(m)
cf <- formatC(round(cf, 3), digits = 3, format = "f") 
zitr_MBL$ci <- matrix(paste(matrix(cf[,2], ncol = 4), 
                            matrix(cf[,3], ncol = 4), sep = "-"), ncol = 4)
rownames(zitr_MBL$ci) <- levels(blood$nd)
plot(rotate(zitr_MBL), terminal_panel = en)

## ----session, echo = FALSE----------------------------------------------------
sessionInfo()

## ----setup, results = "hide", echo = FALSE, message = FALSE, warnings = FALSE----
set.seed(290875)

load(system.file("rda", "bloodloss.rda", package = "TH.data"))

### some packages
library("trtf")
library("tram")
library("rms")
library("coin")
library("survival")
library("ATR")
library("multcomp")
library("gridExtra")
library("vcd")
library("colorspace")
library("lattice")
tcols <- diverge_hcl(50, h = c(246, 40), c = 96, l = c(65, 90), alpha = .5)
cols <- qualitative_hcl(3, palette = "Harmonic")
vR <- paste(R.Version()$major, R.Version()$minor, sep = ".")
vtram <- packageDescription("tram")$Version
vtrtf <- packageDescription("trtf")$Version
### plot setup
trellis.par.set(list(plot.symbol = list(col="black", cex = .75),
                     box.rectangle = list(col=1),
                     box.umbrella = list(lty=1, col=1),
                     strip.background = list(col = "white")))
ltheme <- canonical.theme(color = FALSE)     ## in-built B&W theme
ltheme$strip.background$col <- "transparent" ## change strip bg
lattice.options(default.theme = ltheme)

frmt1 <- function(x) formatC(round(x, 1), digits = 1, format = "f") 
frmt3 <- function(x) {
    if (!is.numeric(x)) return(x)
    formatC(round(x, 3), digits = 3, format = "f") 
}

### tree plots
ctrl <- ctree_control(alpha = 0.05, minbucket = 50,
                      teststat = "max", splitstat = "max", maxsurrogate = 3)

en <- function(obj, col = "black", bg = "white", fill = "transparent",
                     ylines = 2, id = TRUE, mainlab = NULL, gp = gpar(), K = 20,
                     type = c("trafo", "distribution", "survivor",  
                              "density", "logdensity", "hazard",
                              "loghazard", "cumhazard", "quantile"),
                     flip = FALSE, axes = TRUE, xaxis = NULL, ...)
{

    ### panel function for ecdf in nodes
    rval <- function(node) {

        nid <- id_node(node)
        dat <- data_party(obj, nid)
        wn <- dat[["(weights)"]]   

        cf <- obj$coef[as.character(nid),c("Hb.prae", "F1.prae", 
                                           "F2.prae", "F13.Akt.prae")]
        cf <- matrix(round(exp(cf), 3), nrow = 1)
        # cf <- rbind(cf, obj$ci[as.character(nid),])
        rownames(cf) <- c("OR")#, "CI")
        colnames(cf) <- c("Hb.prae", "F1.prae", "F2.prae", "F13.Akt.prae")
        colnames(cf) <- c("hemoglobin", "F. I", "F. II", "F. XIII")

        top_vp <- viewport(layout = grid.layout(nrow = 1, ncol = 2,
                           widths = unit(c(1, ylines), c("null", "lines")),
                           heights = unit(1, "null")),
                           width = unit(1, "npc"),
                           height = unit(1, "npc"), # - unit(2, "lines"),
                           name = paste("node_mlt", nid, sep = ""), gp = gp)

        pushViewport(top_vp)
        grid.rect(gp = gpar(fill = bg, col = 0))

        grid.draw(tableGrob(cf))

        upViewport(1)
    }

    return(rval)
}
class(en) <- "grapcon_generator"

### format confidence intervals
ci <- function(m) {
    cf <- coef(m)
    idx <- 1:length(cf)
    i <- grep("(Intercept)", names(cf))
    if (length(i) > 0)
        idx <- idx[-i]
    cbind(exp(cf)[idx], exp(confint(m)[idx,]))
}

vlab <- function(x) {
    lab <- code$desc_EN[code$varname == x]
    lab <- paste0(toupper(substr(lab, 1, 1)), substr(lab, 2, nchar(lab)))
    paste(lab, " (in ", code$unit[code$varname == x], ")", sep = "")
}

pvar <- function(x)
    paste(paste(x[-length(x)], collapse = ", "), ", and ", x[length(x)], sep = "")


## ----vignette, eval = FALSE---------------------------------------------------
# library("knitr")
# knit("blood_loss_report.Rnw")
# library("tools")
# texi2pdf("blood_loss_report.tex")

## ----preproc, echo = FALSE----------------------------------------------------
x <- c("GA", "AGE", "MULTIPAR", "BMI", "TWIN", "FET.GEW", "IOL", "AIS")
z <- subset(code, type %in% c("confounder", "reason"))$varname
prae <- c("F1.prae", "F2.prae", "Hb.prae", ### "F13.Ag.prae", 
          "F13.Akt.prae") 
          ### "DD.prae")
vars <- c("MBL", prae, z)
blood$mode <- with(blood, SECTIO.prim == "yes" | SECTIO.sek == "yes" |
                     SECTIO.not == "yes") + 1
blood$mode[blood$SECTIO.sek == "yes" | blood$SECTIO.not == "yes"] <- 3
blood$mode <- factor(blood$mode, levels = 1:3,
                     labels = c("Vaginal delivery", "Planned Cesarean", "Unplanned Cesarean"))
blood$VCmode <- blood$mode
levels(blood$VCmode) <- c("Vaginal delivery", "Cesarean Sectio", "Cesarean Sectio")
ct <- table(blood$mode)

## ----table-1, echo = FALSE, results = "asis"----------------------------------
frmtnum <- function(x)
    paste(frmt1(x)[2], " (", paste(frmt1(x)[-2], collapse = "-"), ")", sep = "")
frmtrow <- function(x) {
    if (is.factor(blood[[x]])) return(table(blood[[x]], blood$mode))
    prb <- c(0.25, .5, .75)
    ret <- c(vaginal = frmtnum(quantile(subset(blood, mode == "Vaginal delivery")[[x]], 
                                   prob = prb, na.rm = TRUE)),
             planned = frmtnum(quantile(subset(blood, mode == "Planned Cesarean")[[x]], 
                                   prob = prb, na.rm = TRUE)),
             unplanned = frmtnum(quantile(subset(blood, mode == "Unplanned Cesarean")[[x]], 
                                   prob = prb, na.rm = TRUE)))
    ret <- matrix(ret, nrow = 1)
    rownames(ret) <- "Med (IQR)"
    if (all(!is.na(blood[[x]]))) return(ret)
    ret <- rbind(table(is.na(blood[[x]]), blood$mode)["TRUE",], ret)
    rownames(ret) <- c("missing", "Med (IQR)")
    ret
}
tab <- lapply(vars, frmtrow)
names(tab) <- vars

desc <- code$desc_EN[match(vars, code$varname)]
desc <- rep(desc, sapply(tab, nrow))
desc[dd <- duplicated(desc)] <- ""

unit <- code$unit[match(vars, code$varname)]
unit <- gsub("\\%", "\\\\%", unit)
unit <- gsub("kg/m\\^2", "$\\\\text{kg} / \\\\text{m}^2$", unit)
unit <- rep(unit, sapply(tab, nrow))
unit[dd] <- ""
unit[is.na(unit)] <- ""

xtab <- do.call("rbind", tab)
xtab <- cbind(var = desc, unit = unit, item = rownames(xtab), xtab)

writeLines(paste(xtab[,1], " & ", xtab[,2], "&", xtab[, 3], " & ", xtab[,4],
" & ", xtab[,5], " & ", xtab[,6], " \\\\"))

write.csv(xtab, file = "table_1.csv")


## ----MBL-plot, echo = FALSE, fig.width = 6, fig.height = 5, cache = TRUE, warning = FALSE, dev = c("tiff", "pdf", "png"), dpi = 300----
### unconditional MBL
qy <- 0:max(blood$MBL)
### MBL outcome as interval censored

### interval length: 50 for MBL < 1000; 100 for MBL > 1000
off <- 25
tm1 <- with(blood, ifelse(MBL < 1000, MBL - off, MBL - 2 * off))
tm2 <- with(blood, ifelse(MBL >= 1000, MBL + 2 * off, MBL + off))
### some measurements are more precise, use length 10 here
ex <- !blood$MLB %in% seq(from = 100, to = 6000, by = 50)
stopifnot(sum(ex) == 0)
tm1[ex] <- blood$MBL[ex] - off / 5
tm2[ex] <- blood$MBL[ex] + off / 5
blood$MBLsurv <- Surv(time = tm1, time2 = tm2, type = "interval2")

MBLlim <- c(0, 2700)

nd <- data.frame(mode = sort(unique(blood$mode)))
### takes too long on Windows
if (FALSE) {
plot(m <- as.mlt(Colr(MBLsurv | mode ~ 1, data = blood, order = 15,
                 bounds = c(0, Inf), support = c(250, 2000), 
                 extrapolate = TRUE)), newdata = nd,
     q = qy, type = "distribution", col = cols, lwd = 2, xlim = MBLlim,
     xlab = vlab("MBL"), ylab = "Probability", ylim = c(-.05, 1.05), 
     inset = 10)
rug(blood$MBL[blood$mode == "Vaginal delivery"], lwd = 2, col = cols[1])
rug(blood$MBL[blood$mode == "Planned Cesarean"], side = 3, lwd = 2, col = cols[2])
rug(blood$MBL[blood$mode == "Unplanned Cesarean"], side = 3, lwd = 2, col = cols[3])
legend("bottomright", lwd = 2, col = cols, legend = levels(blood$mode), bty = "n")
}

## ----MBL-plot-check, eval = FALSE, echo = FALSE, fig.width = 6, fig.height = 5, warning = FALSE, dev = c("tiff", "pdf", "png"), dpi = 300----
# plot(survfit(MBLsurv ~ mode, data = blood), col = cols, xlim = c(0, 2700),
#      lty = 2, xlab = vlab("MBL"), ylab = "1 - Probability", ylim = c(-.05, 1.05))
# plot(m, newdata= nd, type = "survivor", add = TRUE, col = cols, lty = 1)
# rug(blood$MBL[blood$mode == "Vaginal delivery"], lwd = 2, col = cols[1])
# rug(blood$MBL[blood$mode == "Planned Cesarean"], side = 3, lwd = 2, col = cols[2])
# rug(blood$MBL[blood$mode == "Unplanned Cesarean"], side = 3, lwd = 2, col = cols[3])
# legend("topright", lwd = 2, col = cols, legend = levels(blood$mode), bty = "n")

## ----MBL-Colr, echo = TRUE, cache = TRUE--------------------------------------
mvars <- c("Hb.prae", "F1.prae", "F2.prae", "F13.Akt.prae")
fm <- paste(mvars, collapse = "+")
### continuous outcome logistic regression
m_MBL <- Colr(as.formula(paste("MBLsurv ~ ", fm)), data = blood, 
              bounds = c(0, Inf), support = c(250, 2000))
### number of observations
sum(complete.cases(model.frame(m_MBL)))
summary(m_MBL)
logLik(m_MBL)

## ----MBL-Colr-ci, echo = TRUE, cache = TRUE-----------------------------------
(ci_all <- ci(m_MBL))

## ----MBL-Colr-Cesar, echo = TRUE, cache = TRUE--------------------------------
m_MBL_C <- Colr(as.formula(paste("MBLsurv | VCmode ~ VCmode:(", fm, ")")), 
                data = blood, bounds = c(0, Inf), support = c(250, 2000))
summary(m_MBL_C)
logLik(m_MBL_C)

## ----MBL-Colr-pre, echo = FALSE, fig.width = 6, fig.height = 5, dev = c("tiff", "pdf", "png"), dpi = 300----
nd <- blood[1,mvars, drop = FALSE]
nd[1,] <- cm <- round(apply(blood[, mvars], 2, median, na.rm = TRUE), 1)
F13 <- seq(from = min(blood$F13.Akt.prae, na.rm = TRUE), 
           to = max(blood$F13.Akt.prae, na.rm = TRUE),
           length = 25)
nd <- nd[rep(1, length(F13)),]
nd[, "F13.Akt.prae"] <- F13
nd$MBLsurv <- 500
X <- model.matrix(as.mlt(m_MBL)$model, data = nd)

cf <- confint(glht(as.mlt(m_MBL), linfct = X))

plot(F13, plogis(cf$confint[, "Estimate"], lower.tail = FALSE), type = "l",
     ylim = c(0, 1), xlab = "Prepartum F. XIII (%)", 
     ylab = expression(paste("Probability PPH (", MBL >= 500, "ml)")))
lwr <- plogis(cf$confint[, "lwr"], lower.tail = FALSE)
upr <-  plogis(cf$confint[, "upr"], lower.tail = FALSE)
polygon(c(F13, rev(F13)), c(lwr, rev(upr)),
        border = NA, col = "lightblue")
lines(F13, plogis(cf$confint[, "Estimate"], lower.tail = FALSE))
rug(blood$F13.Akt.prae, col = rgb(.1, .1, .1, .1))

## ----sample-size, echo = TRUE-------------------------------------------------
blood$PPH <- factor(blood$MBL >= 500, levels = c(FALSE, TRUE), 
                    labels = c("no", "yes"))
summary(m_PPH <- lm(F13.Akt.prae ~ PPH, data = blood))
confint(m_PPH)["PPHyes",]

## ----sample-size-W, echo = TRUE, cache = TRUE---------------------------------
wilcox_test(F13.Akt.prae ~ PPH, data = blood, 
            distribution = approximate(10000), conf.int = TRUE)

## ----MBL-check-1, echo = TRUE, cache = TRUE, warning = FALSE, message = FALSE, results = "hide"----
### Tobit model
tll <- logLik(t_MBL <- Lm(as.formula(paste("MBLsurv ~ ", fm)), 
                          data = blood))
### distribution regression
drll <- logLik(dr_MBL <- Colr(as.formula(paste("MBLsurv | ", fm, "~ 1")), 
                              data = blood, bounds = c(0, Inf), 
                              support = c(250, 2000)))

## ----dr-plot, echo = FALSE, warning = FALSE, dev = c("tiff", "pdf", "png"), dpi = 300----
nd0 <- data.frame("Hb.prae" = 0, "F1.prae" = 0, "F2.prae" = 0, "F13.Akt.prae" = 0)
q <- seq(from = MBLlim[1], to = MBLlim[2], length.out = 200)
p0 <- predict(as.mlt(dr_MBL), newdata = nd0, q = q, type = "trafo")
layout(matrix(1:4, ncol = 2))
for (i in 1:4) {
    nd <- nd0
    nd[[i]] <- 1
    cim <- confint(m_MBL)[i,]
    p <- c(predict(as.mlt(dr_MBL), newdata = nd, q = q, type = "trafo") - p0)
    ylim <- exp(max(abs(c(p[is.finite(p)], cim))) * c(-1, 1))
    cn <- code$desc_EN[code$varname == colnames(nd)[i]]
    plot(q, exp(p), type = "l", main = cn, 
         ylim = ylim, xlab = vlab("MBL"), ylab = expression(exp(beta)))
    polygon(c(-100, 3100, 3100, -100), rep(exp(cim), each = 2),
            border = NA, col = rgb(.1, .1, .1, .1))
    abline(h = exp(coef(m_MBL)[i]), lty = 2)
    abline(h = 1, lty = 1, col = "darkred", lwd = 3)
    rug(blood$MBL, col = rgb(.1, .1, .1, .1))
}

## ----MBL-check-2, echo = FALSE, results = "hide", cache = TRUE, warning = FALSE, message = FALSE----
### Binary logistic regression
lr500 <- glm(as.formula(paste("I(MBL < 500) ~ ", fm)), 
             data = blood, family = binomial())
(ci_500 <- ci(lr500))
lr750 <- glm(as.formula(paste("I(MBL < 750) ~ ", fm)), 
             data = blood, family = binomial())
(ci_750 <- ci(lr750))
lr1000 <- glm(as.formula(paste("I(MBL < 1000) ~ ", fm)), 
              data = blood, family = binomial())
(ci_1000 <- ci(lr1000))

## ----table-2, echo = FALSE, results = "asis"----------------------------------
p_all <- paste("$", format.pval(summary(m_MBL)$test$test$pvalues, eps = 0.001), "$")
p_500 <- paste("$", format.pval(summary(lr500)$coef[-1,4], eps = 0.001), "$")
p_750 <- paste("$", format.pval(summary(lr750)$coef[-1,4], eps = 0.001), "$")
p_1000 <- paste("$", format.pval(summary(lr1000)$coef[-1,4], eps = 0.001), "$")
ci_tab <- rbind(cbind(frmt3(ci_all), p_all), 
                cbind(frmt3(ci_500), p_500),
                cbind(frmt3(ci_750), p_750),
                cbind(frmt3(ci_1000), p_1000))
ci_tab <- cbind(c("All", rep("", 3),
                 "500", rep("", 3),
                 "750", rep("", 3),
                 "1000", rep("", 3)), rownames(ci_tab), ci_tab)
writeLines(paste(ci_tab[,1], " & ", ci_tab[,2], " & ",
                 ci_tab[,3], " & ", ci_tab[,4], " & ", ci_tab[,5], " & ", ci_tab[,6], " \\\\"))
write.csv(ci_tab, file = "table_2.csv")

## ----table-3, echo = FALSE, results = "asis"----------------------------------
ci_tab <- cbind(frmt3(ci(m_MBL_C)), format.pval(summary(m_MBL_C)$test$test$pvalues, eps = 0.001))
ci_tab <- cbind(names(coef(m_MBL_C)), ci_tab)
writeLines(paste(ci_tab[,1], " & ", ci_tab[,2], " & ",
                 ci_tab[,3], " & ", ci_tab[,4], " & ", ci_tab[,5], " \\\\"))
write.csv(ci_tab, file = "table_3.csv")

## ----MBL-xtree, echo = FALSE, cache = TRUE, fig.width = 12.25, fig.height = 4.5, dev = c("tiff", "pdf", "png"), dpi = 300----
### partitioning
xfm <- paste(x, collapse = "+")
zfm <- paste(z, collapse = "+")

xfm_MBL <- as.formula(paste("MBLsurv ~ ", fm, "|", xfm))
zfm_MBL <- as.formula(paste("MBLsurv ~ ", fm, "|", zfm))

blood$DAUER.ap[is.na(blood$DAUER.ap)] <- 0

yfm <- as.formula(paste("MBLsurv ~ ", fm))
xMBL_cc <- complete.cases(blood[, all.vars(yfm)])
zMBL_cc <- complete.cases(blood[, all.vars(yfm)])

xitr_MBL <- trafotree(as.mlt(m_MBL), formula = xfm_MBL, data = blood[xMBL_cc,], 
                      parm = mvars, control = ctrl)

nodeid <- predict(xitr_MBL, newdata = blood, type = "node")
blood$nd <- factor(nodeid, levels = sort(unique(nodeid)),
                   labels = sort(unique(nodeid)))
m <- Colr(as.formula(paste("MBLsurv | nd ~ nd:(", fm, ")")), 
          data = blood[xMBL_cc,], bounds = c(0, Inf), support = c(250, 2000))
cf <- ci(m)
cf <- formatC(round(cf, 3), digits = 3, format = "f") 
xitr_MBL$ci <- matrix(paste(matrix(cf[,2], ncol = 4), 
                            matrix(cf[,3], ncol = 4), sep = "-"), ncol = 4)
rownames(xitr_MBL$ci) <- levels(blood$nd)
plot(rotate(xitr_MBL), terminal_panel = en)

## ----MBL-extreme, echo = FALSE------------------------------------------------
xn <- tapply(1:nrow(blood), blood$nd, function(i) colMeans(blood[i, mvars], na.rm = TRUE))
nd <- as.data.frame(do.call("rbind", xn))
nd$nd <- sort(unique(blood$nd))
cb <- confband(as.mlt(m), newdata = nd, type = "distribution", 
               K = 500, calpha = univariate_calpha())
### 500
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 500)^2),-1]))))[, c(1, 2, 4, 3)]

## ----MBL-extreme-, echo = FALSE-----------------------------------------------
### 750
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 750)^2),-1]))))[, c(1, 2, 4, 3)]

## ----MBL-extreme-1000, echo = FALSE-------------------------------------------
### 1000
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 1000)^2),-1]))))[, c(1, 2, 4, 3)]

## ----MBL-extreme-50, echo = FALSE---------------------------------------------
nd50 <- nd
nd50$F13.Akt.prae <- nd50$F13.Akt.prae + 50
cb <- confband(as.mlt(m), newdata = nd50, type = "distribution", 
               K = 500, calpha = univariate_calpha())
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 500)^2),-1]))))[, c(1, 2, 4, 3)]

## ----MBL-extreme-50-750, echo = FALSE-----------------------------------------
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 750)^2),-1]))))[, c(1, 2, 4, 3)]

## ----MBL-extreme-50-1000, echo = FALSE----------------------------------------
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 1000)^2),-1]))))[, c(1, 2, 4, 3)]

## ----F13-trt, echo = FALSE, results = "hide", dev = c("tiff", "pdf", "png"), dpi = 300----
nd <- nd[rep(1:nrow(nd), 2),]
nd$type <- gl(2, nrow(nd) / 2, labels = c("prepartum F. XIII", "prepartum F. XIII + 50 units"))
nd$F13.Akt.prae <- nd$F13.Akt.prae + c(0, 50)[nd$type]
nd$med <- c(predict(as.mlt(m), newdata = nd, type = "quantile", prob = .5))
nd$MBL1000 <- (1 - c(predict(as.mlt(m), newdata = nd, type = "distribution", q = 1000))) * 100
print(nd)
qy <- 2:2000 
p <- predict(as.mlt(m), newdata = nd, type = "distribution", q = qy)
nd <- nd[rep(1:nrow(nd), each = length(qy)),]
nd$MBL <- rep(qy, nrow(nd) / length(qy))
nd$p <- c(p)
key <- simpleKey(levels(nd$type), points = FALSE, lines = TRUE,
                 space = "top", lty = 1)
key$lines$col <- cols2 <- tcols[c(1, length(tcols))]
plt <- vector(mode = "list", length = 2)
# plt[[1]] <- plot(rotate(xitr_MBL), terminal_panel = en, pop = FALSE)
pfun <- function(x, y, ...) {
    panel.abline(v = c(500, 750, 1000), col = "lightgrey")
    panel.xyplot(x = x, y = y, ...)
}
levels(nd$nd) <- paste("Subgroup", levels(nd$nd))
plt[[2]] <- xyplot(p ~ MBL | nd, data = nd, groups = type, type = "l", 
       panel = pfun,
       key = key, col = cols2, xlab = vlab("MBL"), ylab = "Probability")
#       layout = matrix(1:nlevels(blood$nd), ncol = 1))
plot(plt[[2]])
# grid.arrange(plt[[1]], plt[[2]], ncol = 2)

## ----MBL-ztree, echo = FALSE, cache = TRUE, fig.width = 12.5, fig.height = 4.5, dev = c("tiff", "pdf", "png"), dpi = 300----
zitr_MBL <- trafotree(as.mlt(m_MBL), formula = zfm_MBL, data = blood[zMBL_cc,], 
                     parm = mvars, control = ctrl)
blood$nd <- factor(predict(zitr_MBL, newdata = blood, type = "node"))
m <- Colr(as.formula(paste("MBLsurv | nd ~ nd:(", fm, ")")), 
          data = blood[zMBL_cc,], bounds = c(0, Inf), support = c(250, 2000))
cf <- ci(m)
cf <- formatC(round(cf, 3), digits = 3, format = "f") 
zitr_MBL$ci <- matrix(paste(matrix(cf[,2], ncol = 4), 
                            matrix(cf[,3], ncol = 4), sep = "-"), ncol = 4)
rownames(zitr_MBL$ci) <- levels(blood$nd)
plot(rotate(zitr_MBL), terminal_panel = en)

## ----session, echo = FALSE----------------------------------------------------
sessionInfo()

# Funktion for simulating data using makeData.R and fitting models using
# psglmm.R

psglmmSim <- function(nsim, formula, VCVtmp, px, py, s, spp.fe, rho12, var.spp, 
  var.plot, var.ind, var.error, x, family, gf, msel, envir, P.lim) {

  mods <- vector("list", length(rho12) * nsim)
  names(mods) <- rep(rho12, each= nsim)
  warn <- vector("list", length(rho12) * nsim)
  p <- px * py

  for(i in 1: length(rho12)) {
    for(j in 1:nsim) {
      d <- makeData(px, py, s, spp.fe, rho12= rho12[i], var.spp, var.plot, 
        var.ind, var.error, x, family, spatial= TRUE, plot.pred= FALSE, P.lim, 
        envir)
      # List with VCV is set up
      VCV <- lapply(1:length(VCVtmp), function(k) vector("list", 2))
      for(k in 1:length(VCVtmp)) {
        for(l in 1:length(VCVtmp[[k]])) {
          if(unlist(strsplit(VCVtmp[[k]][[l]], ""))[1] == "I") {
            dims <- strsplit(gsub("[I_]{2}([a-z]+)$", "\\1", VCVtmp[[k]][[l]]), 
              "")[[1]]
            dimI <- prod(sapply(1:length(dims), function(m) get(dims[m])))
            VCV[[k]][[l]] <- as(diag(dimI), "dgCMatrix")
          } else VCV[[k]][[l]] <- d[[VCVtmp[[k]][[l]]]]
        }
      }  
      VCV <- lapply(1:length(VCV), 
        function(k) kronecker(VCV[[k]][[1]], VCV[[k]][[2]]))
      names(VCV) <- names(VCVtmp)
      k <- j %% (nsim + 1) + nsim * (i - 1)
      warn.k <- NULL
      fitMod <- function(formula, VCV, data, family, gf, msel, msgs) {
        fit <- try(psglmm(formula= formula, VCV= VCV, data= d$d, family= family,
          gf= gf, msel= msel, msgs= msgs), silent= TRUE)
        return(fit)
      }
      # model is fitted
      m <- withCallingHandlers(fitMod(formula= formula, VCV= VCV, data= d$d, 
        family= family, gf= gf, msel= msel, msgs= FALSE), 
        warning= function(w) {
          warn.k <<- c(warn.k, conditionMessage(w)) # not very elegant!
          invokeRestart("muffleWarning")
        })
      if(inherits(m, "try-error")) {
        tmp <- list("RE"= attr(m, "condition"), "FE"= attr(m, "condition"), 
          "varsel"=attr(m, "condition"))
        mods[[k]] <- tmp
        comp <- "try-error"
        choice <- ""
        pValue <- ""
      } else {
        warn[[k]] <- warn.k # any warning is saved
        mods[[k]]$RE <- try(m$varall, silent= TRUE) # estimated random effects
        mods[[k]]$FE <- try(fixef(m$modorig), silent= TRUE) # estimated fixed effects
        mods[[k]]$varsel <- try(m$varsel, silent= TRUE) # chosen random effect component
        # elements for printing progress are set up
        comp <- if(all(m$varall$Selection == "")) "" else m$varsel$Penalty[1]
        choice <- if(all(m$varall$Selection == "")) "" else m$varall$Selection[m$varall$Selection != ""]
        if(comp == "" && all(m$varall$Variance[1:3] == 0)) comp <- "all zero"
        pValue <- if(all(m$varall$Selection == "")) "" else m$varsel[1, "p (LR)"]
      }
      # progress is printed
      cat(paste("rho=", rho12[i], "    nsim=", j, "    ", Sys.time(), "     ", 
        comp, choice, "     ", pValue, "     l(mods) ", length(mods), "\n"))
    }
  }
  return(list(mods= mods, warnings= warn))
}

# Supporting function for simulations
kron <- function(x, y) list(x= x, y= y)

# See 'simModel11.R' for a short explanation
id <- "13"
mod <- paste("simModel", id, sep= "")

library("lme4")
library("mvtnorm")
library("fields")

source("../R/psglmm.R")
source("../R/psglmmSim.R")
source("../R/makeData.R")
source("../R/makeEnvir.R")

nsim= 100
formula= y ~ spp - 1 + (spp - 1 | plot) + (spp - 1 | plot) + (spp - 1 | plot)
VCVtmp= list("phylogenetic"= kron("I_p", "S"), "spatial"= kron("P", "I_s"), 
  "spatio-phylogenetic"= kron("P", "S"))
gf= c("plot", "plot", "plot")
px= 10
py= 10
s= 4
spp.fe= seq(-2, 2, length.out= s)
rho= seq(0, 0.98, 0.02)
var.spp= 2
var.plot= 2
var.ind= 0
var.error= 0.01
x= FALSE
msel= "DSS"
family= gaussian()
P.lim= 0.1

seeds <- 1:length(rho)
for(i in 1:length(rho)) {
  set.seed(seeds[i])
  cat(paste("seed:", seeds[i], "\n"))
  sims <- psglmmSim(nsim, formula, VCVtmp, px, py, s, spp.fe, rho12= rho[i], 
    var.spp, var.plot, var.ind, var.error, x, family, gf, msel, envir, P.lim)
  save(sims, file= paste("sims/", mod, "_", i, ".Rdata", sep=""))
  cat("Data saved\n")
  rm(sims)
}

\documentclass[12pt]{article}

%\VignetteEngine{knitr::knitr}
%\VignetteIndexEntry{bloodloss}
%\VignetteDepends{trtf, tram, rms, coin, survival, ATR, multcomp, gridExtra, vcd, colorspace, lattice}

\title{Statistical Supplementary Material: 
The Impact of Prepartum Factor XIII
Activity on Postpartum Blood Loss}
\author{Christian Haslinger, Wolfgang Korte, Torsten Hothorn, \\
        Romana Brun, Charles Greenberg, Roland Zimmermann}
\date{Processed and Typeset: \today}

\usepackage[utf8]{inputenc}

\usepackage[round]{natbib}
\usepackage{booktabs} 
\usepackage{dcolumn}
\usepackage{rotating}
\usepackage{amstext}
\usepackage{hyperref}
\usepackage{nicefrac}
\usepackage[a4paper,left=3cm,right=2cm,top=2.5cm,bottom=2.5cm]{geometry}

\begin{document}


<<setup, results = "hide", echo = FALSE, message = FALSE, warnings = FALSE>>=
set.seed(290875)

load(system.file("rda", "bloodloss.rda", package = "TH.data"))

### some packages
library("trtf")
library("tram")
library("rms")
library("coin")
library("survival")
library("ATR")
library("multcomp")
library("gridExtra")
library("vcd")
library("colorspace")
library("lattice")
tcols <- diverge_hcl(50, h = c(246, 40), c = 96, l = c(65, 90), alpha = .5)
cols <- qualitative_hcl(3, palette = "Harmonic")
vR <- paste(R.Version()$major, R.Version()$minor, sep = ".")
vtram <- packageDescription("tram")$Version
vtrtf <- packageDescription("trtf")$Version
### plot setup
trellis.par.set(list(plot.symbol = list(col="black", cex = .75),
                     box.rectangle = list(col=1),
                     box.umbrella = list(lty=1, col=1),
                     strip.background = list(col = "white")))
ltheme <- canonical.theme(color = FALSE)     ## in-built B&W theme
ltheme$strip.background$col <- "transparent" ## change strip bg
lattice.options(default.theme = ltheme)

frmt1 <- function(x) formatC(round(x, 1), digits = 1, format = "f") 
frmt3 <- function(x) {
    if (!is.numeric(x)) return(x)
    formatC(round(x, 3), digits = 3, format = "f") 
}

### tree plots
ctrl <- ctree_control(alpha = 0.05, minbucket = 50,
                      teststat = "max", splitstat = "max", maxsurrogate = 3)

en <- function(obj, col = "black", bg = "white", fill = "transparent",
                     ylines = 2, id = TRUE, mainlab = NULL, gp = gpar(), K = 20,
                     type = c("trafo", "distribution", "survivor",  
                              "density", "logdensity", "hazard",
                              "loghazard", "cumhazard", "quantile"),
                     flip = FALSE, axes = TRUE, xaxis = NULL, ...)
{

    ### panel function for ecdf in nodes
    rval <- function(node) {

        nid <- id_node(node)
        dat <- data_party(obj, nid)
        wn <- dat[["(weights)"]]   

        cf <- obj$coef[as.character(nid),c("Hb.prae", "F1.prae", 
                                           "F2.prae", "F13.Akt.prae")]
        cf <- matrix(round(exp(cf), 3), nrow = 1)
        # cf <- rbind(cf, obj$ci[as.character(nid),])
        rownames(cf) <- c("OR")#, "CI")
        colnames(cf) <- c("Hb.prae", "F1.prae", "F2.prae", "F13.Akt.prae")
        colnames(cf) <- c("hemoglobin", "F. I", "F. II", "F. XIII")

        top_vp <- viewport(layout = grid.layout(nrow = 1, ncol = 2,
                           widths = unit(c(1, ylines), c("null", "lines")),
                           heights = unit(1, "null")),
                           width = unit(1, "npc"),
                           height = unit(1, "npc"), # - unit(2, "lines"),
                           name = paste("node_mlt", nid, sep = ""), gp = gp)

        pushViewport(top_vp)
        grid.rect(gp = gpar(fill = bg, col = 0))

        grid.draw(tableGrob(cf))

        upViewport(1)
    }

    return(rval)
}
class(en) <- "grapcon_generator"

### format confidence intervals
ci <- function(m) {
    cf <- coef(m)
    idx <- 1:length(cf)
    i <- grep("(Intercept)", names(cf))
    if (length(i) > 0)
        idx <- idx[-i]
    cbind(exp(cf)[idx], exp(confint(m)[idx,]))
}

vlab <- function(x) {
    lab <- code$desc_EN[code$varname == x]
    lab <- paste0(toupper(substr(lab, 1, 1)), substr(lab, 2, nchar(lab)))
    paste(lab, " (in ", code$unit[code$varname == x], ")", sep = "")
}

pvar <- function(x)
    paste(paste(x[-length(x)], collapse = ", "), ", and ", x[length(x)], sep = "")

@

\maketitle

This dynamic document contains the patient-level data as well as
computer source codes for the reproduction of tables and figures presented
in the manuscript ``The Impact of Prepartum Factor XIII
Activity on Postpartum Blood Loss'' \citep{Haslinger_Korte_Hothorn_2020}. 
This document is described as supplementary in the main publication,
unfortunately, the publisher was unable to provide access to this document
through their system.

The source file \texttt{blood\_loss\_report.Rnw} can be
processed in the \textsf{R} system via
<<vignette, eval = FALSE>>=
library("knitr")
knit("blood_loss_report.Rnw")
library("tools")
texi2pdf("blood_loss_report.tex")
@

\section{Maternal Characteristics}

The baseline distribution of variables are in Table~\ref{tab-1}. For 
measured blood loss, the unconditional distributions
stratified by mode of delivery are depicted in Figure~\ref{fig:MBL_unc} (a
model-based analysis) and Figure~\ref{fig:MBL_turnbull} (a non-parametric analysis).

<<preproc, echo = FALSE>>=
x <- c("GA", "AGE", "MULTIPAR", "BMI", "TWIN", "FET.GEW", "IOL", "AIS")
z <- subset(code, type %in% c("confounder", "reason"))$varname
prae <- c("F1.prae", "F2.prae", "Hb.prae", ### "F13.Ag.prae", 
          "F13.Akt.prae") 
          ### "DD.prae")
vars <- c("MBL", prae, z)
blood$mode <- with(blood, SECTIO.prim == "yes" | SECTIO.sek == "yes" |
                     SECTIO.not == "yes") + 1
blood$mode[blood$SECTIO.sek == "yes" | blood$SECTIO.not == "yes"] <- 3
blood$mode <- factor(blood$mode, levels = 1:3,
                     labels = c("Vaginal delivery", "Planned Cesarean", "Unplanned Cesarean"))
blood$VCmode <- blood$mode
levels(blood$VCmode) <- c("Vaginal delivery", "Cesarean Sectio", "Cesarean Sectio")
ct <- table(blood$mode)
@

\begin{table}
\tiny
\begin{tabular}{lllrrr}
Variable & & & Vaginal delivery ($\Sexpr{ct["Vaginal delivery"]}$) & Planned Cesarean ($\Sexpr{ct["Planned Cesarean"]}$) & Unplanned Cesarean ($\Sexpr{ct["Unplanned Cesarean"]}$)  \\ \hline
<<table-1, echo = FALSE, results = "asis">>=
frmtnum <- function(x)
    paste(frmt1(x)[2], " (", paste(frmt1(x)[-2], collapse = "-"), ")", sep = "")
frmtrow <- function(x) {
    if (is.factor(blood[[x]])) return(table(blood[[x]], blood$mode))
    prb <- c(0.25, .5, .75)
    ret <- c(vaginal = frmtnum(quantile(subset(blood, mode == "Vaginal delivery")[[x]], 
                                   prob = prb, na.rm = TRUE)),
             planned = frmtnum(quantile(subset(blood, mode == "Planned Cesarean")[[x]], 
                                   prob = prb, na.rm = TRUE)),
             unplanned = frmtnum(quantile(subset(blood, mode == "Unplanned Cesarean")[[x]], 
                                   prob = prb, na.rm = TRUE)))
    ret <- matrix(ret, nrow = 1)
    rownames(ret) <- "Med (IQR)"
    if (all(!is.na(blood[[x]]))) return(ret)
    ret <- rbind(table(is.na(blood[[x]]), blood$mode)["TRUE",], ret)
    rownames(ret) <- c("missing", "Med (IQR)")
    ret
}
tab <- lapply(vars, frmtrow)
names(tab) <- vars

desc <- code$desc_EN[match(vars, code$varname)]
desc <- rep(desc, sapply(tab, nrow))
desc[dd <- duplicated(desc)] <- ""

unit <- code$unit[match(vars, code$varname)]
unit <- gsub("\\%", "\\\\%", unit)
unit <- gsub("kg/m\\^2", "$\\\\text{kg} / \\\\text{m}^2$", unit)
unit <- rep(unit, sapply(tab, nrow))
unit[dd] <- ""
unit[is.na(unit)] <- ""

xtab <- do.call("rbind", tab)
xtab <- cbind(var = desc, unit = unit, item = rownames(xtab), xtab)

writeLines(paste(xtab[,1], " & ", xtab[,2], "&", xtab[, 3], " & ", xtab[,4],
" & ", xtab[,5], " & ", xtab[,6], " \\\\"))

write.csv(xtab, file = "table_1.csv")

@
\end{tabular}
\caption{Distribution of feto-maternal and perinatal characteristics,
         stratified by mode of delivery. \label{tab-1}}
\end{table}

\begin{figure}[t]
\includegraphics{MBL-plot-1}
<<MBL-plot, echo = FALSE, fig.width = 6, fig.height = 5, cache = TRUE, warning = FALSE, dev = c("tiff", "pdf", "png"), dpi = 300>>=
### unconditional MBL
qy <- 0:max(blood$MBL)
### MBL outcome as interval censored

### interval length: 50 for MBL < 1000; 100 for MBL > 1000
off <- 25
tm1 <- with(blood, ifelse(MBL < 1000, MBL - off, MBL - 2 * off))
tm2 <- with(blood, ifelse(MBL >= 1000, MBL + 2 * off, MBL + off))
### some measurements are more precise, use length 10 here
ex <- !blood$MLB %in% seq(from = 100, to = 6000, by = 50)
stopifnot(sum(ex) == 0)
tm1[ex] <- blood$MBL[ex] - off / 5
tm2[ex] <- blood$MBL[ex] + off / 5
blood$MBLsurv <- Surv(time = tm1, time2 = tm2, type = "interval2")

MBLlim <- c(0, 2700)

nd <- data.frame(mode = sort(unique(blood$mode)))
### takes too long on Windows
if (FALSE) {
plot(m <- as.mlt(Colr(MBLsurv | mode ~ 1, data = blood, order = 15,
                 bounds = c(0, Inf), support = c(250, 2000), 
                 extrapolate = TRUE)), newdata = nd,
     q = qy, type = "distribution", col = cols, lwd = 2, xlim = MBLlim,
     xlab = vlab("MBL"), ylab = "Probability", ylim = c(-.05, 1.05), 
     inset = 10)
rug(blood$MBL[blood$mode == "Vaginal delivery"], lwd = 2, col = cols[1])
rug(blood$MBL[blood$mode == "Planned Cesarean"], side = 3, lwd = 2, col = cols[2])
rug(blood$MBL[blood$mode == "Unplanned Cesarean"], side = 3, lwd = 2, col = cols[3])
legend("bottomright", lwd = 2, col = cols, legend = levels(blood$mode), bty = "n")
}
@
\caption{Measured blood loss: Distribution of measured blood loss stratified by mode of delivery.
         Rugs indicate measured blood loss
         observations. One vaginal delivery with \Sexpr{max(blood$MBL)} ml blood loss not
         shown. \label{fig:MBL_unc}}
\end{figure}

\begin{figure}[t]
\includegraphics{MBL-plot-check-1}
<<MBL-plot-check, eval = FALSE, echo = FALSE, fig.width = 6, fig.height = 5, warning = FALSE, dev = c("tiff", "pdf", "png"), dpi = 300>>=
plot(survfit(MBLsurv ~ mode, data = blood), col = cols, xlim = c(0, 2700), 
     lty = 2, xlab = vlab("MBL"), ylab = "1 - Probability", ylim = c(-.05, 1.05))
plot(m, newdata= nd, type = "survivor", add = TRUE, col = cols, lty = 1)
rug(blood$MBL[blood$mode == "Vaginal delivery"], lwd = 2, col = cols[1])
rug(blood$MBL[blood$mode == "Planned Cesarean"], side = 3, lwd = 2, col = cols[2])
rug(blood$MBL[blood$mode == "Unplanned Cesarean"], side = 3, lwd = 2, col = cols[3])
legend("topright", lwd = 2, col = cols, legend = levels(blood$mode), bty = "n")
@
\caption{Measured blood loss: Comparison of model-based distribution estimation
(solid lines, Fig.~\ref{fig:MBL_unc}) and the non-parametric Turnbull estimator
(dashed lines) for interval-censored responses; stratified by mode of
delivery. One vaginal delivery with \Sexpr{max(blood$MBL)} ml blood loss not
         shown. \label{fig:MBL_turnbull}}
\end{figure}

\section{Statistical Analysis}

\subsection{Sample Size Calculation}

For sample size calculation, a case-control design was assumed.  In a
previous study, F.~XIII activity prior to delivery was $83$ IU/dL \citep[standard
deviation $24$ IU/dL][]{Sharief_2014}.  Based on the hypothesis that women with 
postpartum hemorrhage (PPH) would
have a mean F.~XIII activity of $<70$ IU/dL, $54$ patients with PPH were needed
to prove this assumption with a statistical power of $80\%$ at a level of
significance of $5\%$ (two-sided $t$-test).  Supposing a PPH-rate of $4.9\%$ 
in our patients, a minimal sample size of $1100$ patients was calculated.

During the first months of the study, it was observed that in several
patients, the 6mL Vacutainer tube was not adequately filled and analysis
would hence have been inaccurate due to incorrect dilution with the
predefined volume of the Na-citrate buffer.  Also, the blood draw was not
performed in time in several patients.  To achieve the required sample size
of $1100$ evaluable patients, we thus decided to increase the enrollment
target to $1500$ patients overall, after repeated approval of the IRB.  In
addition, instructions to the research staff were intensified.  Analysis of
coagulation factors only began after recruitment to the study was completed;
thus, it can be excluded that the increase of the sample size was due to any
kind of interim results.


\subsection{Methods}

The conditional distribution of measured blood loss 
given prepartal hemoglobin (in g/l), F.~I (in g/l), F.~II (in \%), and
F.~XIII (in \%) was estimated by continuous outcome logistic regression
\citep{Lohse_Rohrmann_Faeh_2017,Liu_Shepherd_Li_2017}.  In a first step, all possible binary
logistic regression models for all potential cut-off points measured blood
loss were estimated simultaneously while treating the
regression coefficients as constants and thus applicable to any cut-off point. 
The regression coefficients describe the log-odds ratio and assess the
change induced by a one-unit increase in one of the four prepartal blood
parameters simultaneously for all potential cut-off points.  In more detail,
the model describes the conditional distribution of measured blood loss as
\begin{eqnarray*}
& & \text{Prob}(\text{MBL} \le m \mid x_\text{Hb}, x_\text{F.~I}, x_\text{F.~II},
x_\text{F.~XIII}) = \\
& & \quad \text{logit}^{-1}\left(\alpha(m) +
\beta_\text{Hb} x_\text{Hb} + 
\beta_\text{F.~I} x_\text{F.~I} + 
\beta_\text{F.~II} x_\text{F.~II} + 
\beta_\text{F.~XIII} x_\text{F.~XIII}\right)
\end{eqnarray*}
where $\alpha(m)$ is a cut-off specific non-decreasing intercept function
and $\beta_\text{Hb}, \dots, \beta_\text{F.~XIII}$ are the regression
coefficients for prepartal hemoglobin ($x_\text{Hb}$), F.~I
($x_\text{F.~I}$), F.~II ($x_\text{F.~II}$), and F.~XIII ($x_\text{F.~XIII}$).
These regression coefficients can be interpreted as log-odds ratios
comparing the odds of a patient with an F.~XIII of $x_\text{F.~XIII} + a >
x_\text{F.~XIII}$ 
with the odds of a patient with an F.~XIII of $x_\text{F.~XIII}$:
\begin{eqnarray*}
\nicefrac
{\frac{\text{Prob}(\text{MBL} \le m \mid x_\text{Hb}, x_\text{F.~I}, x_\text{F.~II},
x_\text{F.~XIII} + a)}{1 - \text{Prob}(\text{MBL} \le m \mid x_\text{Hb},
x_\text{F.~I}, x_\text{F.~II},
x_\text{F.~XIII} + a)}}{
\frac{\text{Prob}(\text{MBL} \le m \mid x_\text{Hb}, x_\text{F.~I}, x_\text{F.~II},
x_\text{F.~XIII})}{1 - \text{Prob}(\text{MBL} \le m \mid x_\text{Hb},
x_\text{F.~I}, x_\text{F.~II},
x_\text{F.~XIII})}
} = \exp(\beta_\text{F.~XIII})^a.
\end{eqnarray*}
Thus, positive regression coefficients and corresponding odds ratios larger
than one increase the odds and, consequently, increasing values of F.~XIII
increase the probability of suffering from blood loss less than $m$ (a move
of the conditional distribution of measured blood loss to the left).

In our analysis, measured blood loss was treated as interval censored (with interval length of $50$ ml for
blood losses up to $1000$ ml and $100$ ml for larger blood losses) reflecting the
uncertainty in the actual measurements. The null hypothesis of all
regression coefficients being zero was tested by the likelihood ratio test
(at nominal level $\alpha = 0.05$); $95\%$ Wald-type confidence intervals for odds
ratios are reported without multiplicity adjustment.

In a second step, the impact of potential effect modifiers on the odds
ratios of prepartal blood parameters was assessed
using model-based recursive partitioning
\citep{Zeileis+Hothorn+Hornik:2008}.  Subgroups of patients identified by
feto-maternal and perinatal characteristics were obtained maximising
discrepancies between the regression coefficients of models estimated within
the corresponding subgroups.  Variable selection was performed under
Bonferroni correction.  Subgroup-specific odds ratios are reported.  
All analyses were performed
using the add-on packages \textbf{partykit} \citep{Hothorn_Zeileis_2015} and
\textbf{mlt} \citep{Hothorn_2018_JSS} to the \textsf{R} system for
statistical computing \citep[version \Sexpr{paste(R.version$major,
R.version$minor, sep = ".")},][]{rcore}.

\subsection{Results: Models for Measured Blood Loss}

<<MBL-Colr, echo = TRUE, cache = TRUE>>=
mvars <- c("Hb.prae", "F1.prae", "F2.prae", "F13.Akt.prae")
fm <- paste(mvars, collapse = "+")
### continuous outcome logistic regression
m_MBL <- Colr(as.formula(paste("MBLsurv ~ ", fm)), data = blood, 
              bounds = c(0, Inf), support = c(250, 2000))
### number of observations
sum(complete.cases(model.frame(m_MBL)))
summary(m_MBL)
logLik(m_MBL)
@
The distribution of measured blood loss is affected by prepartal blood
parameters ($\chi^2 = \Sexpr{frmt3(summary(m_MBL)$LRstat)}$, $\text{df} =
\Sexpr{summary(m_MBL)$df}$, $p \Sexpr{format.pval(summary(m_MBL)$p.value, eps =
0.001)})$. Both increasing prepartal F.~II and F.~XIII move the
conditional distribution of measured blood loss to the left (positive
regression coefficients) and thus indicate lower blood loss. For the
corresponding odds ratios, the confidence intervals exclude one:
<<MBL-Colr-ci, echo = TRUE, cache = TRUE>>=
(ci_all <- ci(m_MBL))
@

%%% fails under Windows with
%%%
%%%--- re-building ‘blood_loss_report.Rnw’ using knitr
%%%
%%%fatal Fortran runtime error(/tmp/RtmpLOLCZO/R.INSTALLaccff22fea350/rms/src/ormll.f90:97): Internal error: RUNTIME_CHECK(maskType && maskType->first == TypeCategory::Logical) failed at flang/runtime/transformational.cpp(639)
%%%Aborted
%The same model (although not under interval-censoring, we used the
%raw measurements of blood loss) but with negative log-odds ratios 
%can be estimated as
%<<MBL-orm, echo = TRUE>>=
%(m_MBL_orm <- orm(as.formula(paste("MBL ~ ", fm)), data = blood))
%### OR and confidence interval for F. XIII 
%### (sign of the coefficient is different in rms::orm and tram::Colr)
%exp(-coef(m_MBL_orm)["F13.Akt.prae"])
%exp(-rev(confint(m_MBL_orm)["F13.Akt.prae",]))
%@
%The estimated odds ratio for F.~XIII and it's confidence interval match
%the results reported on above very closely.

The model was furthermore estimated using mode of delivery as stratum. Thus, 
two separate models for vaginal delivery and Cesarean section were
estimated:
<<MBL-Colr-Cesar, echo = TRUE, cache = TRUE>>=
m_MBL_C <- Colr(as.formula(paste("MBLsurv | VCmode ~ VCmode:(", fm, ")")), 
                data = blood, bounds = c(0, Inf), support = c(250, 2000))
summary(m_MBL_C)
logLik(m_MBL_C)
@
For F.~XIII, the estimated log-odds ratios and the corresponding standard
errors are roughly the same for both delivery modes and are very close to
the unstratified analysis. The effect for F.~II seems only present in
Cesarean sections.

\begin{figure}
<<MBL-Colr-pre, echo = FALSE, fig.width = 6, fig.height = 5, dev = c("tiff", "pdf", "png"), dpi = 300>>=
nd <- blood[1,mvars, drop = FALSE]
nd[1,] <- cm <- round(apply(blood[, mvars], 2, median, na.rm = TRUE), 1)
F13 <- seq(from = min(blood$F13.Akt.prae, na.rm = TRUE), 
           to = max(blood$F13.Akt.prae, na.rm = TRUE),
           length = 25)
nd <- nd[rep(1, length(F13)),]
nd[, "F13.Akt.prae"] <- F13
nd$MBLsurv <- 500
X <- model.matrix(as.mlt(m_MBL)$model, data = nd)

cf <- confint(glht(as.mlt(m_MBL), linfct = X))

plot(F13, plogis(cf$confint[, "Estimate"], lower.tail = FALSE), type = "l",
     ylim = c(0, 1), xlab = "Prepartum F. XIII (%)", 
     ylab = expression(paste("Probability PPH (", MBL >= 500, "ml)")))
lwr <- plogis(cf$confint[, "lwr"], lower.tail = FALSE)
upr <-  plogis(cf$confint[, "upr"], lower.tail = FALSE)
polygon(c(F13, rev(F13)), c(lwr, rev(upr)),
        border = NA, col = "lightblue")
lines(F13, plogis(cf$confint[, "Estimate"], lower.tail = FALSE))
rug(blood$F13.Akt.prae, col = rgb(.1, .1, .1, .1))
@
\caption{Prevalence curve of PPH (defined as MBL $\ge$ 500mL) 
         as a function of prepartum F.~XIII for a hypothetical
         subject with prepartum hemoglobin $\Sexpr{cm["Hb.prae"]}$ g/l,
         prepartum F.~I $\Sexpr{cm["F1.prae"]}$ g/l, 
         and prepartum F.II $\Sexpr{cm["F2.prae"]}$\%.
         The blue area represents a $95\%$ confidence band.}
\end{figure}


The sample size planning was performed under choice-based sampling.  The
difference in prepartum F.~XIII was used as effect measure for comparing two
groups of patients (PPH: postpartum hemorrhage, defined as measured blood loss
larger than 500 ml). The one-way analysis of variance matching the sample
size planning is
<<sample-size, echo = TRUE>>=
blood$PPH <- factor(blood$MBL >= 500, levels = c(FALSE, TRUE), 
                    labels = c("no", "yes"))
summary(m_PPH <- lm(F13.Akt.prae ~ PPH, data = blood))
confint(m_PPH)["PPHyes",]
@
and a corresponding Wilcoxon rank sum test reports
<<sample-size-W, echo = TRUE, cache = TRUE>>=
wilcox_test(F13.Akt.prae ~ PPH, data = blood, 
            distribution = approximate(10000), conf.int = TRUE)
@
Patients suffering PPH had, on average, four units less F.~XIII compared to
patients with normal blood loss. It should be noted that logistic regression
allows to estimate odds ratios under choice-based sampling, therefore, the
analysis by continuous outcome logistic regression is also appropriate under
the design applied for sample size planning.



<<MBL-check-1, echo = TRUE, cache = TRUE, warning = FALSE, message = FALSE, results = "hide">>=
### Tobit model
tll <- logLik(t_MBL <- Lm(as.formula(paste("MBLsurv ~ ", fm)), 
                          data = blood))
### distribution regression
drll <- logLik(dr_MBL <- Colr(as.formula(paste("MBLsurv | ", fm, "~ 1")), 
                              data = blood, bounds = c(0, Inf), 
                              support = c(250, 2000)))
@

\begin{figure}[t]
\begin{center}
<<dr-plot, echo = FALSE, warning = FALSE, dev = c("tiff", "pdf", "png"), dpi = 300>>=
nd0 <- data.frame("Hb.prae" = 0, "F1.prae" = 0, "F2.prae" = 0, "F13.Akt.prae" = 0)
q <- seq(from = MBLlim[1], to = MBLlim[2], length.out = 200)
p0 <- predict(as.mlt(dr_MBL), newdata = nd0, q = q, type = "trafo")
layout(matrix(1:4, ncol = 2))
for (i in 1:4) {
    nd <- nd0
    nd[[i]] <- 1
    cim <- confint(m_MBL)[i,]
    p <- c(predict(as.mlt(dr_MBL), newdata = nd, q = q, type = "trafo") - p0)
    ylim <- exp(max(abs(c(p[is.finite(p)], cim))) * c(-1, 1))
    cn <- code$desc_EN[code$varname == colnames(nd)[i]]
    plot(q, exp(p), type = "l", main = cn, 
         ylim = ylim, xlab = vlab("MBL"), ylab = expression(exp(beta)))
    polygon(c(-100, 3100, 3100, -100), rep(exp(cim), each = 2),
            border = NA, col = rgb(.1, .1, .1, .1))
    abline(h = exp(coef(m_MBL)[i]), lty = 2)
    abline(h = 1, lty = 1, col = "darkred", lwd = 3)
    rug(blood$MBL, col = rgb(.1, .1, .1, .1))
}
@
\end{center}
\caption{Measured blood loss: Response-varying regression coefficients (solid curves, on the
odds ratio scale) in the distribution
regression model, separately for each prepartal blood parameter. 
For a given cut-off value $y$ on the x-axis, the line corresponds to the
odds ratio in a binary logistic regression model for the outcome
``measured blood loss $\le y$''. The dashed
lines represent the response-constant regression coefficients (on the
exp-scale) from the continuous outcome logistic regression model, the grey area
depicts the corresponding confidence interval. The thick red line corresponds
to an absent effect (odds ratio one). \label{fig:dr}}
\end{figure}

Continuous outcome logistic regression for measured blood loss was evaluated
by means of comparison against a Tobit model (normal linear regression for
interval-censored response), distribution regression \citep[][simultaneous
estimation of all possible binary logistic regression models without
constant log-odds ratio regression
coefficients]{Foresi_Peracchi_1995,Chernozhukov_2013} and a selection of binary
logistic regression models using the cut-off points $500$ ml, $750$ ml, and
$1000$ ml for measured blood loss. The in-sample log-likelihood for the
continuous outcome logistic regression model ($\Sexpr{frmt3(logLik(m_MBL))}$)
is much larger than the log-likelihood of the Tobit model
($\Sexpr{frmt3(tll)}$) and almost equivalent to the 
log-likelihood ($\Sexpr{frmt3(drll)}$) of the much more flexible distribution regression
model. The response-varying effects from this
distribution regression model are contrasted with the (response-constant)
odds ratios from the continuous outcome logistic regression in
Figure~\ref{fig:dr}. In the relevant domain, the response-varying effects
are covered by the confidence intervals for the response-constant effects.
In summary, continuous outcome logistic regression seems a fair and
interpretable compromise
between the simpler Tobit model assuming conditional normality
for measured blood loss and the distribution regression model allowing
non-constant regression coefficients.

<<MBL-check-2, echo = FALSE, results = "hide", cache = TRUE, warning = FALSE, message = FALSE>>=
### Binary logistic regression
lr500 <- glm(as.formula(paste("I(MBL < 500) ~ ", fm)), 
             data = blood, family = binomial())
(ci_500 <- ci(lr500))
lr750 <- glm(as.formula(paste("I(MBL < 750) ~ ", fm)), 
             data = blood, family = binomial())
(ci_750 <- ci(lr750))
lr1000 <- glm(as.formula(paste("I(MBL < 1000) ~ ", fm)), 
              data = blood, family = binomial())
(ci_1000 <- ci(lr1000))
@

The estimated odds ratios for prepartal F.~II and F.~XIII and also roughly
the corresponding confidence intervals can be reproduced by looking at
binary logistic regression models for selected cut-off points in measured
blood loss. The odds ratios and corresponding confidence intervals for F.~XIII
are roughly constant across the different cut-off points, as could be
expected from the results of distribution regression (Table~\ref{tab-2}).

\begin{table}
\begin{center}
\begin{tabular}{llrrrr}
Cut-off & Parameter & OR & lower & upper & $p$-value \\ \hline
<<table-2, echo = FALSE, results = "asis">>=
p_all <- paste("$", format.pval(summary(m_MBL)$test$test$pvalues, eps = 0.001), "$")
p_500 <- paste("$", format.pval(summary(lr500)$coef[-1,4], eps = 0.001), "$")
p_750 <- paste("$", format.pval(summary(lr750)$coef[-1,4], eps = 0.001), "$")
p_1000 <- paste("$", format.pval(summary(lr1000)$coef[-1,4], eps = 0.001), "$")
ci_tab <- rbind(cbind(frmt3(ci_all), p_all), 
                cbind(frmt3(ci_500), p_500),
                cbind(frmt3(ci_750), p_750),
                cbind(frmt3(ci_1000), p_1000))
ci_tab <- cbind(c("All", rep("", 3),
                 "500", rep("", 3),
                 "750", rep("", 3),
                 "1000", rep("", 3)), rownames(ci_tab), ci_tab)
writeLines(paste(ci_tab[,1], " & ", ci_tab[,2], " & ",
                 ci_tab[,3], " & ", ci_tab[,4], " & ", ci_tab[,5], " & ", ci_tab[,6], " \\\\"))
write.csv(ci_tab, file = "table_2.csv")
@
\end{tabular}
\caption{Odds ratios and corresponding confidence intervals for
         prepartal blood parameters. ``All'' refers to all cut-off points
         simultaneously via continuous outcome logistic regression. \label{tab-2}}
\end{center}
\end{table}


\begin{table}
\begin{center}
\begin{tabular}{lrrrr}
Parameter & OR & lower & upper & $p$-value \\ \hline
<<table-3, echo = FALSE, results = "asis">>=
ci_tab <- cbind(frmt3(ci(m_MBL_C)), format.pval(summary(m_MBL_C)$test$test$pvalues, eps = 0.001))
ci_tab <- cbind(names(coef(m_MBL_C)), ci_tab)
writeLines(paste(ci_tab[,1], " & ", ci_tab[,2], " & ",
                 ci_tab[,3], " & ", ci_tab[,4], " & ", ci_tab[,5], " \\\\"))
write.csv(ci_tab, file = "table_3.csv")
@
\end{tabular}
\caption{Odds ratios and corresponding confidence intervals for
         prepartal blood parameters, stratified by mode of delivery. 
\label{tab-3}}
\end{center}
\end{table}



\clearpage

\subsection{Results: Identification of Effect Modifiers}

In the second step of the analysis, 
the dependency of the regression coefficients for prepartal blood parameters
on two sets of external variables were analysed and are given in
Figures~\ref{fig:MBL-xtree} and \ref{fig:MBL-ztree}.
Figure~\ref{fig:MBL-xtree} depicts the model built on $\Sexpr{length(x)}$ prepartal available variables
(\Sexpr{pvar(code$desc_EN[match(x, code$varname)])}). The
model in Figure~\ref{fig:MBL-ztree} uses all $\Sexpr{length(z)}$ prepartal and
postpartal available variables (\Sexpr{pvar(code$desc_EN[match(z,
code$varname)])}). The model in Figure~\ref{fig:MBL-xtree} indicates that
higher values of F.~XIII correspond to lower blood loss (odds ratio $> 1$
and thus a distribution move to the left) in subgroups 5 and 6. The effect
seems lower for twin births (subgroup 7) and mothers with
low body mass index (subgroup 3). Using all prepartal and postpartal
variables in Figure~\ref{fig:MBL-ztree}, the effect of F.~XIII is most
pronounced in subgroup 4 (spontaneous delivery and not colloids).

\begin{figure}
<<MBL-xtree, echo = FALSE, cache = TRUE, fig.width = 12.25, fig.height = 4.5, dev = c("tiff", "pdf", "png"), dpi = 300>>=
### partitioning
xfm <- paste(x, collapse = "+")
zfm <- paste(z, collapse = "+")

xfm_MBL <- as.formula(paste("MBLsurv ~ ", fm, "|", xfm))
zfm_MBL <- as.formula(paste("MBLsurv ~ ", fm, "|", zfm))

blood$DAUER.ap[is.na(blood$DAUER.ap)] <- 0

yfm <- as.formula(paste("MBLsurv ~ ", fm))
xMBL_cc <- complete.cases(blood[, all.vars(yfm)])
zMBL_cc <- complete.cases(blood[, all.vars(yfm)])

xitr_MBL <- trafotree(as.mlt(m_MBL), formula = xfm_MBL, data = blood[xMBL_cc,], 
                      parm = mvars, control = ctrl)

nodeid <- predict(xitr_MBL, newdata = blood, type = "node")
blood$nd <- factor(nodeid, levels = sort(unique(nodeid)),
                   labels = sort(unique(nodeid)))
m <- Colr(as.formula(paste("MBLsurv | nd ~ nd:(", fm, ")")), 
          data = blood[xMBL_cc,], bounds = c(0, Inf), support = c(250, 2000))
cf <- ci(m)
cf <- formatC(round(cf, 3), digits = 3, format = "f") 
xitr_MBL$ci <- matrix(paste(matrix(cf[,2], ncol = 4), 
                            matrix(cf[,3], ncol = 4), sep = "-"), ncol = 4)
rownames(xitr_MBL$ci) <- levels(blood$nd)
plot(rotate(xitr_MBL), terminal_panel = en)
@
\caption{Measured blood loss: Subgroup model for measured blood loss based
         on prepartal available information. \label{fig:MBL-xtree}}
\end{figure}

From the subgroup model presented in Figure~\ref{fig:MBL-xtree}, the 
probability of measured blood loss $> 500$ ml was estimated for 
each of the four subgroups with a corresponding confidence interval
effects.
<<MBL-extreme, echo = FALSE>>=
xn <- tapply(1:nrow(blood), blood$nd, function(i) colMeans(blood[i, mvars], na.rm = TRUE))
nd <- as.data.frame(do.call("rbind", xn))
nd$nd <- sort(unique(blood$nd))
cb <- confband(as.mlt(m), newdata = nd, type = "distribution", 
               K = 500, calpha = univariate_calpha())
### 500
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 500)^2),-1]))))[, c(1, 2, 4, 3)]
@
For measured blood loss $> 750$ ml, the probabilities change to
<<MBL-extreme-, echo = FALSE>>=
### 750
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 750)^2),-1]))))[, c(1, 2, 4, 3)]
@
and for measured blood loss $> 1000$ ml to
<<MBL-extreme-1000, echo = FALSE>>=
### 1000
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 1000)^2),-1]))))[, c(1, 2, 4, 3)]
@
When a hypothetical increase of F.~XIII by 50 was assumed, these
probabilities reduced to
<<MBL-extreme-50, echo = FALSE>>=
nd50 <- nd
nd50$F13.Akt.prae <- nd50$F13.Akt.prae + 50
cb <- confband(as.mlt(m), newdata = nd50, type = "distribution", 
               K = 500, calpha = univariate_calpha())
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 500)^2),-1]))))[, c(1, 2, 4, 3)]
@
for measured blood loss $> 500$, to
<<MBL-extreme-50-750, echo = FALSE>>=
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 750)^2),-1]))))[, c(1, 2, 4, 3)]
@
for measured blood loss $> 750$, and to
<<MBL-extreme-50-1000, echo = FALSE>>=
data.frame(Subgroup = nd$nd, do.call("rbind", lapply(cb, function(x) 100 * (1 - x[which.min((x[, "q"] - 1000)^2),-1]))))[, c(1, 2, 4, 3)]
@
for measured blood loss $> 1000$. These values can be used as potential treatment
effects in the design of a prospective randomised clinical trial.
The corresponding conditional distribution functions illustrating 
this hypothetical treatment effect are given in Figure~\ref{fig:cdf}.

\begin{figure}
<<F13-trt, echo = FALSE, results = "hide", dev = c("tiff", "pdf", "png"), dpi = 300>>=
nd <- nd[rep(1:nrow(nd), 2),]
nd$type <- gl(2, nrow(nd) / 2, labels = c("prepartum F. XIII", "prepartum F. XIII + 50 units"))
nd$F13.Akt.prae <- nd$F13.Akt.prae + c(0, 50)[nd$type]
nd$med <- c(predict(as.mlt(m), newdata = nd, type = "quantile", prob = .5))
nd$MBL1000 <- (1 - c(predict(as.mlt(m), newdata = nd, type = "distribution", q = 1000))) * 100
print(nd)
qy <- 2:2000 
p <- predict(as.mlt(m), newdata = nd, type = "distribution", q = qy)
nd <- nd[rep(1:nrow(nd), each = length(qy)),]
nd$MBL <- rep(qy, nrow(nd) / length(qy))
nd$p <- c(p)
key <- simpleKey(levels(nd$type), points = FALSE, lines = TRUE,
                 space = "top", lty = 1)
key$lines$col <- cols2 <- tcols[c(1, length(tcols))]
plt <- vector(mode = "list", length = 2)
# plt[[1]] <- plot(rotate(xitr_MBL), terminal_panel = en, pop = FALSE)
pfun <- function(x, y, ...) {
    panel.abline(v = c(500, 750, 1000), col = "lightgrey")
    panel.xyplot(x = x, y = y, ...)
}
levels(nd$nd) <- paste("Subgroup", levels(nd$nd))
plt[[2]] <- xyplot(p ~ MBL | nd, data = nd, groups = type, type = "l", 
       panel = pfun,
       key = key, col = cols2, xlab = vlab("MBL"), ylab = "Probability")
#       layout = matrix(1:nlevels(blood$nd), ncol = 1))
plot(plt[[2]])
# grid.arrange(plt[[1]], plt[[2]], ncol = 2)
@
\caption{Measured blood loss: Conditional distribution of measured blood
loss in the subgroups given in Figure~\ref{fig:MBL-xtree} for original F.~XIII
measurements (blue lines) and under hypothetical treatment (yellow
lines). Vertical grey lines indicate $500$, $750$, and $1000$ ml measured
blood loss. \label{fig:cdf}}
\end{figure}


\begin{figure}[t]
<<MBL-ztree, echo = FALSE, cache = TRUE, fig.width = 12.5, fig.height = 4.5, dev = c("tiff", "pdf", "png"), dpi = 300>>=
zitr_MBL <- trafotree(as.mlt(m_MBL), formula = zfm_MBL, data = blood[zMBL_cc,], 
                     parm = mvars, control = ctrl)
blood$nd <- factor(predict(zitr_MBL, newdata = blood, type = "node"))
m <- Colr(as.formula(paste("MBLsurv | nd ~ nd:(", fm, ")")), 
          data = blood[zMBL_cc,], bounds = c(0, Inf), support = c(250, 2000))
cf <- ci(m)
cf <- formatC(round(cf, 3), digits = 3, format = "f") 
zitr_MBL$ci <- matrix(paste(matrix(cf[,2], ncol = 4), 
                            matrix(cf[,3], ncol = 4), sep = "-"), ncol = 4)
rownames(zitr_MBL$ci) <- levels(blood$nd)
plot(rotate(zitr_MBL), terminal_panel = en)
@
\caption{Measured blood loss: Subgroup model for measured blood loss based
         on prepartal and postpartal available information. \label{fig:MBL-ztree}}
\end{figure}

%\bibliographystyle{plainnat}
%\bibliography{refs}

\clearpage


\begin{thebibliography}{10}
\providecommand{\natexlab}[1]{#1}
\providecommand{\url}[1]{\texttt{#1}}
\expandafter\ifx\csname urlstyle\endcsname\relax
  \providecommand{\doi}[1]{doi: #1}\else
  \providecommand{\doi}{doi: \begingroup \urlstyle{rm}\Url}\fi

\bibitem[Chernozhukov et~al.(2013)Chernozhukov, Fern{\'a}ndez-Val, and
  Melly]{Chernozhukov_2013}
Victor Chernozhukov, Iv{\'a}n Fern{\'a}ndez-Val, and Blaise Melly.
\newblock Inference on counterfactual distributions.
\newblock \emph{Econometrica}, 81\penalty0 (6):\penalty0 2205--2268, 2013.
\newblock \doi{10.3982/ECTA10582}.

\bibitem[Foresi and Peracchi(1995)]{Foresi_Peracchi_1995}
Silverio Foresi and Franco Peracchi.
\newblock The conditional distribution of excess returns: {An} empirical
  analysis.
\newblock \emph{Journal of the American Statistical Association}, 90\penalty0
  (430):\penalty0 451--466, 1995.
\newblock \doi{10.1080/01621459.1995.10476537}.

\bibitem[Haslinger et~al.(2020)Haslinger, Korte, Hothorn, Brun, Greenberg, and
  Zimmermann]{Haslinger_Korte_Hothorn_2020}
Christian Haslinger, Wolfgang Korte, Torsten Hothorn, Romana Brun, Charles
  Greenberg, and Roland Zimmermann.
\newblock The impact of prepartum factor {XIII} activity on postpartum blood
  loss.
\newblock \emph{Journal of Thrombosis and Haemostasis}, 18:\penalty0
  1310--1319, 2020.
\newblock \doi{10.1111/jth.14795}.

\bibitem[Hothorn(2018)]{Hothorn_2018_JSS}
Torsten Hothorn.
\newblock Most likely transformations: The mlt package.
\newblock \emph{Journal of Statistical Software}, 2018.
\newblock URL
  \url{https://cran.r-project.org/web/packages/mlt.docreg/vignettes/mlt.pdf}.
\newblock Accepted 2018-03-05.

\bibitem[Hothorn and Zeileis(2015)]{Hothorn_Zeileis_2015}
Torsten Hothorn and Achim Zeileis.
\newblock {partykit}: A modular toolkit for recursive partytioning in {R}.
\newblock \emph{Journal of Machine Learning Research}, 16:\penalty0 3905--3909,
  2015.
\newblock URL \url{http://jmlr.org/papers/v16/hothorn15a.html}.

\bibitem[Liu et~al.(2017)Liu, Shepherd, Li, and Harrell]{Liu_Shepherd_Li_2017}
Qi~Liu, Bryan~E. Shepherd, Chun Li, and Frank~E. Harrell.
\newblock Modeling continuous response variables using ordinal regression.
\newblock \emph{Statistics in Medicine}, 36\penalty0 (27):\penalty0 4316--4335,
  2017.
\newblock \doi{10.1002/sim.7433}.

\bibitem[Lohse et~al.(2017)Lohse, Rohrmann, Faeh, and
  Hothorn]{Lohse_Rohrmann_Faeh_2017}
Tina Lohse, Sabine Rohrmann, David Faeh, and Torsten Hothorn.
\newblock Continuous outcome logistic regression for analyzing body mass index
  distributions.
\newblock \emph{F1000Research}, 6:\penalty0 1933, 2017.
\newblock \doi{10.12688/f1000research.12934.1}.

\bibitem[{R Core Team}(2019)]{rcore}
{R Core Team}.
\newblock \emph{R: A Language and Environment for Statistical Computing}.
\newblock R Foundation for Statistical Computing, Vienna, Austria, 2019.
\newblock URL \url{https://www.R-project.org/}.

\bibitem[Sharief et~al.(2014)Sharief, Lawrie, Mackie, Smith, Peyvandi, and
  Kadir]{Sharief_2014}
L.~T. Sharief, A.~S. Lawrie, I.~J. Mackie, C.~Smith, F.~Peyvandi, and Rezan~A.
  Kadir.
\newblock Changes in factor {XIII} level during pregnancy.
\newblock \emph{Haemophilia}, 20\penalty0 (2):\penalty0 144--148, 2014.
\newblock \doi{10.1111/hae.12345}.

\bibitem[Zeileis et~al.(2008)Zeileis, Hothorn, and
  Hornik]{Zeileis+Hothorn+Hornik:2008}
Achim Zeileis, Torsten Hothorn, and Kurt Hornik.
\newblock Model-based recursive partitioning.
\newblock \emph{Journal of Computational and Graphical Statistics}, 17\penalty0
  (2):\penalty0 492--514, 2008.
\newblock \doi{10.1198/106186008X319331}.

\end{thebibliography}

\clearpage

\subsection*{Reproducibility (Supplementary Material)}

The results are reproducible by running the
\textsf{R} transcript file \texttt{blood\_loss\_report.R} in the following
environment:
<<session, echo = FALSE>>=
sessionInfo()
@


\end{document}

\name{wpbc}
\alias{wpbc}
\docType{data}
\title{ Wisconsin Prognostic Breast Cancer Data}
\description{

  Each record represents follow-up data for one breast cancer
  case.  These are consecutive patients seen by Dr. Wolberg
  since 1984, and include only those cases exhibiting invasive
  breast cancer and no evidence of distant metastases at the
  time of diagnosis.

}
\usage{data("wpbc")}
\format{
  A data frame with 198 observations on the following 34 variables.
  \describe{
    \item{\code{status}}{a factor with levels \code{N} (nonrecur) and
                         \code{R} (recur)}
    \item{\code{time}}{recurrence time (for \code{status == "R"}) or
                       disease-free time (for \code{status == "N"}). }
    \item{\code{mean_radius}}{radius (mean of distances from center to points on the perimeter) (mean).}
    \item{\code{mean_texture}}{texture (standard deviation of gray-scale values) (mean).}
    \item{\code{mean_perimeter}}{perimeter (mean).}
    \item{\code{mean_area}}{area (mean).}
    \item{\code{mean_smoothness}}{smoothness (local variation in radius lengths) (mean).}
    \item{\code{mean_compactness}}{compactness (mean).}
    \item{\code{mean_concavity}}{concavity (severity of concave portions of the contour) (mean).}
    \item{\code{mean_concavepoints}}{concave points (number of concave portions of the contour) (mean).}
    \item{\code{mean_symmetry}}{symmetry (mean).}
    \item{\code{mean_fractaldim}}{fractal dimension (mean).}
    \item{\code{SE_radius}}{radius (mean of distances from center to points on the perimeter) (SE).}
    \item{\code{SE_texture}}{texture (standard deviation of gray-scale values) (SE).}
    \item{\code{SE_perimeter}}{perimeter (SE).}
    \item{\code{SE_area}}{area (SE).}
    \item{\code{SE_smoothness}}{smoothness (local variation in radius lengths) (SE).}
    \item{\code{SE_compactness}}{compactness (SE).}
    \item{\code{SE_concavity}}{concavity (severity of concave portions of the contour) (SE).}
    \item{\code{SE_concavepoints}}{concave points (number of concave portions of the contour) (SE).}
    \item{\code{SE_symmetry}}{symmetry (SE).}
    \item{\code{SE_fractaldim}}{fractal dimension (SE).}
    \item{\code{worst_radius}}{radius (mean of distances from center to points on the perimeter) (worst).}
    \item{\code{worst_texture}}{texture (standard deviation of gray-scale values) (worst).}
    \item{\code{worst_perimeter}}{perimeter (worst).}
    \item{\code{worst_area}}{area (worst).}
    \item{\code{worst_smoothness}}{smoothness (local variation in radius lengths) (worst).}
    \item{\code{worst_compactness}}{compactness  (worst).}
    \item{\code{worst_concavity}}{concavity (severity of concave portions of the contour) (worst).}
    \item{\code{worst_concavepoints}}{concave points (number of concave portions of the contour) (worst).}
    \item{\code{worst_symmetry}}{symmetry (worst).}
    \item{\code{worst_fractaldim}}{fractal dimension (worst).}
    \item{\code{tsize}}{diameter of the excised tumor in centimeters.}
    \item{\code{pnodes}}{number of positive axillary lymph nodes observed at time of surgery.}
  }
}
\details{

    The first 30 features are computed from a digitized image of a
    fine needle aspirate (FNA) of a breast mass.  They describe
    characteristics of the cell nuclei present in the image.

    There are two possible learning problems: predicting \code{status} or predicting
    the time to recur.

	1) Predicting field 2, outcome: R = recurrent, N = non-recurrent
	- Dataset should first be filtered to reflect a particular
	endpoint; e.g., recurrences before 24 months = positive,
	non-recurrence beyond 24 months = negative.
	- 86.3% accuracy estimated accuracy on 2-year recurrence using
	previous version of this data.

	2) Predicting Time To Recur (field 3 in recurrent records)
	- Estimated mean error 13.9 months using Recurrence Surface
	Approximation.

   The data are originally available from the UCI machine learning repository.

}
\source{

  W. Nick Street, Olvi L. Mangasarian and William H. Wolberg (1995).
  An inductive learning approach to prognostic prediction.
  In A. Prieditis and S. Russell, editors, \emph{Proceedings of the
  Twelfth International Conference on Machine Learning}, pages
  522--530, San Francisco, Morgan Kaufmann.

  Peter Buehlmann and Torsten Hothorn (2007),
  Boosting algorithms: regularization, prediction and model fitting.
  \emph{Statistical Science}, \bold{22}(4), 477--505.

}
\examples{

    data("wpbc", package = "TH.data")

    ### fit logistic regression model 
    coef(glm(status ~ ., data = wpbc[,colnames(wpbc) != "time"],
             family = binomial()))

}
\keyword{datasets}

\name{bodyfat}
\alias{bodyfat}
\docType{data}
\title{ Prediction of Body Fat by Skinfold Thickness, Circumferences, and
        Bone Breadths}
\description{
    For 71 healthy female subjects, body fat measurements and several
    anthropometric measurements are available for predictive modelling
    of body fat.
}
\usage{data("bodyfat")}
\format{
  A data frame with 71 observations on the following 10 variables.
  \describe{
    \item{\code{age}}{age in years.}
    \item{\code{DEXfat}}{body fat measured by DXA, response variable.}
    \item{\code{waistcirc}}{waist circumference.}
    \item{\code{hipcirc}}{hip circumference.}
    \item{\code{elbowbreadth}}{breadth of the elbow.}
    \item{\code{kneebreadth}}{breadth of the knee.}
    \item{\code{anthro3a}}{sum of logarithm of three anthropometric measurements.}
    \item{\code{anthro3b}}{sum of logarithm of three anthropometric measurements.}
    \item{\code{anthro3c}}{sum of logarithm of three anthropometric measurements.}
    \item{\code{anthro4}}{sum of logarithm of three anthropometric measurements.}
  }
}
\details{

  Garcia et al. (2005) report on the development of predictive regression equations
  for body fat content by means of common anthropometric
  measurements which were obtained for 71 healthy German women.
  In addition, the women's body composition was measured by
  Dual Energy X-Ray Absorptiometry (DXA). This reference method
  is very accurate in measuring body fat but finds little applicability
  in practical environments, mainly because of high costs and the
  methodological efforts needed. Therefore, a simple regression equation
  for predicting DXA measurements of body fat is of special interest for the practitioner.
  Backward-elimination was applied to select
  important variables from the available anthropometrical measurements, and
  Garcia (2005) report a final linear model utilizing
  hip circumference, knee breadth and a compound covariate which is defined as
  the sum of log chin skinfold, log triceps skinfold and log subscapular skinfold.

}
\source{

    Ada L. Garcia, Karen Wagner, Torsten Hothorn, Corinna Koebnick,
    Hans-Joachim F. Zunft and Ulrike Trippo (2005),
    Improved prediction of body fat by measuring skinfold
    thickness, circumferences, and bone breadths. \emph{Obesity Research},
    \bold{13}(3), 626--634.

    Peter Buehlmann and Torsten Hothorn (2007),
    Boosting algorithms: regularization, prediction and model fitting.
    \emph{Statistical Science}, \bold{22}(4), 477--505.

    Benjamin Hofner, Andreas Mayr, Nikolay Robinzonov and Matthias Schmid
    (2012). Model-based Boosting in R: A Hands-on Tutorial Using the R
    Package mboost. \emph{Computational Statistics}.\cr
    \doi{10.1007/s00180-012-0382-5}

    Available as vignette via: vignette(package = "mboostDevel", "mboost_tutorial")
}
\examples{

    data("bodyfat", package = "TH.data")

    ### final model proposed by Garcia et al. (2005)
    fmod <- lm(DEXfat ~ hipcirc + anthro3a + kneebreadth, data = bodyfat)
    coef(fmod)

}
\keyword{datasets}

\name{GlaucomaM}
\alias{GlaucomaM}
\non_function{}
\title{ Glaucoma Database }
\usage{data("GlaucomaM")}
\description{
The \code{GlaucomaM} data has 196 observations in two classes. 
62 variables are derived from a confocal laser scanning image of the 
optic nerve head, describing its morphology. Observations are from 
normal and glaucomatous eyes, respectively. 
}
\format{
  This data frame contains the following predictors describing the
  morphology of the optic nerve head and a membership variable:
  \describe{
    \item{ag}{area global.}
    \item{at}{area temporal.}
    \item{as}{area superior.}
    \item{an}{area nasal.}
    \item{ai}{area inferior.}
    \item{eag}{effective area global.}
    \item{eat}{effective area temporal.}
    \item{eas}{effective area superior.}
    \item{ean}{effective area nasal.}
    \item{eai}{effective area inferior.}
    \item{abrg}{area below reference global.}
    \item{abrt}{area below reference temporal.}
    \item{abrs}{area below reference superior.}
    \item{abrn}{area below reference nasal.}
    \item{abri}{area below reference inferior.}
    \item{hic}{height in contour.}
    \item{mhcg}{mean height contour global.}
    \item{mhct}{mean height contour temporal.}
    \item{mhcs}{mean height contour superior.}
    \item{mhcn}{mean height contour nasal.}
    \item{mhci}{mean height contour inferior.}
    \item{phcg}{peak height contour.}
    \item{phct}{peak height contour temporal.}
    \item{phcs}{peak height contour superior.}
    \item{phcn}{peak height contour nasal.}
    \item{phci}{peak height contour inferior.}
    \item{hvc}{height variation contour.}
    \item{vbsg}{volume below surface global.}
    \item{vbst}{volume below surface temporal.}
    \item{vbss}{volume below surface superior.}
    \item{vbsn}{volume below surface nasal.}
    \item{vbsi}{volume below surface inferior.}
    \item{vasg}{volume above surface global.}
    \item{vast}{volume above surface temporal.}
    \item{vass}{volume above surface superior.}
    \item{vasn}{volume above surface nasal.}
    \item{vasi}{volume above surface inferior.}
    \item{vbrg}{volume below reference global.}
    \item{vbrt}{volume below reference temporal.}
    \item{vbrs}{volume below reference superior.}
    \item{vbrn}{volume below reference nasal.}
    \item{vbri}{volume below reference inferior.}
    \item{varg}{volume above reference global.}
    \item{vart}{volume above reference temporal.}
    \item{vars}{volume above reference superior.}
    \item{varn}{volume above reference nasal.}
    \item{vari}{volume above reference inferior.}
    \item{mdg}{mean depth global.}
    \item{mdt}{mean depth temporal.}
    \item{mds}{mean depth superior.}
    \item{mdn}{mean depth nasal.}
    \item{mdi}{mean depth inferior.}
    \item{tmg}{third moment global.}
    \item{tmt}{third moment temporal.}
    \item{tms}{third moment superior.}
    \item{tmn}{third moment nasal.}
    \item{tmi}{third moment inferior.}
    \item{mr}{mean radius.}
    \item{rnf}{retinal nerve fiber thickness.}
    \item{mdic}{mean depth in contour.}
    \item{emd}{effective mean depth.}
    \item{mv}{mean variability.}
    \item{Class}{a factor with levels \code{glaucoma} and \code{normal}.}
  }
}
\details{
  All variables are derived from a laser scanning image of the eye background
taken by the Heidelberg Retina Tomograph. Most of the variables describe
either the area or volume in certain parts of the papilla and are measured
in four sectors (temporal, superior, nasal and inferior) as well as for the
whole papilla (global). The global measurement is, roughly, the sum of the
measurements taken in the four sector.

  The observations in both groups are matched by age and sex to prevent any
bias.
}
\source{
 Torsten Hothorn and Berthold Lausen (2003), Double-Bagging: Combining
classifiers by bootstrap aggregation. \emph{Pattern Recognition},
\bold{36}(6), 1303--1309. 

}
\keyword{datasets}

\name{sphase}
\alias{sphase}
\docType{data}
\title{ S-phase Fraction of Tumor Cells }
\usage{data("sphase")}
\description{
  S-phase fraction of tumor cells in breast cancer patients.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{SPF}{S-phase fraction}
    \item{RFS}{recurrence free survival}
    \item{event}{censoring indicator: \code{FALSE} means censored,
      \code{TRUE} is an event.}
  }
}
\details{

  The data have been used to address the question whether a simple
  cutpoint in S-phase fraction can be used to discriminate between
  patients with good and bad prognosis (for example in Hothorn & Lausen,
  2003).

}
\source{

  J. Pfisterer, F. Kommoss, W. Sauerbrei, D. Menzel, M. Kiechle,
  E. Giese, M. Hilgarth & A. Pfleiderer (1995).
  DNA flow cytometry in node positive breast cancer: Prognostic value
  and correlation to morphological and clinical factors.
  \emph{Analytical and Quantitative Cytology and Histology} \bold{7}(6),
  406--412.

}
\references{

  Torsten Hothorn & Berthold Lausen (2003).
  On the Exact Distribution of Maximally Selected Rank Statistics.
  \emph{Computational Statistics & Data Analysis} \bold{43}(2),
  121--137.

}
\keyword{datasets}

\name{Westbc}
\alias{Westbc}
\docType{data}
\title{ Breast Cancer Gene Expression }
\description{
    Gene expressions for 7129 genes in 49 breast cancer samples and the
    status of lymph node involvement.
}
\usage{data("Westbc")}
\format{
  An list with two elements to be converted to class \code{ExpressionSet} (see package \code{Biobase}).
}
\details{

  A full description of the data
  can be found in West et al. (2001) and an application
  of boosted linear models is given by Buehlmann (2006).

}
\references{

  Peter Buehlmann (2006), Boosting for high-dimensional linear models.
  \emph{The Annals of Statistics}, \bold{34}(2), 559--583.

  Peter Buehlmann and Torsten Hothorn (2007),
  Boosting algorithms: regularization, prediction and model fitting.
  \emph{Statistical Science}, \bold{22}(4), 477--505.

}
\source{
  Mike West, Carrie Blanchette, Holly Dressman, Erich Huang,
  Seiichi Ishida, Rainer Spang, Harry Zuzan, John A. Olson Jr.,
  Jeffrey R. Marks and Joseph R. Nevins (2001),
  Predicting the clinical status of human breast cancer by using
  gene expression profiles, \emph{Proceedings of the National Academy of Sciences},
  \bold{98}, 11462-11467.
}
\examples{

  \dontrun{
    library("Biobase")
    data("Westbc", package = "TH.data")
    westbc <- new("ExpressionSet",
          phenoData = new("AnnotatedDataFrame", data = Westbc$pheno),
          assayData = assayDataNew(exprs = Westbc$assay))
  }
}
\keyword{datasets}

\name{mammoexp}
\alias{mammoexp}
\docType{data}
\title{ Mammography Experience Study }
\description{
  Data from a questionaire on the benefits of mammography.
}
\usage{data(mammoexp)}
\format{
  A data frame with 412 observations on the following 6 variables.
  \describe{
    \item{ME}{Mammograph experience, an ordered factor with 
              levels \code{Never} < \code{Within a Year} < \code{Over a Year}}
    \item{SYMPT}{Agreement with the statement: 
                 `You do not need a mamogram unless you develop symptoms.' 
                 A factor with levels \code{Strongly Agree}, \code{Agree},
                 \code{Disagree} and \code{Strongly Disagree}}
    \item{PB}{Perceived benefit of mammography, the sum of five scaled
              responses, each on a four point scale.
              A low value is indicative of a woman with strong agreement 
              with the benefits of mammography.}
    \item{HIST}{ Mother or Sister with a history 
                 of breast cancer; a factor with levels \code{No} and
                 \code{Yes}.}
    \item{BSE}{Answers to the question: 
               `Has anyone taught you how to examine your own breasts?'
               A factor with levels \code{No} and \code{Yes}. }
    \item{DECT}{Answers to the question: 
                `How likely is it that a mammogram
                could find a new case of breast cancer?'
                An ordered factor with levels \code{Not likely} < 
                \code{Somewhat likely} < \code{Very likely}.}
  }
}
\source{

  Hosmer and Lemeshow (2000). \emph{Applied Logistic Regression}, 2nd
  edition. John Wiley & Sons Inc., New York. Section 8.1.2, page 264.

}
\keyword{datasets}

\name{birds}
\alias{birds}
\docType{data}
\title{ Habitat Suitability for Breeding Bird Communities }
\description{
  Environmental variables and bird counts for identifying
  suitable bird habitats
}
\usage{data("birds")}
\format{
  A data frame with 258 observations on the following 10 variables.
  \describe{
    \item{\code{GST}}{Growing stock per grid}
    \item{\code{DBH}}{Mean diameter of the largest three trees}
    \item{\code{AOT}}{Age of oldest tree}
    \item{\code{AFS}}{Age of forest stand}
    \item{\code{DWC}}{Amount of dead wood of conifers}
    \item{\code{LOG}}{Amount of logs per grid}
    \item{\code{x_gk}}{grid location, x coordinate}
    \item{\code{y_gk}}{grid location, y coordinate}
    \item{\code{SG4}}{observed number of birds from structural gild 4: 
        Requirement of regeneration (Phylloscopus trochilus, Aegithalos caudatus)}
    \item{\code{SG5}}{observed number of birds from structural gild 5:
        Requirement of regeneration combined with planted conifers (Phylloscopus collybita, Turdus
        merula, Sylvia atricapilla).}
  }
}
\details{

Counts of breeding bird
communities collected at 258 observation plots in a northern
Bavarian forest district are the response variable of interest.  
Along with the number of birds in two structural gilds, 
6 covariates are given here and
one is interested in quantifying their impact on habitat
suitability.

}
\source{

 Joerg Mueller (2005).
 Forest structures as key factor for beetle and bird communities 
 in beech forests. PhD thesis, Munich University of Technology.
 
}
\references{

  Thomas Kneib and Joerg Mueller and Torsten Hothorn (2008),
  Spatial smoothing techniques for the assessment of habitat suitability,
  \emph{Environmental and Ecological Statistics}, 
  \bold{15}(3), 343--364.

}
\keyword{datasets}

% original file MASS/man/geyser.Rd
% copyright (C) 1994-2014 W. N. Venables and B. D. Ripley
%
\name{geyser}
\alias{geyser}
\usage{
geyser
}
\title{Old Faithful Geyser Data}
\description{
  A version of the eruptions data from the \sQuote{Old Faithful} geyser
  in Yellowstone National  Park,  Wyoming. This version comes from
  Azzalini and Bowman (1990) and is of continuous measurement from August
  1 to August 15, 1985.

  Some nocturnal duration measurements
  have originally been described as \sQuote{short}, \sQuote{medium}
  or \sQuote{long} and are given as interval censored observations in this
  version of the dataset.
}
\format{A data frame with 299 observations on 2 variables.
  \tabular{lll}{
    \code{duration}  \tab Surv  \tab Eruption time in mins \cr
    \code{waiting}   \tab numeric  \tab Waiting time for this eruption \cr
  }
}
\note{
  Variable \code{duration} was converted to a \code{Surv} object for
  representing interval censored nocturnal observations.
}
\seealso{
  \code{\link{faithful}}, \code{\link[MASS]{geyser}}.
}
\references{
  Azzalini, A. and Bowman, A. W. (1990) A look at some
  data on the Old Faithful geyser.  \emph{Applied Statistics}
  \bold{39}, 357--365.

  Venables, W. N. and Ripley, B. D. (2002)
  \emph{Modern Applied Statistics with S.} Fourth edition.  Springer.

}
\keyword{datasets}

\name{mn6.9}
\alias{mn6.9}
\docType{data}
\title{I.Q. and attitude towards science}
\description{
  Responses given by 2982 New Jersey high-school seniors on 4 questions concerning attitude towards science. Also recorded was whether students had a high or low I.Q. 
}
\usage{data(mn6.9)}
\format{
  A data frame with 2982 observations on the following 5 variables.
  \describe{
    \item{\code{y1}}{Agree=1/disagree=0 to "The development of new ideas is the scientist's greatest source of satisfaction"}
    \item{\code{y2}}{Agree=1/disagree=0 to "Scientists and engineers should be eliminated form the military draft"}
    \item{\code{y3}}{Agree=1/disagree=0 to "The scientist will make his maximum contribution to society when he has freedom to work on problems that interest him"}
    \item{\code{y4}}{Agree=1/disagree=0 to "The monetary compensation of a Nobel Prize-winner in physics should be at least equal to that given to popular entertainers"}
    \item{\code{group}}{I.Q. levels: 1=low, 2=high}
  }
}

\source{
  McCullagh, P. and Nelder, J.A. (1989, p. 239). \emph{Generalized Linear Models}. Second Edition. Chapman & Hall/CRC.  

  copied from multmod package 1.0 (CRAN archive)
}
\keyword{datasets}

\name{GBSG2}
\alias{GBSG2}
\non_function{}
\title{ German Breast Cancer Study Group 2 }
\usage{data("GBSG2")}
\description{
  A data frame containing the observations from the  GBSG2 study.
}
\format{
  This data frame contains the observations of 686 women:
  \describe{
    \item{horTh}{hormonal therapy, a factor at two levels \code{no} and
\code{yes}.}
    \item{age}{of the patients in years.}
    \item{menostat}{menopausal status, a factor at two levels \code{pre} 
(premenopausal) and \code{post} (postmenopausal).}
    \item{tsize}{tumor size (in mm).}
    \item{tgrade}{tumor grade, a ordered factor at levels \code{I < II <
III}.}
    \item{pnodes}{number of positive nodes.}
    \item{progrec}{progesterone receptor (in fmol).}
    \item{estrec}{estrogen receptor (in fmol).}
    \item{time}{recurrence free survival time (in days).}
    \item{cens}{censoring indicator (0- censored, 1- event).}
  }
}
\source{
  W. Sauerbrei and P. Royston (1999). Building multivariable prognostic
  and diagnostic models: transformation of the predictors by using 
  fractional polynomials. \emph{Journal of the Royal Statistics Society
  Series A}, Volume \bold{162}(1), 71--94.
}
\references{
  M. Schumacher, G. Basert, H. Bojar,  K. Huebner, M. Olschewski, 
  W. Sauerbrei, C. Schmoor, C. Beyerle, R.L.A. Neumann and H.F. Rauschecker
  for the German Breast Cancer Study Group (1994),
  Randomized \eqn{2\times2} trial evaluating hormonal treatment
  and the duration of chemotherapy in node-positive breast cancer patients.
  \emph{Journal of Clinical Oncology}, \bold{12}, 2086--2093.
}
\examples{
data(GBSG2)

thsum <- function(x) {
  ret <- c(median(x), quantile(x, 0.25), quantile(x,0.75))
  names(ret)[1] <- "Median"
  ret
}

t(apply(GBSG2[,c("age", "tsize", "pnodes", 
                 "progrec", "estrec")], 2, thsum))

table(GBSG2$menostat)
table(GBSG2$tgrade)
table(GBSG2$horTh)
}
\keyword{datasets}
